
;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Donnees du Noyau ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Segment DonneesNoyauReel

 ;;; Align 4	;;;  Veuiller  conserver l'alignement: insrer des donnes
		;;; l ou il faut, pour aligner.

 ;;; Adresse du serveur XMS
 label	XMS_Server dword
   XMS_S_ofs	dw	?
   XMS_S_Seg	dw	?

 ;; XMS_0B_params	XMS_Move_Params ? ; est-ce utile ?

 ;;; Type de micro-processeur
   TypeCPU	dw	?	; contient le rsultat de TestCPU

 ;;; Adresse du noyau
   HandleNoyau	dw	0	; handle XMS du noyau, 0 si en mmoire
				; conventionnelle
   OffsetNoyau	dd	0	; adresse linaire du noyau, nul si non allou
				; ofs,seg si dans mmoire conventionnelle.

 ;;; Taille du tampon entre mmoire DOS et mmoire tendue en octets
   TailleTampon	dw	4096	; 4 Ko par dfaut, puissance de deux >= 1 Ko


 ;;; Adresse de la ZOT
   HandleZOT	dw	0	; idem pour la ZOT que pour le noyau
   OffsetZOT	dd	0

 ;;; Table globale de descripteurs pour la tche matresse
S_EntreeVide		=	00h	;(S_ comme slecteur)
S_NoyauMemES		=	08h
S_DonneesNoyauMemES	=	10h
S_PileNoyauMemES	=	18h
S_TacheDeCommutation	=	20h
S_PorteServiceNoyauL1	=	28h
S_PorteServiceNoyauL2	=	30h
S_PorteServiceNoyauL3	=	38h
S_NoyauReel		=	40h	; pour le noyau reel, en tant que code
S_DonneesNoyauReel	=	48h	; idem en tant que donnes
S_Tout			=	50h	; toute la mmoire.
S_ZOT			=	58h	; la ZOT

S_TacheActuelle		=	080h
S_LDT_TacheActuelle	=	088h
S_CodeTacheActuelle	=	090h
S_DonneesTacheActuelle	=	098h
S_PileTacheActuelleL0	=	0A0h
S_PileTacheActuelleL1	=	0A8h
S_PileTacheActuelleL2	=	0B0h
S_PileTacheActuelleL3	=	0B8h

 Align 16
 GDTReelle	dq	0		; Slecteur nul: entre vide
  DefDescriptor 0,0,0100b,10011111b	; NoyauMemES
  DefDescriptor 0,0,0100b,10010011b	; DonneesNoyauMemES
  DefDescriptor 0,0,0100b,10010011b	; PileNoyauMemES
  DefDescriptor 0,0,0,11101001b		; TacheDeCommutation
  DefDescriptor 0,S_NoyauMemES,0,10101100b	; PorteServiceNoyauL1
  DefDescriptor 0,S_NoyauMemES,0,11001100b	; PorteServiceNoyauL2
  DefDescriptor 0,S_NoyauMemES,0,11101100b	; PorteServiceNoyauL3
  DefDescriptor 0,0,0000b,10011111b	; NoyauReel
  DefDescriptor 0,0,0000b,10010011b	; DonneesNoyauReel
  DefDescriptor 0,-1,1100b,10010011b	; Tout
  DefDescriptor 0,0,1100b,10010011b	; ZOT
	dq 4 dup (0)			; slecteurs de $60  $7F
  DefDescriptor 0,0,0,11101011b		; TacheActuelle
  DefDescriptor 0,0,0,10000010b		; LDT_TacheActuelle
  DefDescriptor 0,0,0100b,11111111b	; CodeTacheActuelle
  DefDescriptor 0,0,0100b,11110011b     ; DonneesTacheActuelle
  DefDescriptor 0,0,0100b,10010111b     ; PileTacheActuelleL0
  DefDescriptor 0,0,0100b,10110111b     ; PileTacheActuelleL1
  DefDescriptor 0,0,0100b,11010111b     ; PileTacheActuelleL2
  DefDescriptor 0,0,0100b,11110111b     ; PileTacheActuelleL3
	dq 8 dup (0)			; slecteurs de $C0  $FF
 LimiteGDTReelle = 32*8-1		; 32: nombre d'entres



Public TypeCPU,TailleTampon,GDTReelle
Public HandleNoyau,OffsetNoyau,HandleZOT,OffsetZOT

EndS	DonneesNoyauReel


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Code du Noyau ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Segment	NoyauReel

;;;;;;;;;;;;;;;;;;;;;;;;;;;; Interface externe ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Proc	FarToNear	far
; Procdure OSL correspondante: (aucune:utilisation implicite si ncessaire)
; Rsultat : xcute une procdure near  partir d'un appel far.
;	CTLR
; Paramtres :
;	- la pile et les registres doivent contenir les paramtres de la
;	procdure near  appeler.
;	- SS:EBP doit pointer vers une structure:
;	 . adresse (2 octets) pour l'adresse
;	 . champ libre (4 octets) pour l'adresse de retour.
; Restrictions:
;	- BP ne doit pas tre modifi par la routine appele;
;	- la pile est rendue dans l'tat dans lequel la routine near l'a
;	laiss.
	pop	[dwo ss:bp+2]
	call	[ wo ss:bp]
	jmp	[dwo ss:bp+2]
EndP			;;ok

;;;;;;;;;;;;;;;;;;;;;;;;;;;; Entres/sorties ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Proc	DisableAllInts	near
  cli
  ret
  ; ...
  ;; programmer les E/S pour interdire NMI
EndP	DisableAllInts	;;ok
Proc	EnableAllInts	near
  sti
  ret
  ; ...
  ;; reprogrammer les E/S pour autoriser NMI
EndP	EnableAllInts	;;ok

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Mode Protg ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Proc	Protect near
; Procdure OSL correspondante: (aucune:utilisation implicite si ncessaire)
; Rsultat : interdit les interruptions, passe en mode protg avec la TGD
;	GDTReelle, et xcute une procdure passe en paramtre.
;	CTLRS eax,cs:eip,gdtr,cr0
; Paramtres :
;	- GoProtect doit pointer sur la procdure  lancer en mode protg
; Restrictions:
;	  On suppose la ligne A20 active. Si cela peut ne pas tre le cas
;	(si OSL se place en tche de fond), il faudra intgrer pralablement
;	une procdure de sauvegarde et restauration de la ligne A20
   call DisableAllInts
   movzx esp,sp
   mov eax,esp
   mov ax,cs		; segment NoyauReel
   lea eax,[eax*4+GDTReelle]
   push eax
   push LimiteGDTReelle
   LGDT [pword ptr ss:esp]
   mov eax,cr0
   and eax,1ffaffffh	;effacer PG,CD,NW,AM,WP
   or  al,1		;mettre PE
   mov cr0,eax
   db 0eah		;;; jmp far
 GoProtect_o	dw	0
 GoProtect_s	dw	S_NoyauMemES
 ;(les interruptions sont toujours invalides)
EndP	Protect		;;ok
Proc	UnProtect	near
; Procdure OSL correspondante: (aucune:utilisation implicite si ncessaire)
; Rsultat : passe en mode rel, initialise la pile, et xcute une
;	procdure passe en paramtre.
;	  CTLRS eax,cs:eip,ss:sp,cr0
; Paramtres :
;	- GoProtect doit pointer sur la procdure  lancer en mode protg
   mov eax,cr0
   and eax,1ffafffeh ;effacer PE,PG,CD,NW,AM,WP
   mov cr0,eax
   jmp far Unprotect_
 UnProtect_:
   mov ax,cs		;; PileReelle: programme .COM
   mov ss,ax
   ldea sp,SPReel
   call EnableAllInts

   db 0eah			;; jmp far
  GoReal_o	dw	EndOSL
  GoReal_s	dw	?	;  initialiser  NoyauReel
EndP	UnProtect		;;ok


Proc	SetDescrpt	near
; Rsultat : Initialise en descripteur
; Paramtres :
;	- ds:si pointe sur le descripteur,
;	- ebx contient l'adresse de base du segment
;	- ecx contient le champ limite du segment,
;	- ax contient les attributs du segment:
;	  al=P,DPL-,DT,Type; ah=G,D,0,AVL,0000
; Retour :
;	- ax,ebx,ecx sont dtruits
   SetDescriptor ds:si
   ret
EndP	SetDescrpt	;;ok

;;;;;;;;;;;;;;;;;;;;;;;;;; Interface OSLm/DOS ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

proc	DOS_RW		far
; Rsultat: lit ou crit un bloc d'octets dans un fichier DOS, et le
;	transfre vers la mmoire tendue (XMS)
; Paramtres:
;	- bx: numro d'accs du fichier DOS
;	- edi: longueur  lire
;	- esi: position actuelle dans le fichier
;	- cx,edx: numro d'accs du bloc EMB et adresse dans le bloc EMB
;		du tampon d'criture vers le disque
;	- al: 0 pour la lecture, 1 pour l'criture
; Retour:
;	- eax: longueur lue/crite
;	- ebx,ecx,edx,esi,edi,es: indfini
;	- CF=1 ssi erreur
; Restrictions:
;	- il faut ds,ss:NoyauReel
; Notes:
;	- on a suppos que le XMS conservait tous les registres  usage
;	gnral, avec leur parties tendues: eax,ebx,ecx,edx,esi,edi,ebp,esp,
;	cs,ds,es,ss,fs,gs.
;	- on n'a pas test si ax=0 lors du retour de l'appel DOS, dans le
;	cas de la mmoire tendue comme tampon.

   mov ah,al		;; calcule l'appel du DOS
   add ah,3Fh		; 3Fh: lire, 40h: crire
   push ebp		;; sauve: ebp,ds,ax
   setf cx		;; dtermine si on utilise la mmoire tendue
   @if z
 ;;;;;; cas 1: destination=mmoire conventionelle ;;;;;
     push ds
     push ax
     movzx eax,ax
   ;; calculer la longueur pour s'aligner sur le cluster
     mov ecx,7000h
     and si,0FFFh		;modulo 4Ko
     sub cx,si
   ;; prendre adresse buffer huge dans ds:dx, avec si=ds
     mov esi,edx
     movzx edx,dx
     shr esi,16
     ror edx,4
     add si,dx
     shr edx,28
     mov ds,si
   ;; lire/crire le premier bloc
     cmp edi,ecx
     @if nb
       pop ax
       push ax
       int 21h
       jc short DOSRW_dosx
       add ebp,eax
       cmp eax,ecx
       jb short DOSRW_dosx
       add dx,cx
       mov cx,8000h
   ;; lire/crire les blocs suivants
       @while
	 sub edi,ecx
       @do ae
	 pop ax
	 push ax
	 int 21h
	 jc short DOSRW_dosx
	 add ebp,eax
	 cmp eax,ecx
	 jb short DOSRW_dosx
	 add si,800h
	 mov ds,si
       @wend
     @endif
   ;; lire/crire le dernier bloc
     mov cx,di
     @if ncxz
       pop ax
       push ax
       int 21h
       jc short DOSRW_dosx
       add ebp,eax
       cmp eax,ecx
       jb short DOSRW_dosx
     @endif
   DOSRW_dosx:
     pop ax
     mov eax,ebp
     pop ds
     pop ebp
     ret
   @endif
 ;;;;;; cas 2: destination=mmoire tendue ;;;;;
  ;; sauver le code d'appel DOS
   push ax
   push bx
   pop ebp
  ;; initialiser les paramtres de l'appel XMS fonction 0Bh
   clr ax		;  ax:ebx = addr (TamponNoyau)
   mov bx,cs		; (rappel: cx:edx = addr (EMB)
   shl ebx,16
   ldea bx,TamponNoyau
   setf si
   @if pe		;; es contient l'offset dans la pile du champ Offset
     push edx
     mov es,sp
     push cx
     push ebx
     push ax
   @else
     push ebx
     push ax
     push edx
     mov es,sp
     push cx
   @endif
  ;; utiliser le tampon de 4Ko
    ;( la premire fois, s'aligner  cause de l'entte)
   movzx eax,[TailleTampon]
   push eax
   bsf cx,ax		;; masquer autant de bits que possible pour avoir le
   stc			; mme alignement que le tampon.
   sbb ax,ax
   shl ax,cl
   not ax
   and esi,eax
   pop ecx
   push ecx
   sub ecx,esi
  ;; se prparer au transfert
   mov si,es	;; pointe sur l'offset dans l'EMB
   push ebp
   pop bx
   pop es	;; ax lors des appels DOS
   clr ebp ;; longueur lue
  ;; lire/crire le premier bloc
   cmp edi,ecx
   @if nb
     mov ax,es			;; appel DOS
     ldea dx,TamponNoyau
     int 21h
     jc near DOSRW_xmsx		;; vrifier que tout va bien;
     push eax			;; longueur lue
     mov dx,sp			; sauver les parties tendues des registres?
     call [XMS_Server]		;; appeler XMS
     cmp ax,1
     pop eax
;    stc			;; si erreur, ax=0 et alors below et carry
     jnz short DOSRW_xmsx
     add [si],eax		;; mettre compteurs  jour
     sub edi,eax
     add ebp,eax
     cmp eax,ecx		;; fin de fichier ?
     jb short DOSRW_xmsx
     movzx ecx,[TailleTampon]
 ;; lire/crire les blocs suivants
     @while
       cmp edi,ecx
     @do ae
       mov ax,es			;; appel DOS
       ldea dx,TamponNoyau
       int 21h
       jc short DOSRW_xmsx	;; vrifier que tout va bien;
       push eax			;; longueur lue
       mov dx,sp		; sauver les parties tendues des registres?
       call [XMS_Server]	;; appeler XMS
       cmp ax,1
       pop eax
;      stc			;; si erreur, ax=0 et alors below et carry
       jnz short DOSRW_xmsx
       add [si],eax		;; mettre compteurs  jour
       sub edi,eax
       add ebp,eax
       cmp eax,ecx		;; fin de fichier ?
       jb short DOSRW_xmsx
     @wend
   @endif
   ;; lire/crire le dernier bloc
   mov cx,di
   @if ncxz
     mov ax,es			;; appel DOS
     ldea dx,TamponNoyau
     int 21h
     jc short DOSRW_xmsx	;; vrifier que tout va bien
     push eax			;; longueur lue
     mov dx,sp		; sauver les parties tendues des registres?
     call [XMS_Server]		;; appeler XMS
     cmp ax,1
     pop eax
;    stc			;; si erreur, ax=0 et alors below et carry
     jnz short DOSRW_xmsx
     add [si],eax		;; mettre compteurs  jour
     sub edi,eax
     add ebp,eax
     cmp eax,ecx		;; fin de fichier ?
     jb short DOSRW_xmsx
   @endif
   add sp,12
   mov eax,ebp
   pop ebp
   clc
   ret
 DOSRW_xmsx:
   add sp,12
   mov eax,ebp
   pop ebp
   stc
   ret
EndP	DOS_RW	;;ok (pas sr:  tester en priorit)

;;;;;;;;;;;;;;;;;;;;;;;;;;;; Terminaison d'OSL ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Proc	UnAlloc near
  ;; libre un bloc mmoire allou au chargement
  mov dx,[si]
  setf dx
  @if z ; (mmoire conventionnelle ?)
    mov ax,[si+4]
    setf ax		; bloc nul: non allou
    @if nz
      mov es,ax
      mov ah,49h	; librer bloc
      int 21h
    @endif
    ret
  @endif
  mov ah,0ah		;librer emb
  call [XMS_Server]
  ret
EndP	UnAlloc		;;ok
Proc	EndOSL near
  mov ax,cs		; NoyauReel
  mov ds,ax
  ldea si,HandleNoyau
  call UnAlloc
  ldea si,HandleZOT
  call UnAlloc
  mov ah,9
  ldea dx,AuRevoir
  int 21h
  mov ax,4C00h
  int 21h
AuRevoir db "  Bonjour chez vous !",13,10,'$'
EndP	EndOSL		;;ok

;;;;;;;;;;;;;;;;;;;;;;;;;;;; Liste des routines ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Interface externe
 ; FarToNear
; Entres/Sorties
 ; DisableAllInts
 ; EnableAllInts
; Mode Protg
 ; SetDescrpt
 ; Protect
 ; UnProtect
; Interface DOS
 ; DOS_RW
; Terminaison
 ; EndOSL
  ;  UnAlloc

Public FarToNear
Public DisableAllInts,EnableAllInts
Public SetDescrpt
Public Protect,GoProtect_o,GoProtect_s,UnProtect,GoReal_o,GoReal_s
Public DOS_RW
Public EndOSL

EndS	NoyauReel



Segment PileReelle

TaillePile=1024
;; Taille en para de la partie permanente du chargeur:
;; PSP: 100h
;; NoyauReel: Size NoyauReel+ Size DonneesNoyauReel, ( arrondir au para)
;; PileReelle: TaillePile
;; TamponNoyau: TailleTampon   (variable  rajouter au calcul)
 __TNR__ = ( Size DonneesNoyauReel + Size NoyauReel +0Fh ) shr 4
 __TPR__ = ( TaillePile + 0Fh ) shr 4
 Taille_Necessaire = 10h + __TNR__ + __TPR__

;;;	db TaillePile dup (?)	; pas la peine d'initialiser cette pile,
;;;	ORG 0			; puisqu'on ne l'utilise qu'on dernier moment

Label	DebutPile word
Proc FinChargement
 ;;; Place la pile  la fin de la pile du noyau
   ldea sp,SPReel
   ;(tant qu'on a un programme .COM, pas la peine d'initialiser ss)
 ;;; dalloue le segment Chargeur
   mov bx,Taille_Necessaire	; calcule la taille ncessaire
   mov ax,[TailleTampon]
   shr ax,4
   add bx,ax
   mov ah,4Ah			; fonction realloc ; es: le segment PSP
   int 21h
   @if c
     ldea dx,ErreurChargement
     mov ah,9
     int 21h
     mov ax,4C00h
     int 21h
   @endif
 ;;; Passe en mode protg
 ;(GoProtect a t initialis sur le point d'entre
 ;dclar dans l'entte du noyau)
   jmp Protect
EndP FinChargement	;;ok

SPReel = FinChargement+TaillePile
TamponNoyau = SPReel

Public TaillePile,DebutPile
Public TamponNoyau

EndS	PileReelle

