;; OSL0010N.ASM


;; dfinition d'un objet descripteur de segment de bas niveau:
; - adresse de la classe du descripteur (i.e. la classe
;	"DescripteurDeSegment")
; - adresse de la sur-zne
; - l'entre quivalente pour la DT (?)
; - dbut et fin de la place rserve au segment
; - dbut et fin de la place utilise dans le segment
; -  kicty qu'il appartient que le segment.
; - quels sont les autres segments indispensables  l'utilisation de celui-ci
; akesaufi

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Types Pointeurs ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Struc	PointeurTache		;; Pointe sur un objet Tche 32 bits
 SL	SelecteurLong	?
EndS	PointeurTache

Struc	PointeurTD		;; Pointe sur un objet Table de Descripteur
  AL	AdresseLongue	?
EndS	PointeurTD


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Gestion de la GDT ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
if 0

Q: vaut-il mieux que chaque tche ait sa GDT et joue avec la LDT, ou que
 chaque tche ait sa LDT et joue avec la GDT ? Une tche pourrait mme jouer
 avec les deux !!!
   Dans le premier cas (GDT non vraiment 'globale'), chaque tche devra avoir
 une copie des (disons) dix premiers descripteurs, ce qui prend de la place
 inutilement. Une commutation rapide et sans heurt de GDT se produira lors
 d'un bouage de LA ZOT.
   Dans le second, (GDT  place fixe), chaque commutation de tche utilisateur
 vaudra au systme la copie extensive de la table, qui ralentira: pour une
 tche moyenne avec 64 entres, le mouvement de la table prendra plus de 600
 cycles; de plus, la gestion des DT sera complique: chaque utilisation d'un
 nouvel objet avec ses sous-fonctions vaudra une copie double d'un
 "relinkage". Beurk !

				 AVL P /--DPL
				 D | | |/--DT
				G|0| |/||Type(1CRA,0EWA)
00	Entre Vide		0000 00000000
01	NoyauMemES		0100 10011111
02	DonneesNoyauMemES	0100 10010011
03	PileNoyauMemES		0100 10010011
04	TacheDeCommutation	???? 11101001	;pour changer de tche.
05	PorteServiceNoyauL1	???? 10101100
06	PorteServiceNoyauL2	???? 11001100
07	PorteServiceNoyauL3	???? 11101100
08	NoyauReel		0000 10011111
09	DonneesNoyauReel	0000 10010011
0A	Tout			1100 10010011
0B	ZOT			1100 10010011
...0F	-- Rserv au noyau
10	TacheActuelle		???? 11101011
11	LDT_TacheActuelle	???? 10110011
12	CodeTacheActuelle	0100 11111111
13	DonneesTacheActuelle	0100 11110011
14	PileTacheActuelleL0	0100 10010111
15	PileTacheActuelleL1	0100 10110111
16	PileTacheActuelleL2	0100 11010111
17	PileTacheActuelleL3	0100 11110111

18+	Libre pour la tche
Pour la tche principale du noyau:

Endif

Struc	TableDescripteurs
  LongueurTable		dw		?
  Proprietaire		PointeurTache	?
  TableSuivante		PointeurTD	?
  TablePrecedente	PointeurTD	?
EndS	TableDescripteurs

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; TSS ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Struc	Tache32bits
;;;;;;;;;;;;;;;;;;; Spcifications Intel ;;;;;;;;;;;;;;;;;;;;;;;;
    T32_TSS		TSS32	?	; suit les spcifications Intel
;;;;;;;;;;;;;;;;;; Champs supplmentaires ;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;; Liens entre tches: ;;;;;;;;
 ; Identificateur de la tche:
    NumeroTache		dd		?
 ;; Ces liens relient entre elles
 ;;- Les tches en attente
 ;;- Les tches actives
    TacheSuivante	PointeurTache	?
    TachePrecedente	PointeurTache	?
 ; Ceux-ci relie chaque tche  ses proches:
    TacheMere		PointeurTache	?
    NombreDeSousTache	dd		?  ; (on y compte la tche elle-mme)
    PremireSousTache	dw		?  ; slecteur dans la GDT
    SoeurSuivante	dw		?  ; slecteurs dans la GDT de la
    SoeurPrecedente	dw		?  ; Tache Mre
 ;;;;;; Ressources utilises par la tche: ;;;;;;;
    LongueurTSS		dw		?
			PointeurGDT
    Ressources		dw		?
	F_Save?	   =	0
 ;;;;;; Champs  adresse (et longueur ?) variable
    F_Save		dw		54 dup (?)
 ;; Ne pas oublier la carte de permission E/S
 ;;;;;; Champs situs hors du segment de TSS, mais
EndS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; IDT ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




;;;;;;;;;;;;;;;;;;;;;;;;;;; Liste des routines ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

