
;; OSL0010N.ASM
;; routines permettant la gestion de la mmoire sous OSL
;; routines  inclure dans un segment 32 bits.

; Cher Bruno,
;   voici la liste dtaille des procdures que je te demande d'crire.
;  J'ai commenc le fichier assembleur que voici en y mettant les
;  commentaires gnraux.
;   lit le fichier NOYAU386.OSL pour avoir les directives gnrales sur
;  la programmation du noyau OSL.




;;;;;;;;;;;;;;;;;;;; DEFINITION DES STRUCTURES UTILISEES ;;;;;;;;;;;;;;;;;;;;;

struc	ElementZOT	tnum,tsel,tofs,tail,	;taille:14
   Taille	dd	?	;le mot double est l'unit de taille. Ainsi
		;( moins que le processeur ne gueule), les deux bits de
		;poids fort du double mot sont libres, et le bit de signe
		;indique si l'objet est utilis, ou si la place est libre,
		;l'autre tant rserv aux "services techniques de surface"
		;(i.e. la procdure Eboueurs, qui nettoie la ZOT).
		;  Si le processeur gueule quand les bits haut ne sont pas
		;nuls alors que l'index a un facteur d'chelle 4, il faudra
		;utiliser la nullit ventuelle du champ NumeroDT de
		;TypeExact pour savoir si l'lment est occup (il faudra
		;alors qu'il n'y ait pas de DT numro 0). La dernire
		;solution est d'ajouter un champ  la structure ElementZOT
		;pour avoir ces renseignements.
   TypeExact	AdresseLongue	<tnum,tsel,tofs>
   Utilisations	dw	?	; indique le nombre d'utilisations de l'objet.
		;On peut l'incrmenter et le dcrmenter pour savoir si
		;l'objet est encore utile. Si le nombre redescend  zro,
		;l'objet sera limin. Si le nombre fait le tour du compteur,
		;il restera  zro et sera immortel. (sauf s'il est dtruit
		;manuellement par l'utilisateur)
		;Suggestion: on pourra rgler la taille de ce champ une fois
		;que l'on aura vu son importance effective.
		dw	?
ends

struc	EnteteZOT
   ; Remarque: S'il y a des ZOT embotes,
   ; le segment contenant les services de la sur-ZOT devra par une bonne
   ; habitude du systme tre dans la LDT prsente lors de l'utilisation de
   ; la ZOT.

  ;; Etat de La ZOT
    EtatZOT		dw	?	;champ indiquant la validit des
					;informations prcdentes
	;; numros des bits d'information du mot EtatZOT
	ZOT_Beurk	=	0	;  mis ssi la ZOT n'est pas accessible
				  ; actuellement, car en cours de nettoyage.
	ZOT_V_TE	=	1	; si la table des lments est valide
	ZOT_M_TE	=	2	; s'il faut la mettre  jour en
					; permanence

  ;; donnes utiles  la mise au point, mais pas  la gestion de la ZOT
  ;;(optionnellement)
    NbOperationEbouage	dw	?	;comptage du nombre de compactages


  ;; donnes fondamentales de la ZOT
    LoMem		dd	?	;dbut et fin de l'espace attribu
    HiMem		dd	?	; aux objets temporaires.

  ;; donnes utiles  la rservation de mmoire
    TailleLibreTotale	dd	?	;taille libre totale restante
    DernierBloc		dd	?	;adresse du dernier bloc mmoire
    PlusGrosBloc	dd	?	;adresse du plus gros bloc libre

  ;; donnes utiles  la gestion de la Table des lments

  ; Formules utiles pour valuer la taille souhaitable de la Table des
  ; lments.

   TableElements	dd	?	;dbut de la table des lments:
		; cette table contient, lors du passage des boueurs, la liste
		; des adresses des zones de la ZOT. Ces zones sont
		; alternativement, et par ordre d'adresse croissante, des
		; objets (zones occupes) et des zones inoccupes.
		; pendant l'utilisation de cette table, le champ taille des
		; enttes des lments de la ZOT contiendront la diffrence
		; d'adresse de l'objet aprs son compactage.
   NombreElements	dd	?	;(dw?) nombre d'lments dans la ZOT

  ; Taille effective moyenne d'un lment:
  ;  (Himem-Lomem-TailleLibreTotale)/NombreElements
  ; Esprance du nombre d'lments  rserver dans la table:
  ;  (NombreElements*(Himem-Lomem))/(Himem-Lomem-TailleLibreTotale)

  ;; Donnes indispensables au compactage avec correction des pointeurs
   struc DescrTblInternePtr	prev,next,taille,adr,ofs
     LC		ListeChainee	<prev,next>
     Adresse	dd		adr
     Decalage	dd		ofs
     Taille	dd		Taille
   ends
    InternPtrTbl DescrTblInternePtr <InternPtrTbl,InternPtrTbl,0,0,0>

ends	;EnteteZOT


if 0	;(commentaire)
  Routines OSL concernant la ZOT (suivies de leur nom assembleur embelli)

     TesteLaZone				// TsthZone
     TesteMembre				// TsthMmeBeur

     CrerUnMembre				// CrathMmeBeur
     AccderUnMembre				// Ax'aisseTouMmeBeur
     ChangerLaTailleDUnMembre			// ChengeMmeBeurSize
     FairePourChaqueMembre			// Communisme
     FairePourUnBlocDeMembres			// Communisme2
     SurveillerUnMembre				// Communisme3
     DtruireUnMembre				// Communisme4

     InsrerUnBlocDeMembres			// IBM (Khrsse)
     SupprimerUnBlocDeMembres			// DeleteMmeBeurBlauq
     InsrerOuSupprimerPlusieursBlocsDeMembres	// InsDelMmeBeurBlauq
     ImporterUnBlocDeMembres			// RehadMmeBeurBlauq
     ExporterUnBlocDeMembres			// MakeMoneyWithMmeBeurBlauq

endif





;; dfinition de la mtaclasse Zone d'objet
LesMembresSontDeTailleVariable	= 1
LesMembresSontAAdresseVariable	= 2
LesMembresSontConstructibles	= 4
LesMembresSontDestructibles	= 8





;;;;;;;;;;;;;;;;;;;;;;;;;;; PROCEDURES STANDARD ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

segment NoyauMemES

;;;;;;;;;;;;;;;;;;;;;;;;;;; DEPLACEMENT MEMOIRE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc	InternalMovsd	near
; Procdure OSL correspondante: aucune
; Paramtres:
;	- DS et ES pointent sur le mme segment
;	- ESI et EDI pointent au dbut de blocs de mmoire s'tendant vers
;	 le haut.
;	- ECX contient la longueur (non signe)  transfrer en octets
; Restrictions:
;	- il faut que ECX soit non nul et divisible par 4
; Pile: 4 mots doubles
; Rsultats:
;	- dplace le bloc ESI vers EDI.
;	- ESI et EDI sont indfinis.
;	- annule ECX
;	CTLRS ECX,ESI,EDI,F (!DF)
; Remarques
;	- le bloc n'est pas cras si les blocs se chevauchent (en fait,
;	si ESI<EDI<ESI+ECX ), et c'est l l'intrt de la routine.
;	- le bloc est dplac par Rep Movsd, c'est pourquoi il faut que
;	 4 divise CX.
	;; d'un segment dans lui-mme (en supposant ds=es), sans craser
	;; la mmoire si la destination est aprs la source.
		cmp	esi,edi
		jb	sh intmovsddec		; si esi<edi
		jz	sh intmovsdnotestupido
		cld
	RepMovsd:
		shr	ecx,2
		jecxz	repmovsd0
		rep	movsd
	repmovsd0:
		retn
	intmovsddec:
		add	esi,ecx
		add	edi,ecx
		std
		call	RepMovsd
	intmovsdnotestupido:
		retn
InternalMovsd	endp

ends	;NoyauMemES
