;; OSL0011N.ASM
;;;;;;;;;;;;;;;;;;;;; FONCTIONS MEMBRES DE LA ZOT ;;;;;;;;;;;;;;;;;;;;;;;;;;


Proc	Communisme	near
; procdure OSL correspondante: < FairePourChaqueMembre >
; rsultats: Excute pour chaque membre une mme routine (proche)
;            CTLRS EAX,EBX,ESI,F (+? cf [EDX] )
; paramtres:
;   DS:0 pointe sur l'entte de la ZOT (type EnteteZOT).
;   EDX contient l'adresse de la routine  xcuter pour chaque membre
;     ESI va pointer successivement sur chaque membre.
    mov esi,ofs EnteteZOT.ObjetPreReserve
  CycleCommuniste:
    call edx
    lodsd
    lea esi,[esi][eax*4]
    cmp esi,[EnteteZOT.TableElements]
    jb	CycleCommuniste
   ;jnz ErreurZOT
    ret
EndP


Proc	TesthZone	near
; procdure OSL correspondante: < TesteLaZone >
; rsultats: teste l'intgrit de la zone.
;           CTLRS EAX,EBX,ECX,ESI,EDI,F (+? cf [EDX] )
;     si CF est mis, c'est qu'il y aura eu une erreur dans la ZOT
; paramtres:
;   DS:0 pointe sur l'entte de la ZOT (type EnteteZOT).
  ;; Prendre la taille du segment dans edi (pour vrifier les adresses)
    xor eax,eax
    mov ax,ds
    LSL edi,eax
  ;; Tester l'tat de la ZOT:
    mov ax,[EtatZOT]
    shr ax,1		;; la zone ne doit pas tre en Ebouage
    jc sh FinTesthZone
  ;; Tester l'alignement de la ZOT
    mov eax,[Lomem]
    mov ebx,[TableElements]
    mov ecx,[Himem]
    test al,11b
    jnz ErreurTesthZone
    test bl,11b
    jnz ErreurTesthZone
    test cl,11b
    jnz ErreurTesthZone
  ;; Vrifier que l'on a edi>=Himem>TableElements>Lomem
    cmp edi,ecx		;;
    jc sh FinTesthZone	;(jb==jc)
    cmp ecx,ebx
    jbe sh ErreurTesthZone
    cmp ebx,eax
    jbe sh ErreurTesthZone
  ;; Tester la taille de la table des lments
	;; calcule la taille minimale que devrait avoir la table:
	;; tmin = 2N-M o N=nombre d'lments, M=nombre de zones nulles
	;; on en profite pour fabriquer la table des lments, et
	;; pour tester le nombre d'lments.
    ;...
  ;; Tester l'intgrit de la liste chane des tables internes de pointeurs
    ;...
  FinTesthZone:
    ret
  ErreurTesthZone:
    stc
    ret
EndP

Proc	TesthMemeBeur	near
; procdure OSL correspondante: < TesteMembre >
; rsultats:
;	-Vrifie le slecteur dans DX en tant que partie d'un lment de la
;	zone.
;	-renvoie dans ESI l'offset de l'entte de l'objet
;	(structure ElementZOT).
;	-renvoie dans EAX l'offset de l'objet par rapport  son dbut
;	(i.e. 0=juste aprs l'entte)
;     CF est mis ssi il y a eu une erreur dans le test est mauvais
;            CTLRS EAX,EBX,ESI,F (+? cf [EDX] )
; paramtres:
;   DS:0 pointe sur l'entte de la ZOT (type EnteteZOT).
	call GetDescriptor

EndP

RESTE A FAIRE

     CrerUnMembre				// CrathMmeBeur
     AccderUnMembre				// Ax'aisseTouMmeBeur
     ChangerLaTailleDUnMembre			// ChengeMmeBeurSize
     FairePourUnBlocDeMembres			// Communisme2
     SurveillerUnMembre				// Communisme3
     DtruireUnMembre				// Communisme4

     InsrerUnBlocDeMembres			// IBM (Khrsse)
     SupprimerUnBlocDeMembres			// DeleteMmeBeurBlauq
     InsrerOuSupprimerPlusieursBlocsDeMembres	// InsDelMmeBeurBlauq
     ImporterUnBlocDeMembres			// RehadMmeBeurBlauq
     ExporterUnBlocDeMembres			// MakeMoneyWithMmeBeurBlauq


proc	BullFrog
; procdure OSL correspondante: < AgrandirLaZone >
; rsultats: Agrandit la zone de mmoire
; paramtres:
;   ECX indique la taille supplmentaire demande pour le segment la zone.
    ....
    Cette partie est  faire plus tard, car elle utilise le reste des
  objets: la procdure doit appeler celle grant la globalit des segments,
  etc... . Bref,  faire en dernier.
endp
proc    WhatsLeft
; procdure OSL correspondante: < PlaceRestante >
; rsultats: renvoie la taille libre restant dans le segment
;   ECX indique la taille disponible dans la zone (le segment)
    ....
    Cette partie est  faire plus tard, car elle utilise le reste des
  objets: la procdure doit appeler celle grant la globalit des segments,
  etc... . Bref,  faire en dernier.
endp
proc    BolzanoWeierstrass
; procdure OSL correspondante: < CompacterLaZone >
; rsultats:
;  - compacte la zone de mmoire
;  - renvoie la taille libre restant dans le segment zone de mmoire dans ECX
    ....
    Cette partie est  faire plus tard, car elle utilise le reste des
  objets: la procdure doit appeler celle grant la globalit des segments,
  etc... . Bref,  faire en dernier.
endp


proc    IBM_Krasse
; procdure OSL correspondante: < InsrerUnBlocDeMembres >
; rsultats:
;  - insre N octets  l'adresse
;  - s'il ne reste pas de place libre, la demande au gestionnaire de segment,
;   d'abord juste aprs et/ou juste aprs, et s'il n'en a pas, essaie mme de
;   se reloger, autre part, en compactant si ncessaire la zone suprieure.
;  - renvoie la taille libre restant dans le segment zone de mmoire dans ECX
    ....
    Cette partie est  faire plus tard, car elle utilise le reste des
  objets: la procdure doit appeler celle grant la globalit des segments,
  etc... . Bref,  faire en dernier.
endp



;; en entre:	1) une zone de mmoire brute
;;		2) une liste (par variable) dont les lments
;;		sont des ensembles de deux entiers, le premier indiquant la
;;		longueur d'un bloc  insrer (signe positif) ou  dtruire
;;		(signe ngatif). La place cre n'est pas initialise. Le
;;		processus s'arrte quand le deuxime lment est nul.
;;		Aucun test de taille n'est effectu.
;; (1) dans ES
;; (2) dans DS:EBX
;; niveau de privilge: 01
		mov	edx,4
		clr	esi
		clr	edi
	IBM_0:	mov	eax,[ebx]
		add	ebx,edx
		mov	ecx,[ebx]
		jecxz	IBM_goodbye
		add	ebx,edx
		or	eax,eax
		js	IBM_delete
		add	edi,eax
		push	offset IBM_0
		jmp	intmovsb
	IBM_delete:
		add	esi,eax
		push	offset IBM_0
		jmp	intmovsb
	IBM_goodbye:
		retn


;Procdure OOPS-ASM pour faire la mme chose
; (le ASM du OOPS doit non seulement accepter macros et identificateurs,
; mais il doit de plus remettre les structures et donnes  leur place.
; Il est impossible d'crire un quelconque programme en OOPS sans que la
; division des objets soit effectue, et les objets accessibles dfinis 
; l'intrieur du code objet; aussi, l'assembleur devra se charger de toute
; cette basse besogne, pour en dcharger le programmeur-utilisateur;
; par contre, en mode habituel, le ASM ne permettra pas de programmation
; "sle", i.e. des sauts sans tiquette sre, des donnes pour du code, etc.)
;; la zone mmoire est en O0, la liste dans O1
;; niveau de protection: 2 au moins
;Entre niveau 2:
;	pushm O2,O3
;	pour_tout_lment(
;	  O1,
;	  {
;
;	  }
;	 )
;
;	popm
;
;
;

Elements OOPS de base
 chose	(res)		( rapprocher du void en C)
 entier	(integer)
 rel

Types OOPS matriels
  scalaire
  chiffre en base n
  nombre modulo n	la diffrence entre les 2: la retenue

constructeurs virtuels OOPS, et constructeurs rels associs (*)

 Ensemble		; l'objet est un ensemble de composants
			; tout ensemble est index, fut-ce par une
			; adresse mmoire relative de la composante, etc.
    on doit y dfinir:
     le type des lments
     le type des pointeurs
     l'ensemble ventuel des pointeurs vers des lments particuliers
 Objetd'unEnsemble	; l'objet est l'ensemble, mais reprsent par un
			; lment particulier (point) exemple: dans une
			; liste chane boucle, la liste est reprsente
			; par un de ses lments; ce phnomne se rapproche
			; d'une classe a& en C++, sauf que le pointage n'est
			; pas standard.
   Liste		; l'index (entier) est le numro de l'objet
    Tableau		; les objets sont tous de mme taille
     Chaine		;
      Pile		;

(* un pointeur ne sera jamais qu'un index dans un tableau ou une liste *)
