/**********************************************************************/

#define GetOpt_G
#include "GetOpt.h"
#include "StrToX.h"
#include <stdio.h>
#include <stdlib.h>

/******************* Procdures Principales ***************************/

void GetParam(Option *ListOptions,Word LOLength,int* Args,char** ListArgs)
{
  Word i;   /* numro argument en ligne de commande */
  char *j;   /* position dans la chane (pour options multiples) */
  Word n;   /* numro option */
  char* s;

  *Args = 0;
  switch (CardOptBegin) {

  case 0:
    i = 1;
    j = ParamStr[i];
    if (ParamCount > 0)
      ParseOptions(ListOptions, LOLength, &i, &j);
    for (i=1; i <= ParamCount ; i++)
      ListArgs[i-1] = ParamStr[i];
    break;

  case -1:
    for (i = 0; i < ParamCount; i++) {
      j = ParamStr[i];
      ParseOptions(ListOptions, LOLength, &i, &j);
    }
    break;

  default:
    for (i = 0; i < ParamCount; i++)
    {
      j = ParamStr[i] ;
      if ( IsBeginOpt(*j) )
      {
	j++ ;
	ParseOptions(ListOptions, LOLength, &i, &j );
      }
      else
	if (*Args >= ParamNumber)
	  ParamError (&i,&j) ;
	else ListArgs[(*Args)++] = j;
    } /** for **/
  }
}


void ParseOptions(Option *ListOptions,Word LOLength,Word* i,char** j)
{
  long n;
  char *s ;
  Option * Opt ;

  while( **j !=0 )
  {
    for (n = 1; n < LOLength; n++)
    {
      Opt = &ListOptions[n] ;
      if (**j == Opt->c)
      {
	Opt->s (Opt->p,i,j) ;
	n = LOLength+1 ;
      }
    }
    if (n == LOLength) ListOptions[0].s (ListOptions[0].p,i,j);
    (*j)++;
  }
}

void PrintSmallHelp (Word *i,char**j)
{
  puts(HelpText);
  exit(1) ;
}

/**************** Procdures SetOpt standard **********************/
void SetTrue(void *p,Word*i,char**j)
{
  *(boolean *)p = True;
}

void SetFalse(void *p,Word*i,char**j)
{
  *(boolean *)p = False;
}


void SetTrueFalse(void *p,Word *i,char **j)
{
  switch (*(*j+1)) {

  case '+':
  case '1':
  case 'O':
  case 'p':
  case 'Y':
  case 'y':
    *(boolean *)p = True;
    (*j)++ ;
    break;

  case '-':
  case '0':
  case 'N':
  case 'n':
    *(boolean *)p = False;
    (*j)++ ;
    break;

  default:
    ParamError(i, j);
    break;
  }
}

void SetMultipleBytes(void *p,Word*i,char**j)
{
  Word k;
  SetByteList* P=p ;

  for (k = 0; k < P->n ; k++)
    *(P->M[k]->p) = P->M[k]->v ;
}

static void SetNumberOrDefault(long* p, Word* i, char** j,
			       boolean IsDefault,long Default)
{
  long n;
  Word i1;
  char *t, *u;
  char b;

  i1 = *i;
  t = *j+1;
  if (*t == 0 )
  {
    if (*i == ParamCount)
      ParamError(i, j);
    else
    {
      (*i)++ ;
      t = ParamStr[*i];
    }
  }
  else
    if (*t == '=' || *t == ':') t++ ;
  n = GetInteger (t,&u) ;
  if (t==u)
    if (IsDefault) *p = Default ;
    else ParamError(i,j) ;
  else {
    *i = i1 ;
    *j = u-1 ;
    *p = n ;
  }
}
void SetNumberOrM1(void *p,Word* i,char** j)
{
  SetNumberOrDefault(p, i, j, True, -1L);
}
void SetNumber(void *p,Word* i,char** j)
{
  SetNumberOrDefault(p, i, j, False, 0L);
}
void SetLong(void *p,Word* i,char** j)
{
  SetLongParam *P=p ;
  *P->p=P->v ;
}
void SetPtr(void *p,Word* i,char** j)
{
  SetPtrParam *P=p ;
  *P->p=P->v ;
}
void SetByte(void *p,Word* i,char** j)
{
  SetByteParam *P=p ;
  *P->p=P->v ;
}
void GetString(void *p,Word* i,char** j)
{
  char **P=p ;
  if (**j==0)
    if ( (*i)+1 >= ParamCount ) ParamError(i,j) ;
    else { (*i)++ ; *j=ParamStr[*i] ;}
  *P=*j;
  while (**j!=0) (*j)++ ;
  (*j)-- ;
}



/*********************** Valeurs Par dfaut ***********************/

void InitGetParam (int argc,char ** argv)
{
 ParamCount = argc ;
 ParamStr = argv+1 ;
 ParamError = PrintSmallHelp ;
 ParamNumber = MAXLIST ;
 CardOptBegin = 1 ;
 OptBegin.minus = 1 ;
 OptBegin.slash = 0 ;
}
