/******************* Unit GetOpt **************/
/*
v1.0
*/
/*
This is copyright (c) Franois-Ren "Far" Rideau June 1993
You may freely distribute or modify it, but please keep
my address inside it, and send me modified version.
My addresses are:
- rideau@clipper.ens.fr
- 6, rue Augustin Thierry 75019 Paris FRANCE
*/

#ifndef GetOpt_H
#define GetOpt_H

#ifdef GetOpt_G
 #define vextern
#else
 #define vextern extern
#endif

#include "MyTypes.h"

#define MAXOPT 16384
#define MAXLIST 8192

typedef void SetOpt (void*,Word*,char**);

typedef struct {
  char c;	/*caractre*/
  void* p;	/*paramtre de la procdure*/
  SetOpt* s;	/*procdure  lancer*/
  char *d;	/*description*/
} Option;
	/* dans une table d'option, la premire est celle par dfaut */


typedef struct {
  char *p, v;
} SetByteParam;
typedef struct{
  void **p, *v;
} SetPtrParam ;
typedef struct {
  long *p, v;
} SetLongParam;

typedef struct {
  Word n;
  SetByteParam **M;
} SetByteList;

vextern struct {
  int minus:1 ;
  int slash:1 ;
}	OptBegin ;      /* caractres indiquant des options */
vextern Word CardOptBegin;	/* cardinal de l'ensemble prcdent */
				/* 0: premier argument=options */
				/* -1: tout est option */
vextern Word ParamNumber;
vextern Word ParamCount;		/* = _argc */
vextern char **ParamStr;		/* = _argv+1 */
vextern char *HelpText;
vextern void (*ParamError) (Word *,char **);
			/* Que faire en cas d'erreur */

extern void InitGetParam (int argc,char **argv) ;
extern void GetParam (Option *ListOptions, Word LOLength,
		       int *Args, char **ListArgs);
extern void ParseOptions (Option *ListOptions, Word LOLength,
		       Word *i, char**j);
extern void PrintSmallHelp (Word *i, char **j);

extern SetOpt SetTrue, SetFalse, SetTrueFalse,
	      SetByte, SetMultipleBytes, SetLong, SetPtr,
	      SetNumber, SetNumberOrM1,
	      GetString ;

/**********************************************************************/

#define IsBeginOpt(c) \
   ( ((c=='-')&&(OptBegin.minus)) || ((c=='-')&&(OptBegin.slash)) )

#undef vextern
#endif /*GETOPT_H*/
