#ifndef MyVIO_H
#define MyVIO_H

/***
  myVIO.h
  Virtual IO Header.
***/

#include "Objects.h"

#ifdef MyVIO_G
  #define vextern
#else
  #define vextern extern
#endif

typedef struct StreamInfo {
  void (*Open) (TObject * stream, Name*name, int rights) ;
  char (*Read) (TObject *stream) ;
  void (*Write) (TObject *stream, char c) ;
  void (*MultiRead) (TObject *stream, void*Buffer, int size) ;
  void (*MultiWrite) (TObject *stream, void*Buffer, int size) ;
  void (*Close) (TObject *stream) ;
} StreamInfo;



vextern const TMetaClass m_Stream ;
vextern const TClass c_FileStream, c_DevStream, c_StringStream,
	      c_MultiBufferedStream ;

#define Right_READ	  0x0004
#define Right_WRITE	  0x0002
#define Right_EXEC	  0x0001
#define RightsBitPerGroup 3
#define Open_CREATE       0x0200
#define Open_APPEND	  0x0400
#define Open_REWRITE	  0x0800
#define Type_MASK	  0xF000
#define Type_SPECIAL	  0x1000
#define Type_TEXT	  0x2000
#define Type_DEVICE	  0x4000
#define Type_OBJECT	  0x8000
#define Type_CHARDEV	  0x7000
#define Type_BLOCKDEV	  0x5000
#define Type_PIPE	  0x3000
#define Type_MEM	  0x1000
#define Type_DIR	  0xD000


#undef vextern
#endif /* MyVIO.h */
