#define Objects_G
#include "MyTypes.h"
#include "Objects.h"
#include "VSymbolT.h"
#include <stdlib.h>
#include <string.h>

/****************** Generic Functions on (Meta)Classes ****************/

TField * GetMetaMember (TMetaClass *MC,Name *name)
{
  int i ;
  TField * F ;

  for (i=0;i<MC->NMembers;i++)
  {
    F=MC->Member+i ;
    if ( strcmp (name,F->name) ) return F ;
  }
  return NULL ;
}

void SubMember (TObject*Field,TObject*Obj,Name *name)
{
  TField * F = GetMetaMember (Obj->class->meta,name) ;
  if (F!=NULL) F->get(Field,Obj,F) ;
  else { Field->body=Field->class=NULL ;}
}
void * GetMember (TObject*Obj,Name *name)
{
  TObject M ;
  SubMember(&M,Obj,name) ;
  return M.body ;
}
void FindObjectWithMetaClassIn (TObject * Result, char*Name,
				TMetaClass *MC, TObject *Where )
{
}
void GenDictionary (TObject*Obj,char*name,TObject*result)
{
  if ( strcmp (name,"self") ) memcpy(result,Obj,sizeof(Obj)) ;
  else
  { SubMember (result,Obj,name) ;
    if (result->body==NULL && Obj->up!=NULL)
      Obj->up->class->meta->GetMember(Obj->up,name,result) ;
  }
}

/*** Input/Output ***/
void BinReader (TObject*Obj,VInput *I)
{
  TMetaClass *M = Obj->class->meta ;
  int i ;
  TField *F ;
  TObject *field ;

  for (i=0;i<M->NMembers;i++)
  {
    F=&M->Member[i] ;
    F->get(field,Obj,F) ;
    field->class->meta->ReadFromBin(field,I) ;
  }
}

void BinWriter (TObject*Obj,VOutput *O)
{
  TMetaClass *M = Obj->class->meta ;
  int i ;
  TField *F ;
  TObject *field ;

  for (i=0;i<M->NMembers;i++)
  {
    F=&M->Member[i] ;
    F->get(field,Obj,F) ;
    field->class->meta->WriteBinTo(field,O) ;
  }
}


/********************** standard TMetaClass members ********************/

/*** Creators ***/

void MetaNew (TObject*Obj,...)
{ /** first info must be object length **/
    Obj->body = malloc ( *(int*)(Obj->class->info) ) ;
    memset (Obj->body,0,Obj->class->meta->length(Obj));

}

/*** Destructors ***/

void MetaDestroy (TObject*Obj)
{
  free (Obj->body) ;
  Obj->body = NULL ;
} /** first info must be object length **/


/*** Evaluators ***/

TObject* Identity (TObject* Obj,...)  { return Obj ;}


/*** Surveyors ***/

int MetaLength (TObject* Obj)
{ return *(int*)(Obj->class->info) ; } /** first info must be object length **/

/********************** standard TField members ********************/

void           InitMember (TObject* Descr,TObject* Object,TField* Field)
{
  Descr->class = Field->class ;
  Descr->name  = Field->name ;
  Descr->up    = Object ;
}

void           GetConstOfsMember (TObject* Descr,
				  TObject* Object,TField* Field) 
{
  InitMember (Descr,Object,Field) ;
  Descr->body = ((char*)(Object->body))+(Field->offset) ;
}


/************************ Some useful constants *********************/
const int One = 1 ;
const int Two = 2 ;
const int Four = 4 ;

/******************* Basic Data Classes & MetaClasses ***************/

const TClass c_Void = {"Void",&MetaVoid,NULL} ;
const TClass c_Char = {"Char",&MetaInt, &One} ;
const TClass c_Short = {"ShortInt",&MetaInt, &Two} ;
const TClass c_Long = {"LongInt",&MetaInt, &Four} ;

/******************* Basic Constructor MetaClasses ******************/

/********************* Meta MetaClass MetaClass *********************/

void MetaClassParser (TObject*Obj, VInput* I)
{}
void MetaClassPrinter (TObject*Obj, VOutput* O)
{}

const TField * m_MetaClass_Members
/* =
{
 { "Name",
 },
 {
 }
}
*/
;

const TMetaClass m_MetaClass = { "MetaClass",
  MetaNew, Identity, MetaLength, MetaDestroy,
  BinReader,MetaClassParser,BinWriter,MetaClassPrinter,
  GenDictionary, 2, &m_MetaClass_Members, &c_Void
} ;
const TClass c_MetaClass = { "MetaClass",&m_MetaClass,NULL } ;
const TObject  MetaClass = { "MetaClass",NULL,&c_MetaClass } ;
