/*
				 Dichotomie.h
*/
/*
   Ce fichier contient le code ncssaire pour crire une procdure de
 dichotomie : on dtermine le nombre convenant le mieux, dans un intervalle
 de dpart, sachant dterminer si un nombre donn convient, est trop grand,
 ou trop petit, un nombre plus grand qu'un nombre trop grand convenant moins
 bien, et de mme pour les nombres trop petits.
   On doit dfinir ou non les variables ou macro suivantes :
 * UPPER_LIMIT et LOWER_LIMIT, initialise aux valeurs extrmes de
 l'intervalle .
 * TEST_LOWER_LIMIT et TEST_UPPER_LIMIT : non nuls si et seulement si (ssi)
  l'on n'est pas sr que le nombre convenant soit respectivement suprieur ou
  gal  la borne infrieure de l'intervalle, ou infrieur ou gal  la borne
  suprieure de l'intervalle . Il faut s'assurer que le second est
  strictement suprieur au premier avant d'oprer  la dichotomie .
 * NUMBER : variable du bon type qui sera utilise dans la procdure
 * DISCRETE : non nul ssi le nombre reprsente une grandeur  valeurs
  discontinues (comme des entiers, par opposition aux rels).
 * PRECISION : indique la prcision strictement en-dessous de laquelle le
  nombre est suffisament bien dfinit ( 1 pour les entiers ) .
 * COMPARE(N) : instruction(s)  xcuter pour dterminer si le nombre donn
  en paramtre est trop grand, trop petit, ou convenant .
 * RESULT : variable du type renvoy par COMPARE , nul ssi le nombre
  convient, ngatif s'il est trop petit, positif s'il est trop grand ;
 * OK(NUMBER,RESULT) : instructions  xcuter quand le meilleur nombre,
  NUMBER, est trouv, avec RESULT tant le rsultat de la dernire
  comparaison .
*/
/* Exemple :
 // Solution d'une quation par dichotomie :

 inline int sgn(float x) { return  (x<0)?(-1):(x!=0) ;}

 float ResoudreParDichotomie ( float (*f) () , float a,b )
 {
   int s = sgn ( (*f)(b) - (*f)(a) ) ;
   int r ;
   float x ;

   if (  sgn( (*f)(a) ) != s  ) error() ;

   #define RESULT		r
   #define NUMBER		x
   #define COMPARE(x)		(s*(*f)(x))
   #define LOWER_LIMIT		a
   #define UPPER_LIMIT		b
   #define TEST_LOWER_LIMIT	0
   #define TEST_UPPER_LIMIT	0
   #define PRECISION		(1e-6)
   #define DISCRETE		0
   #define OK(x,r)		return x

   #include <dichotomie.h>
 }
*/

#if TEST_LOWER
 RESULT = COMPARE(LOWER_LIMIT) ; if(RESULT<=0) OK(LOWER_LIMIT,RESULT) ;
#endif
#if TEST_UPPER
 RESULT = COMPARE(UPPER_LIMIT) ; if(RESULT>=0) OK(UPPER_LIMIT,RESULT) ;
#endif

#define TRY(X)	if ( (RESULT = COMPARE(X)) ==0) OK(X,RESULT)

#if DISCRETE
 #define HALF(a)	(  (a) >> 1  )
 #define PLUS
 #define MINUS
#else
 #define HALF(a)	(  (a) / 2  )
 #define PLUS		+ (PRECISION)
 #define MINUS		- (PRECISION)
#endif


do
 {
 NUMBER = HALF( (LOWER_LIMIT) + (UPPER_LIMIT) ) ;
 TRY (NUMBER) ;
 if ( IS_TOOLOW(RESULT) )
       LOWER_LIMIT = NUMBER MINUS ;
  else UPPER_LIMIT = NUMBER PLUS  ;
 }
while
 ( ((UPPER_LIMIT)-(LOWER_LIMIT)) >= PRECISION ) ;

OK (LOWER_LIMIT,COMPARE(LOWER_LIMIT)) ;


#undef COMPARE(x)
#undef LOWER_LIMIT
#undef UPPER_LIMIT
#undef TEST_LOWER_LIMIT
#undef TEST_UPPER_LIMIT
#undef PRECISION
#undef DISCRETE
#undef RESULT
#undef OK
#undef NUMBER
#undef TRY
