#define debug
#ifdef debug
#include <string.h>
#include "macro.h"
#include "erreur.h"
#include <alloc.h>
#endif


////////		CLASSES "stringo" et "stack"

/*
  Cette classe est un objet abstrait utilis pour les entres/sorties .
  Pour l'instant, il gre surtout des chanes de caractres de petite taille,
 en rservant tout simplement la place dans la pile.
  Un gestionnaire plus volu utilisera des fichiers temporaires sur disque,
 la mmoire tendue au-del de la limite DOS ...
*/
const char* zero ="";
char NestedComments ;


struct	stringo
{ Word	size,		// taille du tampon de caractres
	ptr,		// pointeur d'accs index
	len;		// longueur effective utilise
  int	pace;		//  logarithme en base 2 de l'incrment de taille en
			// cas de dbordement ; une valeur <0 indique une
			// taille constante, mme si dbordement, et une
			// valeur <-1 indique une chane  adresse fixe .
  char*	cars;		// adresse du tampon

public :

 // CONSTRUCTEURS
   stringo	(Word Size=32,const char*C=zero,Word Pace=-2) ;
   stringo	(const char*) ;
  ~stringo	()	{ if (pace>=-1) delete cars ;}

 // OPERATEURS
   stringo& operator= (stringo&s) {
			 size = s.size ;
			 ptr  = s.ptr  ;
			 len  = s.len  ;
			 pace = s.pace ;
			 if (pace<-1) cars = s.cars ;
			 else
			  {
			  cars = new char[size] ;
			  memmove (cars,s.cars,len) ;
			  }
			 return *this ;
			 }


 // ENTREES/SORTIES
  void	put	(char) ;
  void	write	(Word) ;
  void	write	(dword) ;
  void	Write	(void*,Word) ;
  char	get	()	{ if (ptr>=size) return 0 ;
			  return cars[ptr++];}
  char	car	()	{ return cars[ptr] ;}
  dword getint	() ;

 // CONTROLE DU FLUX
  void	back	()	{ if(ptr) --ptr ;}
  int	end	()	{ return ptr>=len ;}
  int	setsize (Word) ;
  int	verifysize (Word);
  void	skipcomments () ;
};


stringo::stringo	(Word Size=32,const char*C=zero,Word Pace=-2)
 { len  = strlen (C);
   size = MAX(Size,len);
   cars = new char[size];
   pace = Pace;
   if(len) memmove ( cars,C,len );
 }
stringo::stringo   (const char*C)
 { size = len = strlen (C) ;
   ptr  = 0 ;
   pace = -1 ;
   cars = (char*) C ;
 }

void	stringo::put (char c)
 {if (pace<0) return ;
  if (ptr==size)
    if (!setsize(size+pace))
      erreur(TooFewMemory);
  cars[ptr++]=c;
  len = MAX(ptr,len);
 }
void	stringo::Write (void*P,Word L)
#define	writeo(o)	Write(&ObjLen((o)))
 {if (pace<0) return ;
  if (ptr+L>=size)
    if (!setsize(ptr+L))) erreur(TooFewMemory);
  memmove ( cars+ptr , P , L ) ;
  ptr = ptr + L + 1 ;
  len = MAX(ptr,len);
 }
void	stringo::write (Word w)
 {put(Lo(w));
  put(Hi(w));
 }
void	stringo::write (dword d)
 {write(LLo(d));
  write(LHi(d));
 }

int	stringo::setsize (Word newsize)
 {
#ifdef debug
  if (pace<0) erreur (DebugError) ;
#endif
  newsize = (  newsize + (1<<pace) - 1  ) >> pace ;
  if ( !realloc(cars,size=newsize) )
  {
   char* st = new char[size] ;
   if (st==0) erreur ( TooFewMemory ) ;
   memmove ( st,cars,size ) ;
   free (cars) ;
   cars = st ;
  }
  return 1 ;
 }
int	stringo::verifysize (Word vsize)
 {
  if (pace==0) return size>=vsize ;
  Word w = vsize % pace ;
  if (w) w -= pace ;
  return setsize ( vsize - w ) ;
 }

dword	stringo::getint()
 {
 back ();
 dword a;
 char c=get();
 do	//  a=10*a+c
  {
  a <<= 1 ; a +=  (a<<2) ;	// a*=10
  a += c&0xf ;			// a+=c
  }
 while (isdigit(c=get()));
 back();
 return a ;
 }

void stringo::skipcomments(void)
{
//	liminer les commentaires '/' et '*' ( dj pris )
 char c=get();
 Word lvl;
 if (NestedComments)
   for (lvl=1;lvl; c=get() )
    {
    if (c=='*')	{ if ((c=get())=='/') { lvl--; continue; }}
    else
    if (c=='/') { if ((c=get())=='*') { lvl++; continue; }}
    }
 else
 for(;;c=get())
  {
  if (end()) erreur (OpenComment);
  if (c!='*')
   if (c=='/') break;
   else continue;
  }
}


struct stack : stringo
{
	stack	(Word s,int p) : stringo(s,"",p) ;
  void	push	(char c)	{put (c);},
	push	(Word w)	{write(w);},
	push	(dword)		{write(d);},
#define	Push(obj)		writeo(ObjLen(obj))
	pop	(char& c)	{if(ptr>0) c=cars[--ptr];},
	pop	(Word& w)	{if(ptr>1) w=((Word*)cars)[ptr-=2];},
	pop	(dword& d)	{if(ptr>3) d=((dword*)cars)[ptr-=4];},
	pop	(char*c,Word l)	{if(ptr>=l) memmove(c,cars+(ptr-=l),l);};
#define Pop(obj)	pop ((char*)&ObjLen(obj))
}

