 ;									     ;
 ;				OSLm prversion 0.0			     ;
 ;									     ;
.xlist
			  ; sur IBM PC/XT ou compatible

;dj fait:
 ;Noyau	:
  ;Save		:Sauve l'tat du processus actuel
  ;Restore	:Remet en marche un tel processus
;En train :
 ;Noyau
  ;Eboueur	:libre la mmoire occupe par des objets inutiles de la ZOT
;A faire  : tout le reste !!!!!

 ;									     ;
 ;				  Spcifications			     ;
 ;									     ;

;Nature du projet
 ;  OSLm est un environnement multi-tche permettant la programmation par un
 ; systme de piles en notation polonaise inverse, avec multifentrage pour la
 ; visualisation.
;-Structure de langage  objets
 ;  Le langage de programmation OSLm utilise systmatiquement des objets,
 ; concept englobant les donnes et le code ncessaire  leur traitement.
 ; une version complte d'OSLm devra permettre la dfinition de nouveaux
 ; type d'objets.
;-Langage semi-compil et semi-interprt
 ;  Le code xcutable obtenu par la semi-compilation est une suite d'adresses
 ; de routines dans un noyau (en anglais:runtime) permettant l'inclusion
 ; directe de langage machine, donnant ainsi un compromis relativement rapide
 ; et efficace par rapport aux solutions d'un langage totalement interprt
 ; (trs lent  l'xcution) ou d'un langage compil (lent  la compilation,
 ; pas toujours plus rapide  l'xcution, souvent tout aussi ou mme plus
 ; gourmand en code xcutable, sans offrir directement les potentialits d'un
 ; environnement multitche).
 ;  Ce compromis offre donc une compilation trs rapide, avec un code
 ; proche de celui d'un langage compil, une vitesse comparable  celle
 ; d'un programme compil moyen, grce  une bibliothque intgre des
 ; routines souvent utilises.
;-Types d'objets prxistant
 ; * les entiers longs  , sur 30 bits
 ; * les entiers courts , sur 16 bits
 ; * les rels courts   , sur 29 bits, en notation  virgule flottante
 ;  binaire, la mantisse signe sur 21 bits offrant 6 chiffres signifi-
 ;  catifs et l'exposant sign sur 8 bits un intervalle de 1e38  1e-38
 ; * les chanes de caractres
 ; * des piles d'objets, en nombre limit par la mmoire seulement
 ; * des programmes en OSLm, limits en taille  64 Ko pour le code
 ;   xcutable, idem pour la liste des noms de variables et constantes
;-Notation polonaise inverse
 ;  Cette notation, non forcment exclusive pour le langage, est tout  fait
 ; adapte  la structure de piles : on empile les oprandes avant d'valuer
 ; l'opration . ( exemple: '4+5' s'crit  4 5 +  )

;Structure des donnes et de la mmoire
 ;  Toute la RAM disponible devient une zone d'objets temporaires (ZOT).
 ; Ces objets sont :
 ; . des programmes
 ; . des zones de variables globales associes  un processus
 ; . des piles OSLm
 ; . des chanes de caractre
 ; N.B.: les entiers et rels courts ne sont pas inclus directement dans
 ;	cette zone, tant toujours dans une pile ou une variable globale.
;-Format d'un pointeur:
 ; . un mot de 16 bits indique le bloc de 8 octets o se trouve l'objet. Une
 ;  telle mthode permet la gestion de 512 Ko de ZOT maximum ( auxquels il
 ;  faut retirer la taille de la table des vecteurs d'interruption, de la zone
 ;  des donnes du BIOS, du DOS et des programmes rsidents ). Pour ne pas
 ;  gaspiller l'espace ainsi adressable, Le Noyau OSLm sera charg en haut de
 ;  la mmoire,  l'initialisation. ( Edition de liens avec l'option /H )
 ; . un octet prcise le type pour un pointeur tendu
 ; . optionnellement, un octet complte le tout
Value	=	0	;1 mot
Type	=	2	;1 octet
xtn	=	3	;1 octet optionnel
 ; * le bit 0 (parit) de Type indique s'il s'agit d'un pointeur dans la ZOT
 ;  s'il est  1 ou bien d'un objet de type immdiat dans l'autre cas.
 ; * s'il s'agit d'un objet de type pointeur,  value est alors
 ;  un pointeur, et type indique le type de l'objet:
 ;  type - type de l'objet		type - type de l'objet
 ;  01h  - pile				03h  - zone rserve d'un processus
 ;  05h  - fentre			07h  - ??
 ;  09h  - rel tendu			0Bh  - chane de caractres
 ;  0Dh	 - programme			0Fh  - En cours de destruction
 ; * s'il s'agit d'un objet de type immdiat, les bit 1 et 2 de type
 ;  indiquent de quel type d'objet il s'agit (# = type and 6):
 ;	# - type de l'objet
 ;	0 - entier long		:type,value est un nombre multipli par 8
 ;	2 - entier court	:value est un nombre
 ;	4 - rel
 ;	6 - pointeur sur une variable/constante (selon bit 3  0/1)
 ;  dans ce dernier cas, le type est selon le quartet haut de Type :
 ;	0:un pointeur 3 octets		1:une chane de caractre
 ;	2:				3:
 ;	4:sous-programme		5:fentre
 ;	6:				7:
 ;	8:un entier long		9:un entier court
 ;	A:un rel			B:
 ;	C:				D:
 ;	E:				F:
;-Format des objets dans la ZOT
 ; ptr:pointeur en gnral
 ; npt:pointeur normal 2 octets
 ; xpt:pointeur tendu 4 octets
AE	=	0	; xpt sur l'objet mme avec xtn
Len	=	4	; longueur de l'objet en bloc de 8 octets
NxtPZ	=	6	; npt sur la prochaine zone de ptr si l'objet
			;  en contient une
PrvPZ	=	8	; npt sur la zone de ptr prcdente si l'objet en
			,  en contient une
;-Format d'une pile dans la ZOT .
 ; AE,Len,NxtPZ,PrvPZ	; entte
IncLen	=	3	; 1<<(xtn>>1) = incrment de Len si dbordement
StkTop	=	10	; ptr relatif du haut de la pile, (en nombre de xpt)
			;  le bit 0 de xtn est le bit haut de ce ptr.
MinLen	=	12	; taille minimale de la pile (* 8o)
StkLvl	=	14	; chaque niveau de pile est un xpt
;-Format d'un processus (zone de variables globales)
 ; AE,Len,NxtPZ,PrvPZ	: entte
NumStk	=	3	; nombre de piles fixes inclues dans la zone
Progrm@	=	10	; npt sur le code programme du processus (dans la ZOT)
			;  un 0 indique un programme hors ZOT auquel cas cette
			;  zone de la zone s'arrte aprs SavSS
NxtTsk	=	12	; npt sur le processus suivant sur la liste
			;  d'xcution du gestionnaire de tches
PrvTsk	=	14	; npt sur le processus prcdent sur la mme liste
Father	=	16	; npt sur le processus pre
NxtBro	=	18	; npt sur le processus frre suivant
FstSon	=	20	; npt sur le processus fils ain
SavSP	=	22	; sauvegarde des registres pointeur de pile
SavSS	=	24
Status	=	26	;
NumPtr	=	28	; nombre de variables globales de type pointeur
PtrMax	=	30	; npt (relatif  AE) de haut des ptr indpendants
 ;	Et pour chaque pile,
StkPtr	=	32+4n	; ptr en nombre de xpt de pile
StkMax	=	34+4n	; npt (relatif  AE) de l'adresse maximale de la pile
			; minimum = maximum du prcdent
;-Format d'une fentre
 ; AE,Len,NxtPZ,PrvPZ	: entte
Status	=	3
NxtWin	=	10	; npt sur la fentre suivant sur la liste d'affichage
PrvWin	=	12	; npt sur le processus prcdent sur la mme liste
Mother	=	14	; npt sur la fentre mre
NxtSis	=	16	; npt sur la fentre suivante
FstDau	=	18	; npt sur la premire fentre fille
HorzPos	=	20
VertPos	=	22
HorzLen	=	24
VertLen	=	26
Buffer	=	28
	Include	AsmMacro.lib
	Purge	CalcBit,PutBit,GetBit,SetBit,ClrBit,ComBit
	Purge	Max,Min,ljnc,ljc,ljnz,ljz,shri,rori,roli,rcli,rcri
	Purge	PrProcs,CgaLine,Print,Input,GetC,GotoXY
ValToAd	macro	val,ofs,ifz
	clr	ofs
	shr	val,1
	ifnb	<&ifz>
	jz	ifz
	endif
	rcl	ofs,1
	shli	ofs,2
	endm

;  Les commentaires suivant les instructions commenant par ';' dcrivent
; l'action de l'instruction et de celles qui suivent. Ceux commenant par ';;'
; dcrivent la manire de le faire si elle n'est pas vidente o le contenu
; d'un registre qui lui a t affect longtemps auparavant et qui ne doit pas
; avoir t chang (ex: ds=cs, bp=2, etc ) .
	.list
 ;									     ;
 ;				  Initialisation			     ;
 ;									     ;
Init	segment	para public code 'Init'
	assume	cs:Boot,ss:InitStk,ds:Noyau

NewIntVect	dw	Eboueur
NumNewIV	=	($-NewIntVect)/2

Boot	proc	far
	mov	ds,Noyau


	cli

	MsDos	35h,8		;  Placer les interruptions du Noyau OSLm
	mov	IntVect08  ,bx
	mov	IntVect08+2,es
	ldea	dx,TimerInt	;;ds=Noyau
	MsDos	25h,8

	;ici il doit y avoir une initialisation du timer

	MsDos	35h,9
	mov	IntVect09  ,bx
	mov	IntVect09+2,es
	ldea	dx,KeyBoardInt	;;ds=Noyau
	MsDos	25h,9

	sti

	mov	cx,NumNewIV
	mov	aL,40h
	ldea	di,NewIntVect
	ldea	si,IntVect40
SetNewIV:
	MsDos	35h
	mov	[si],bx
	inc	si
	inc	si
	mov	[si],es
	inc	si
	inc	si
	mov	dx,cs:[di]	;;ds=Noyau
	inc	di
	inc	di
	MsDos	25h
	inc	aL
	loop	SetNewIV

 ; Lancer un programme prcis dans les paramtres d'entre, ou , dfaut,
 ;l'diteur/compilateur

Boot	endp
Init	ends
InitStk	segment	word stack 'Stack'
	dw	512 dup (?)
InitStk	ends

 ;									     ;
 ;				      Noyau				     ;
 ;									     ;

;Le rle standard des registres:
 ; ds:si = instruction OSL suivante  xcuter
 ; es:di = pointeur de pile OSLm actuelle dans la zone des variables globales
 ; ss:sp = pointeur de pile systme dans cette mme zone

Noyau	segment	word public code 'Kernel'
	assume	cs:Noyau,ss:Noyau,ds:Noyau,es:Noyau
	public	Eboueur

Data	proc	near
		; Sauvegarde des anciens vecteurs d'interruption
IntVect08	dd	?			; Timer
IntVect09	dd	?			; Keyboard
IntVect40	dd	NumNewIV dup (?)	; Eboueur...

Status		dw	0

KernelStk	dw	7 dup (?)
AfterThat	dw	?	;pile de retour du noyau
Lomem		dw	?	;bas de la ZOT
Himem		dw	?	;limite maximale de la ZOT
ZotTop		dw	?	;limite actuelle de la place libre dans la ZOT
				; o crer le prochain objet
Sysnpt		=	$	;pointeurs npt du systme
ActProcss	dw	?	;processus actuel
ActProgrm	dw	?	;programme actuel	(0:Hors ZOT)
SysnptLen	=	($-Sysnpt)/2
FirstPZ		dw	?	;premire zone de ptr	(0:absente)

EbPZTSR		dw	EsrPile	 ,EsrPrcs ,EsrWndw ,Esr??

Data	endp

Save	proc	near

;**************	      Sauvegarde de l'tat du processus	     ***************;

;le drapeau d'interruption doit tre baiss (cli ou int xx)
;AfterThat doit contenir l'adresse de retour aprs Save
	push	dx		;empiler dx,cx,bx,ax
	push	cx
	push	bx
	push	ax
	mov	ax,ds		;initialiser ds  cs (Noyau), en gardant
	mov	bx,cs		; l'ancien ds dans ax
	mov	ds,bx
	mov	cx,ActProgrm	;ds:si contient le pointeur absolu du code
	ValToAd	cx,bx,Save_HZ	; OSLm. La transformer en adresse relative
	sub	ax,cx
	push	ax		; avant de l'empiler
	sub	si,bx
	push	si
	mov	ax,es		;idem pour es:di, pointant dans la zone des
	mov	cx,ActProcss	; variables fixes du processus
	ValToAd	cx,si
	sub	ax,cx
	push	ax
	sub	di,si
	push	di
	mov	ax,ss		;encore idem pour ss:bp,ss:sp
	sub	ax,cx
	sub	bp,si
	push	bp
	sub	sp,si
Save_End:
	mov	ds,cx
	mov	[si][SavSS],ax
	mov	[si][SavSP],sp
	jmp	AfterThat
Save_HZ:			; Les processi Hors de la Zot doivent rserver
	push	si		;chacun dans la ZOT une zone de renseignements
	push	di		;et de sauvegarde des pointeurs de pile pour
	push	bp		;la bonne marche du gestionnaire de tche.
	push	ax	;(ds)
	push	es
	mov	cx,ActProcss
	ValToAd	cx,si
	jmp	short Save_End
Save	endp

Restore	proc	near

;************		Remise en route d'un processus		************;

;cx contient l'adresse de la zone des variables du processus, ou du pointeur
; sur le processus si celui-ci est hors de la ZOT
	mov	cs:ActProcss,cx
	ValToAd	cx,bx
	mov	ds,cx		;restorer les pointeurs de pile
	mov	ax,[bx][Progrm@]
	mov	cs:ActProgrm,ax
	mov	si,[bx][SavSS]
	mov	sp,[bx][SavSP]
	setf	ax
	jz      Rest_HorsZot	;test d'un programme Hors ZOT
	add	si,cx
	mov	ss,si
	add	sp,bx
	pop	bp
	add	bp,bx
	pop	di
	add	di,bx
	pop	si
	add	si,cx
	mov	es,si
	ValToAd	ax,cx		;est empile l'adresse relative du code
	pop	si		; OSLm. La transformer en adresse absolue
	add	si,cx		; et la placer dans ds:si
	pop	bx
	add	bx,ax
	mov	ds,bx
Rest_End:
	pop	ax		;dpiler ax,bx,cx
	pop	bx
	pop	cx
	pop	dx
	iret
Rest_HorsZOT:
	pop	es
	pop	ds
	pop	bp
	pop	di
	pop	si
	jmp	short Rest_End
Restore	endp

Eboueur	proc	far

;********************	     nettoiement de la ZOT 	********************;

;Efface les objets non points rservant inutilement de la place dans la ZOT.
; Cette procdure doit tre dans une interruption.
; Ses sous-routines utilisent un rle standard pour les registres:
; * Phases 1 et 3
;  es:di indique le pointeur en cours de traitement
;  ax	 est un npt sur la prochaine zone de pointeurs

	ldea	cs:AfterThat,EPhase1
	jmp	Save
	mov	ax,cs		;  Initialise la pile dans Noyau car celle
	mov	ds,ax		; actuellement utilise peut tre dans la
	mov	ss,ax		; Zot et risque d'tre change de place.
	ldea	sp,AfterThat+2	;  La nouvelle pile est place sur AfterThat
	cld			; (transferts vers le haut)

EPhase1	proc	near	;  Passe en revue tous les pointeurs et marque les
			; objets points par un zro dans l'entte (si non
			; nulle, la valeur de l'entte est l'adresse actuelle
			; place par l'Eboueur prcdent)
	mov	cx,SysnptLen	;  Commenons par les pointeurs du systme
	ldea	si,Sysnpt	;;ds=cs
EP10:	lodsw
	ValToAd	ax,di,EP10
	mov	es,ax
	clr	ax
	mov	[di],ax
	loop	EP10		;;FirstPZ n'est pas inclu par cette procdure

	push	NxtPZ
	ldea	dx,EP1SR
	ldea	bp,EbPh1
EbPh1:			;  Passe en revue tous les pointeurs et marque ainsi
			; tous les objets points.
	pop	ax		;;NxtPZ
	ValToAd	ax,di,EPhase2	;  S'il n'y a plus de zones de pointeurs 
	mov	es,ax		; passer en revue, continuer  la phase 2
	clr	ax		;  Marquer la zone comme objet point
	mov	[Value+di],ax
	mov	ax,[NxtPZ+di]	;  S'occuper du reste de l'entte:
	push	ax		; NxtPZ ...
	ValToAd	ax,bx
	mov	ds,ax
	clr	ax
	mov	[bx],ax
	mov	ax,[PrvPZ+di]	; et PrvPZ .
	ValToAd	ax,bx
	mov	ds,ax
	clr	ax
	mov	[bx],ax
	mov	bL,[Type+di]	;  Sauter  la routine correspondant au type
	and	bx,0Eh		; de cette zone de pointeurs.
	jmp	cs:[EbPZTSR+bx]

EP1SR:	mov	ax,[di]		;;modifications permises:ax,ds,si
	ValToAd	ax,si
	mov	ds,ax
	clr	ax
	mov	[si],ax
	ret
EPhase1	endp

EPhase2	proc	near	;  Passe tous les objets en revue pour donner leur
			; nouvelle adresse  ceux marqus.
	inc	sp		;  Dpiler l'adresse d'EboueurPhase1-2
	inc	sp
	mov	bp,cs		;  Initialiser ds  cs
	mov	ds,bp
	mov	ax,Lomem	; et cx comme ptr de l'objet
	; Regarder  partir d'o les objets ne sont plus points
EP20:	cmp	ax,bp		;  Si tous les objets de la ZOT sont points,
	jz	FinEb		; la suite de Eboueur est inutile.
	mov	dx,ax
	ValToAd	dx,di
	mov	es,dx
	add	ax,[Len][di]	;  Calculer l'adresse du prochain objet
	Setf	[di]		;  L'objet est-il marqu ?
	jz	EP20		;  Si Oui, l'adresse reste la mme.

	mov	si,ax		;ptr de la nouvelle adresse de l'objet
	; Regarder  partir d'o les objets sont  nouveau points
EP21:	cmp	ax,bp		;  Si tous les objets ont t vus, seul un
	jz	EP22		; changement de ZotTop s'impose.
	mov	dx,ax
	ValToAd	dx,di
	mov	es,dx
	add	ax,[Len][di]	;  Calculer l'adresse du prochain objet
	Setf	[di]		;  Si l'objet n'est pas marqu, continuer car
	jnz	EP21		; la zone est toujours la mme.
	push	ax		;  Empiler l'adresse trouve

	; Pour tous les autres objets, calculer la nouvelle adresse (ax)
	mov	cx,ax		;;Maintenant, si:nouvelle Ad et cx:Ad actuelle
	clr	ax		;;et ax:longueur le l'objet
EbPh2:	add	cx,ax		;  Calculer l'adresse du prochain objet
	cmp	cx,bp		;  Quand tous les objets ont t passs en
	jz	EPhase3		; revue, passer  la Phase 3
	mov	dx,cx
	ValToAd	dx,di
	mov	es,dx
	mov	ax,[Len][di]	;;Vitesse d'accs (ax,mem) = 2 V.acc (reg,mem)
	Setf	[di]		;  L'objet est-il marqu ?
	jnz	EbPh2		;  Si Oui, lui donner une nouvelle adresse
	mov	[di],si		; et rajouter sa longueur au pointeur de
	add	si,ax		; nouvelle adresse pour les objets suivants.
	jmp	short EbPh2
EPhase2	endp

EP22:	mov	ZotTop,ax
FinEb:	jmp	Restore		;  Il serait mieux dans un second temps de
				; tester si la tche affecte va changer juste
				; aprs, ce qui gagnerait le temps d'un
				; Restore, d'une interruption, et d'un Save.

EPhase3	proc	near
	push	bp		;  Sauver l'ancien ZotTop
	mov	ax,si		;  Sauver le nouveau ZotTop
	mov	cs:ZotTop,ax
	mov	cx,SysnptLen	;  Commenons par les pointeurs du systme
	ldea	si,Sysnpt	;;ds=cs
	push	FirstPZ
EP30:	lodsw
	ValToAd	ax,di,EP30
	mov	es,ax
	mov	ax,[di]
	mov	[si],ax
	loop	EP30
	ldea	dx,EP3SR
	ldea	bp,EbPh3
EbPh3:			;  Passe en revue tous les pointeurs et leur donne
			; leur nouvelle valeur
	pop	ax		;;ptn sur la prochaine zone de pointeurs
	ValToAd	ax,di,EPhase4	;  S'il n'y a plus de zones de pointeurs 
	mov	es,ax		; passer en revue, continuer
	mov	ax,[NxtPZ+di]
	push	ax
	ValToAd	ax,si
	mov	ds,ax
	mov	ax,[si]
	mov     [NxtPZ+di],ax
	mov	ax,[PrvPZ+di]
	ValToAd	ax,si
	mov	ds,ax
	mov	ax,[si]
	mov     [PrvPZ+di],ax
	mov	bL,[Type+di]	;  Sauter  la routine correspondant au type
	and	bx,0Eh		; de cette zone de pointeurs .
	jmp	cs:EbPZTSR[bx]

EP3SR:	mov	ax,[di]		;;modifications permises:ax,ds,si
	ValToAd	ax,si
	mov	ds,ax
	mov	ax,[si]
	mov	[di],ax
	ret
EPhase3	endp

EPhase4	proc	near		;  Dcale tous les objets ayant une nouvelle
				; adresse.
	pop	bp		;;ancien bp
	pop	dx		;;ptr de l'objet  transfrer (cf Phase 2)
	clr	ax
EbPh4:	add	dx,ax
	cmp	dx,bp
	jz	FinEb
	mov	ax,dx
	ValToAd	ax,si
	mov	ds,ax
	mov	ax,[si]
	ValToAd	ax,di,EbPh4
	mov	es,ax
	mov	ax,Len[si]
EP40:	test	aH,0F0h		;  Dplacer l'objet par blocs de 32 Ko
	jz	EP41
	mov	cx,4000h
	rep	movsw
	mov	dx,ds
	add	dx,800h
	mov	ds,dx
	mov	dx,es
	add	dx,800h
	mov	es,dx
	and	di,8
	and	si,8
	sub	aH,10h
	jmp	short EP40
EP41:	mov	cx,ax
	shli	cx,2
	and	cx,3FFFh
	rep	movsw
	jmp	EbPh4
EPhase4	endp

EbXpt	macro
	local	EXN
	mov	aL,[Type+di]
	setf	aL
	js	EXN
	call	dx
	EXN:
	endm

EsrPile	proc	near
	mov	ax,[StkTop+di]		;;!:doit prserver bp,dx
	mov	bH,aH			;;!:[dx] utilise ax,si,ds
	and	ax,1FFFh
	push	ax
	mov	aL,[xtn+di]
	add	di,StkLvl
	shr	aL,1
	rcr	bH,1
	shri	bH,4
	jz	EPile3
EPile1:	mov	cx,2000h
EPile2:	EbXpt
	add	di,4
	loop	EPile2
	sub	di,8000h
	mov	ax,es
	add	ax,800h
	mov	es,ax
	dec	bH
	jnz	EPile1
EPile3:	pop	cx
EPile4:	EbXpt
	add	di,4
	loop	EPile4
	jmp	bp
EsrPile	endp

EsrPrcs proc	near
	mov	aL,[NumStk+di]	;;!:doit prserver bp,dx
	mov	bL,aL		;;!:[dx] utilise ax,si,ds
	add	di,Progrm@	;  Remise  jour des 6 pointeurs suivants:
	mov	cx,6		; Progrm@,NxtTsk,PrvTsk,Father,NxtBro,FstSon
EPrcs1:	call	dx
	inc	di
	inc	di
	loop	EPrcs1
	add	di,NumPtr-(FstSon+2)	;;maintenant,di=NumPtr
	mov	cx,[di]
	mov	ax,[di+2]		;;PtrMax
	push	es
	push	di
	clr	bH
	push	bx
	shl	bx,1		;;chaque pile prend 4 octets dans la zone
	shl	bx,1		;;de description du processus
	add	di,bx		;  S'occuper des variables globales de type
	and	cx,1FFFh
	push	cx
	mov	aL,[xtn+di]
	add	di,StkLvl
	shr	aL,1
	rcr	bH,1
	shri	bH,4
	jz	EPile3
EPile1:	mov	cx,2000h
EPile2:	EbXpt
	add	di,4
	loop	EPile2
	sub	di,8000h
	mov	ax,es
	add	ax,800h
	mov	es,ax
	dec	bH
	jnz	EPile1
EPile3:	pop	cx
EPile4:	EbXpt
	add	di,4
	loop	EPile4

	pop	cx
	pop	di
	pop	es
EsrPrcs	endp

EsrWndw	proc	near
	add	di,NxtWin	;  Remise  jour des 5 pointeurs suivants:
	mov	cx,5		; NxtWin,PrvWin,Mother,NxtSis,FstDau
EPrcs1:	call	dx
	inc	di
	inc	di
	loop	EPrcs1		; c'est tout !
	jmp	bp
EsrWndw	endp
Esr??	proc	near
	jmp	bp
Esr??	endp

Eboueur	endp

Noyau	ends

 ;									     ;
 ;				Routines du langage			     ;
 ;									     ;

Instructions	segment	byte public code 'code'

;Instruction_Typique	proc	near
;	...
;	cli
;	...
;	sti
;	...
;	lodsw
;	jmp	ax
;Instruction_Typique	endp

Instructions	ends

 ;									     ;
 ;				   Compilateur				     ;
 ;									     ;

Compiler	segment	byte public code 'code'
NameBuffer	db	256 dup (?)
Compiler	ends
	end	Boot