/*
  Fichier "PJI.C"
  Rdaction commence en aut 1991 .
  Le fichier "PJI1.C" complte celui-ci
*/

/*
@-----------------------------------------------------------------------------
-------------------------- PROJET DE JEU INFORMATIQUE ------------------------
---------------------  rattacher au projet d'environnement ------------------
------------------------------------------------------------------------------

Objet: Ce projet est celui d'un grand jeu informatique qui devra marquer
-----  les mondes ludiques et informatiques par son originalit, sa diversit,
et sa ralisation minutieuse, consciencieuse et efficace ; tout autre jeu
devra paratre fade aprs celui-ci .
			Aut Caesar, aut nihil .

Grandes lignes: Le jeu informatique propos se prsente d'apparence comme
-------------- un jeu d'aventure de qualit, comme les diteurs de jeux savent
(presque) dj en faire . Mais il comprendra aussi :
* une gestion complte et complexe des actions des personnages du jeu par des
 programmes d'intelligence artificielle ;
* une mise en abme de l'ordinateur, ce qui permettra d'inclure au jeu
 d'aventures proprement dit des jeux dans le jeu , jeux d'arcade, etc ;
* des graphismes, sons et animations de qualits pour un jeu  un rythme
 vous couper le souffle, dont on aura quand mme besoin pour ce jeu de
longue haleine ;
* et bien sr un scnario bien ficel avec de multiples retournements de
 situation .

-------------------------------- SOMMAIRE ------------------------------------
SOMMAIRE

INTRODUCTION
 * Historique
 * Ide de base

I - LE SCENARIO
 * Synopsis

II - LE CONTENU DE L'ORDINATEUR
 * Remarques gnrales
 * Note
 * Dtails - dans le fichier "PJI1.C"

III - LE MONDE ARTIFICIELLEMENT INTELLIGENT

APPENDICES

A - NOTE SUR LA PROGRAMMATION
 * Programmation modulaire
 * Intelligence artificielle

B - CONSEILS POUR LA DIFFUSION
 * Protection du logiciel
 * D'auteur  utilisateur

@------------------------------ INTRODUCTION ---------------------------------

** HISTORIQUE
  L'ide du jeu a mri depuis l'ide de la mise en abme de l'ordinateur et
de ses logiciels, apparue en troisime (1986-1987) avec l'intention de la
plonger dans une histoire d'espionnage, suivie en seconde (1987) du squelette
de l'intrigue, avec le projet de personnages artificiellement intelligents, et
de la recration d'une ville, puis, en 1988, un approfondissement du scnario
et du projet d'I.A., jusqu' sa reprise actuelle, avec une complexification du
scnario .
  Durant ce temps, l'ambition du jeu a d'abord chu, abandonnant le projet
d'intelligence artificielle trop lourd pour le vieil Apple II de l'poque, et
mme pour le compatible PC XT, puis a cru  nouveau, le jeu n'tant qu'un
projet destin  crer toujours des mondes imaginaires, que les ordinateurs
et les programmeurs actuels aient ou non la puissance et la technique
ncessaire pour le programmer effectivement .

** IDEE DE BASE
  Le jeu sera une sorte de jeu d'aventure d'espionnage et d'enqute o le
hros-joueur devra notamment trouver une grande partie de ses informations
indispensables au bon droulement de la suite de la partie sur un ordinateur
totalement simul (ou plusieurs), dont il devra dplomber les programmes. La
partie dplombage sera ventuellement didactique grce  l'aide d'un
personnage du jeu .
   Un autre point important du jeu est une gestion complexe et complte au
possible des personnages autres que le ( ou les ! ) joueurs ( abrg par PNJ
ultrieurement, pour Personnages Non Joueurs ), du moins ceux ayant un rle
crucial, par un programme d' I.A. (intelligence artificielle) tournant
simultanment pour chacun des personnages principaux, selon des grandes
lignes du scnario, tenant compte de ce qu'est cens faire le joueur (1) .
  Le dernier point, moins important, est la visualisation tridimensionnelle
des dcors, avec des images digitalises peut-tre, et si possible des rues
notamment bien dessines avec des passants,  comme si on y tait  , et des
personnages principaux ou secondaires qui se dplacent et paraissent vrais .
  Optionnellement, la possibilit de jouer simultanment plusieurs
personnages lors de la mme partie sur des ordinateurs diffrents relis
entre eux a t envisage . Elle ncessitera alors une refonte du scnario et
une lision de la partie dplombage .

- P.S.
  Ce projet manque parfois volontairement de dtails : comme il n'est pas
prvu de le mener  terme actuellement, ces dtails demanderaient une tude
plus approfondie quant  la pertinence de chacun et  la possibilit
effective de le mettre en oeuvre durant une programmation actuelle du jeu,
de par l'volution des techniques de programmation en I.A. particulirement .

- Note
(1) Les tests avant diffusion du jeu permettront de rajouter aux situations
typiques prvues initialement dans le scnario celles dans lesquelles auront
tendance  se mettre les joueurs participant aux tests .


@@----------------------------------- I --------------------------------------
------------------------------- LE SCENARIO ----------------------------------

** SYNOPSIS
   Tout se passe dans une ville (1), capitale de l'tat correspondant, o un
 professeur de l'universit et/ou du lyce (les deux pouvant ne faire qu'un),
 informaticien amateur, a russi  s'introduire dans des fichiers secrets de
 l'tat et/ou de l'tat rival . Ces fichiers impliquent notamment le chef des
 services secrets . Mais celui-ci en vient  apprendre le fait (2) et fait
 enlever (3) le professeur qui a un rendez-vous avec lui ou un agent honnte
 des services secrets, et ce, par le seul agent disponible  temps, le
 personnage joueur (PJ). Mais celui-ci n'est pas  la solde de l'ennemi et
 devient vite une cible pour les agents ennemis qui arrivent sur place ou se
 librent d'autres obligations (d'autres affaires lies  celle-ci, qui les
 ont empch d'tre disponibles  temps) quelques heures plus tard .
   Seulement, le professeur, ayant un rendez-vous familial important, ou tout
 autre obligation prvue de longue date, a envoy son ami et collgue en sa
 place, ci fait que le professeur assassin n'est pas celui qui a tout trouv,
 qui lui se terre dans un coin  l'annonce de l'enlvement . Le chef (et
 peut-tre le PJ) dcouvrira le pot-aux-roses en enqutant sur la personne
 enleve, qui aura pu succomber  une dose trop forte de srum de vrit
 injecte par le chef dans un moment de frnsie (pour tre gentil, on peut
 dire que la victime est seulement trs malade, vanouie, et incapable de
 parler pour un certain temps), et enverra ses sbires  la poursuite du vrai
 professeur . Le rpit ainsi gagn est le temps imparti au PJ pour mener son
 enqute personnelle, quand il aura compris (s'il le comprend avant de mourir)
 que l'on en veut  sa vie pour sa participation  cette affaire .
   Pour compliquer les choses, un extraordinaire hasard fait qu'il y a eu un
 tmoin inopin et non remarqu  l'enlvement du professeur, ci-fait que le
 signalement de l'auteur du rapt (le PJ) est donn  toutes les polices et
 bientt  tous les journaux (sauf si celui-ci s'est dguis par prcaution).
 Le PJ devra alors courir contre la montre pour dcouvrir l'affaire, avant de
 se faire attraper par la police ou par son service, qui prfrerait
 l'attraper lui-mme pour viter des fuites, et s'arrange pour que la police
 reoive des instructions de tir  vue . Ces instructions peuvent tre
 justifies par la prsence de terroristes dangereux menant une vague
 d'attentats meutriers dans la capitale ( les motivations des terroristes
 tant lies indirectement  l'affaire : terroristes manipuls par l'tat
 voisin ennemi ou rival, qui aura corrompu ou non le chef des services ;
 terroristes aux motivations personnelles, rvolts par une affaire dans
 laquelle est implique le chef des services ou son corrupteur ... ) , ou par
 l'existence d'un dangereux tueur en srie qui enlve ses victimes avant de
 les torturer ; ce dernier prtexte ayant pu tre dj utilis pour maquiller
 le meutre d'un agent honnte au courant de l'affaire, celui contact par le
 professeur, par exemple la secrtaire du chef des services secrets (4) .
   Les pistes qui se prsenteront au joueur seront multiples : se sachant
 poursuivi, le PJ pourra tenter non seulement d'chapper  ses poursuivants,
 mais aussi de les attrapper  son tour, et de remonter la filire ainsi ,
 mais il ne pourra pas trouver de preuve tangible ce faisant,  part sa mort ;
 il pourra aussi s'interesser  la victime de l'enlvement, enquter sur les
 raisons qui le rendaient dangereux aux yeux de son chef, et ainsi doubler les
 agents ennemis aux mthodes moins subtiles, trop srs d'eux-mmes, pas assez,
 ou simplement moins intelligentes . Pour lui apporter des lments nouveaux,
 la presse crite et/ou audiovisuelle du jour lui sera utile (5), l'aidant 
 localiser d'autres personnes dont des assassins ou terroristes en cavale et
 les forces de police, mais aussi les invits de diners mondains , lui
 permettant de communiquer par code avec des correspondants mystrieux ou non,
 et/ou d'intercepter de telles communication , lui donnant des indices dans
 des dtails apparemment anodins ou dans des photos . Il pourra aussi visiter
 l'htel de police ou l'hpital, o travaille les gens s'occupant des meurtres
 dans la ville, dont ceux lis  l'affaire, sous l'identit d'un journaliste
 ou d'un proche d'une victime ; il pourra aussi interroger les vrais proches
 des victimes, inspecter les lieux des crimes pour y dceler des indices
 insouponns, tenter de lire des documents normalement secrets, aller voir
 des contacts ou des suspects, espionner des individus louches ou les
 questionner .

 - la fille du prof est courtise par un jeune agent ambitieux des services
  qui se rvlera tre  la solde du chef, aprs avoir peut-tre sembl aid
  le PJ, mais qui n'est pas au dbut au courant .
 - les enfants du prof' pourront tre enlevs pour faire chanter
 - le prof' peut finalement n'avoir eu aucune preuve relle, que ce soit lui
  ou un autre qui les ait forge ; le tout n'tait qu'un coup pour forcer les
  corrompus  se dcouvrir . Alors, peut-tre ceux qui sont derrire tout a
  sont-ils des agents honntes ; mais peut-tre sont-ce d'autres agents
  corrompus ou trangers cherchant  destabiliser les services secrets en
  place pour les remplacer, leur chapper, ou destabiliser l'tat entier .
  Cette affaire rejoindra alors celle des terroristes, qui ont pu tre mani-
  puls par les mmes personnes .
 - selon la personnalit du PJ, les solutions seront diffrentes, les divers
  acteurs pouvant tre rangs au cts du PJ ou neutraliss par la violence,
  la menace, ou la persuasion .

- Notes sur le scnario
 (1) Si le joueur tente d'en sortir, un message s'affiche :  Je ne peux pas
  quitter la ville ainsi, mme s'il est tentant de fuir ; je dois tirer cette
  affaire au clair d'abord. De toute faon, si je m'enfuis, mon service me
  retrouvera tt ou tard, et je devrais rpondre de ma conduite .. Si le
  joueur insiste, malgr les tats de conscience du personnage, il ne pourra
  aboutir qu' la malemort, ou toute fin peu digne d'un hros.
 (2) Le professeur tente de prvenir les services secrets, et a pris contact
  avec un agent qu'il sait honnte . Mais un agent corrompu proche de ce
  dernier (ou du premier !) a tout dcouvert et prvient le chef des services
  (si ce n'est lui-mme) qui dcide d'intercepter le rendez-vous pris pour
  transmettre tous les documents (le chef a reu l'assurance qu'il n'y avait
  pas de copie)
 (3) Le scnario original prvoyait une xcution pure et simple, mais il
  parat improbable que le chef ft assez sr de lui pour assassiner le
  professeur sans l'interroger avant pour s'assurer de la non-existence
  d'autres preuves de sa corruption ou d'autres personnes au courant de la
  chose . De plus, il vaut mieux que le hros ne soit pas un assassin .
 (4) On peut envisager d'introduire un autre joueur grce  ce prtexte :
  enqutant sur les crimes en srie, un dtective suit les indices du crime
  maquill et se trouve impliqu dans l'affaire .
 (5) Pour ne pas avoir  compliquer inutilement le programme d'I.A., permettre
  de concentrer la programmation et le jeu sur l'action et maintenir du coup
  le rythme oppressant du jeu, toute l'affaire est cense se drouler trs
  vite, s'talant sur un, deux ou trois jours au plus . Pour  s'assurer de la
  chose, on pourra faire que le PJ soit bless en dbut de partie par les
  hommes du chef, et que perdant son sang ou tant empoisonn, il succombera
  des suites de ses blessures s'il ne se rend pas assez vite  l'hpital, o
  il est attendu par les hommes du chef, ainsi ventuellement que la police,
  qui sera de toutes faon prvenue des soins donns  un criminel recherch
  et/ou  une personne blesse par balles .




@@---------------------------------- II --------------------------------------
------------------------ LE CONTENU DE L'ORDINATEUR --------------------------


** REMARQUES GENERALES
  L'ordinateur contient  la fois des jeux et des programmes de travail . Et
il faudra parfois vaincre les premiers pour accder aux seconds : des codes
sont livrs subrepticement et plus ou moins volontairement au cours d'un jeu,
 son dbut ou  sa fin ; les hi-scores livrent le nom, le pseudonyme ou les
initiales d'un contact du propritaire de l'ordinateur ; certains programmes
de jeux sont une faade pour des programmes plus srieux ( peut-tre y
aura-t-il une mise en abme du principe du jeu ! ) ; le dplombage d'un
certain jeu, plus facile que celui d'un programme srieux, car antrieur,
mais du mme auteur, permettra de comprendre le fonctionnement de l'autre et
de le dplomber  son tour ; une partie d'un programme de jeu sert  coder
et dcoder des messages, qui sont sur le mme format cod que celui d'un
programme confidentiel ; une image subliminale glisse dans une animation
rvle des informations confidentielles ; un jeu dj dplomb simulera une
cl informatique, ce qui, utilis avec un logiciel professionnel, permettra
d'accder  des informations protges ; une image digitalise rvlera un
dtail sur l'endroit o l'image a t prise ; la date d'un document prouvera
l'intervention d'une personne qui tait cense avoir disparu o tre morte,
ou d'une autre en sachant assez sur la premire pour prendre sa place auprs
de l'ordinateur ...
  Bien sr, il manquera au joueur la disquette-cl du propritaire de
l'ordinateur, qui contient les codes et toute la solution ; mais cette
disquette aura t vole dans le jeu, ou emporte par celui-ci . Elle
sera remise au joueur qui aura termin le jeu, si bien que tous les
programmes proposs dans l'ordinateur, jeux, langages, outils, pourront tre
utiliss  part du jeu principal grce  un code . On pourra mme trouver des
applications pratiques aux modules conus pour le jeu : agenda interactif
( il y en a un par PNJ ), systme de dveloppement ( celui de l'ordinateur
intrieur, qui pourra tre le systme projet, ou du moins son noyau Forth
objet avec une interface rudimentaire mais extensible car paramtrable ),
gestion de bases de donnes relies ( de mme que celles utilises pour
simuler l'acquisition de connaissances par les PNJ ), personnalisation des
programmes et systme multiutilisateur ( de mme que certains modules
considrent galement, simultanment et indiffremment PNJs et PJs, tout en
laissant transparatre leur diffrence, grce  des paramtres extrieurs
dpendant de la personne concerne ), etc .

** NOTE : dans la suite du texte, on qualifiera d'interne ce qui ce passe 
l'intrieur de l'ordinateur simul, que le personnage joueur (PJ) utilise,
et d'externe ce qui ne s'y passe pas, notamment ce qui se passe dans le jeu et
l'ordinateur rel, mais pas dans l'ordinateur simul (bien faire attention 
la mise en abme de l'ordinateur) .

** DETAILS
 voir le fichier "PJI1.C"

@@---------------------------------- III -------------------------------------
------------------ LE MONDE ARTIFICIELLEMENT INTELLIGENT ---------------------


-------------------------------- APPENDICES ----------------------------------

@@----------------------------------- A --------------------------------------
--------------------- NOTES SUR LA PROGRAMMATION DU JEU ----------------------

** PROGRAMMATION MODULAIRE
  Un jeu aussi gigantesque ne peut tre conu et mis en oeuvre que de faon
modulaire ; citons, par ordre croissant d'loignement de l'utilisateur :
l'interface graphique, le module de dessin 3D et celui de dessin des PNJ,
le module d'affichage des actions, celui de gestion des actions reconnaissant
les actions spciales, celui de communication des actions entre les modules
de dcision et ceux d'acquisition ou de transmission des donnes, ceux de
dcision en question, notamment le module d'I.A. dirigeant les PNJ , ceux
d'acquisition de connaissance pour les PNJ, et enfin celui de la gestion de
toute cette masse de donnes dynamiques dans la mmoire, sans compter les
modules d'animations spciales, les modules auxiliaires comme l'aide au joueur
et l'enregistrement de la partie pour la visionner ultrieurement, les modules
de gestion de l'ordinateur mis en abme, et tous ceux correspondant aux
programmes de cet ordinateur ...

** INTELLIGENCE ARTIFICIELLE
  Un module spcial grera les PNJ principaux les uns par rapport aux autres
et  d'autres PNJ importants ainsi qu'au personnage joueur . Il tiendra compte
d'un jugement toff de chacun envers chaque autre, ainsi que de l'humeur de
chacun au cours d'un dialogue ou d'un change quelconque d'actions entre deux
personnages , ce qui ncssite une grande bibliothque de vocabulaire pour
tout ce que le personnage joueur pourra entendre . Il tiendra aussi compte
de ce que sait ou croit savoir chaque personnage sur l'intrigue et l'action
des autres personnages au cours du jeu, ce qui peut voluer de diverses
manires selon l'action du joueur .

@@----------------------------------- B --------------------------------------
----------------------- NOTES SUR LA DIFFUSION DU JEU ------------------------

** PROTECTION DU LOGICIEL
  Le programme externe devra aussi tre protg, pour que le joueur ne puisse
pas tricher en lisant la suite de l'aventure . Un procd efficace sera le
codage systmatique des chanes de caractres des programmes externes avec le
procd de Huffman, et un codage par XOR et par additions successives des
donnes correspondant aux programmes internes ; les fichiers externes de
donnes devront avoir des noms peu rvlateurs .
  Si l'diteur est foncirement anti-pirate, et que le jeu prend vraiment
beaucoup de place sur dans la mmoire de masse, il pourra vendre le jeu sous
forme de mmoire de masse incopiable, cartouche, disque fixe, CD-ROM, module
 connecter  l'interface srie ou rseau ; mais ces mthodes sont mchantes
et onreuses, et de toute faon l'auteur les dsapprouve par principe, tant
pour la librt de copie et la diffusion directe d'auteur  utilisateur . Ce
que l'on pourra faire plutt, c'est sortir un nouvel ordinateur tel que le
systme interne de l'ordinateur du jeu soit le systme externe de l'ordinateur
rel, pour lequel sortira d'autres logiciels, jeux du mme acabit, ou
logiciels de crativit personnelle ( que les entreprises appellent de
productivit professionnelle ); ce projet rejoindra alors Le Projet ( voir le
fichier "Projet.c" ) .

** D'AUTEUR A UTILISATEUR
  Le joueur peut demander une aide externe . Pour cela, il dispose d'un
capital de points, qui ne remonte pas quand il recommence une partie (il en
est prvenu) . Pour le remettre au maximum quand il est  zro, il peut
envoyer 20FF  l'auteur qui lui envoie un code (qui ne marche qu'une fois),
et ainsi de suite . Un joueur assidu aura des rductions ( 20FF pour deux
codes  la troisime fois, etc ) . L'auteur pourra aussi lui proposer de
nouveaux produits, dialoguer avec les meilleurs joueurs, tablir un
classement . Il pourra enregistrer les pirates moyennant 50FF, remboursables
 l'achat de l'original (ouille!) . Enfin, ceux qui auront fini le jeu et qui
auront t enregistrs lui enverront un mot pour qu'il leur donne les codes
finaux permettant l'utilisation du systme interne  volont, hors du jeu .
Etant pour l'change des listing source et l'encouragement  la programmation,
il pourra aussi organiser des rencontres programmatiques .
  En tenant compte de ces revenus auxiliaires, le prix public du logiciel
pourra tre ramen  50FF ou 100FF . De plus, un concours ouvert pourra tre
men parmi les joueurs, pour celui finissant le plus vite le jeu ( un module
chronomtre pourra tre intgr au jeu pour dpartag les joueurs qui
renverront leur rsultat dans un fichier dcrivant l'historique de leur
partie ) ; on pourra mme publier les meilleures parties ; le module
d'enregistrement de la partie sera alors un morceau autre de bravoure du
programmeur .


*/
/*
 Pour voluer dans le texte, chercher :
 @@   pour aller au chaptre suivant,
 **  pour aller  la partie suivante du chaptre .
 @  pour aller au paragraphe suivant .
*/


















