/*
 Fichier "PJI1.C"
 Commenc le 25 aot 1991
 Ce fichier est une suite du fichier "PJI.C"
*/
/*
@------------------------------- SOMMAIRE ------------------------------------
NOTES PRELIMINAIRES
 * Restrictions possibles du scnario
 * Note familiale
 * Ce qu'il y a  trouver

I - PRESENTATION DE L'ORDINATEUR
 * Aspect de l'interface logicielle
 * Note externe
 * Description du noyau Forth
 * Description de l'interprteur
 * Commandes de l'interprteur
 * Interface Graphique

II - LE CONTENU DE L'ORDINATEUR DU PROF
 * Arbre des rpertoires
 * Les enfants
 * Les jeux
 * Hroca
 * Les loisirs
 * Le travail
 * Le secret
 * A Caser

III - LA CHAMBRE DU HUIS-CLOS
 * Liste des objets de la pice
 * Les magazines informatiques

@-------------------------- NOTES PRELIMINAIRES ------------------------------

  Ce fichier se concentre sur l'ordinateur du professeur qui contient des
informations confidentielles protges sur lesquelles le joueur doit faire
main basse .

** RESTRICTIONS POSSIBLES DU SCENARIO
  Dans une version rduite du jeu, et donc plus facilement ralisable, mais
dont la ralisation  part amputerait celle du jeu entier , on pourrait se
limiter  cet aspect du jeu, qui a aussi l'avantage de ne pas ncessiter un
gros effort en intelligence artificielle, et par l en intelligence tout
court du ou des programmeurs .
  Le PJ se retrouvera donc seul face  l'ordinateur du professeur, sans la
disquette cl, mais avec son courage et sa perspicacit pour toute arme ; son
temps est compt en heures . Ceci peut constituer le seul scnario du jeu,
ou peut s'inscrire dans celui plus gnral prsent dans le fichier
prcdent .
  Dans la version restreinte du jeu, une brve introduction pourra ainsi
suffir . Tout ou presque se passera alors  huis clos . La (petite) chambre
sera dessine en trois dimension ; on pourra la fouiller et y trouver des
objets divers dont la plupart paratront insignifiant, mais dont certains
seront trs important : caf pour se tenir veill, chane hifi au rle
essentiel, morceaux de mtal divers pour servir de contact lectrique, manuel
de l'ordinateur ...
  Bien sr, tout ce qui est dit ici peut tre repris dans une version plus
largie du jeu .

  Du point de vue de la liaison avec le reste du scnario, l'on peut
considrer que le PJ s'est introduit dans la maison du prof'  l'insu de la
famille, pendant que celle-ci se trouve dans une soire pour une fte
quelconque, ou bien que celle-ci a t massacre pou enleve par le Chef des
services . Il serait dommage de faire en sorte que la famille soit au courant
et d'accord pour que le PJ tripatouille l'ordinateur, car alors Annette et
Gilles pourraient aider le PJ, ce qui serait regrettable .

@
** NOTE FAMILIALE
  Annette et Gilles sont les plus jeunes enfants du professeur . Gilles a 14
ans et Annette en a 11 . Tous deux apprennent l'informatique sur la machine de
Papa quand il ne l'utilise pas . Celui-ci ne l'utilise notamment pas quand il
est au bureau, o il dispose d'un ordinateur plus puissant, mais o il ne
peut pas crire ce qu'il veut, et dispose de moins de confidentialit, puisque
n'tant pas chef de service, il n'a pas le niveau de priorit maximum sur la
machine . Maman n'a pas la mme passion pour l'informatique, qu'elle ddaigne
royalement .

@
** CE QU'IL Y A A TROUVER
  Le professeur n'a aucun document en tant que tel dans son ordinateur ; il a
seulement, et encore en puissance, les codes ncessaires pour se brancher sur
divers rseaux plus ou moins bien protgs, ainsi qu'un journal de son
introduction dans ces rseaux dcrivant ses dcouvertes successives ; les
documents tlchargs ne sont pas des preuves en soi, c'est pourquoi si le
professeur en a fait une copie sur une disquette que le personnage joueur ne
dtient pas, il ne les a pas gard sur la mmoire de fixe de son ordinateur .
Nanmoins, les numros de ces documents et les informations qu'ils contiennent
permettraient de runir aisment les preuves en question, si un appui
administratif est apport ; c'tait d'ailleurs l'objet des dmarches du prof'
de chercher cet appui, dont on sait qu'elles ont chou et pourquoi .
  Il s'agira donc pour le PJ de retrouver ces documents pour pouvoir les
remettre  des autorits comptentes et sres, ou les publier le cas chant,
afin de dclencher finalement une enqute qui aboutira pour faire cesser les
sombres agissements dcouverts (si le PJ s'y prend mal, l'enqute aura bien
lieu mais s'enlisera, et il aura perdu) .
  Pour l'instant, toutes ces donnes sont protges et caches dans
l'ordinateur du professeur, et le PJ doit concentrer ses efforts sur celui-ci
dans l'espoir de mettre la main dessus .


@------------------------------------ I --------------------------------------
------------------------ PRESENTATION DE L'ORDINATEUR ------------------------

  De manire interne, l'ordinateur est un modle Pactariga, fabriqu par le
clbre constructeur national Comapplaqatarmodorie, et quip de l'universel
systme jv8734ovc, qui est une sorte de Forth orient objet multitche
mono-utilisateur, dot de plus d'un interprteur en notation normale non
("polonaise") inverse hrit du maintenant vieux modle g2l734oq .
  L'aspect mono-utilisateur est important: comme le systme ne gre pas
lui-mme l'existence de plusieurs utilisateurs, ce sont des accessoires
extrieurs au noyau qui le grent; et chacun doit crer sa propre protection
de ses donnes; c'est ainsi que le PJ pourra s'introduire dans les failles du
systme.

** ASPECT DE L'INTERFACE LOGICIELLE INTERNE
  Dans une fentre de l'cran apparait une pile d'objets, tandis que dans une
autre, en gnral situe en dessous et rduite  une ligne, se trouve une
ligne de commande pouvant tre en mode Forth ou interprteur (par change de
fentres, les deux pouvant tre affiche en mme temps au cas chant) . La
fentre de commande ( dont on peut changer les dimensions ) agit comme un
tltype (cran qui dfile) d'ordinateurs classiques, et est en effet hrit
de modles antrieurs compatibles . A la souris ou au clavier, on se promne
dans un arbre de rpertoires, auxquels on a pas tous accs ; on peut ainsi
slectionner le rpertoire courant ou lancer des programmes d'un rpertoire
quelconque,  condition d'y avoir accs ; certains rpertoires ne donnent mme
pas accs aux noms des fichiers contenus .
  Toutes ces fentres peuvent bien sr tre fermes, dplaces, modifies en
dimension, et mme dupliques .
@
** NOTE EXTERNE
  De temps en temps, une bulle apparat, dlivrant un message interne au jeu,
mais externe  l'ordinateur . Le joueur peut de mme la faire apparatre pour
donner des ordres au jeu autres que frapper le clavier de l'ordinateur .
@
** DESCRIPTION DU NOYAU FORTH
  Voir le fichier "Projet.c"
@
** DESCRIPTION DE L'INTERPRETEUR
  Voici comment l'interprteur ragit .
* Instructions
  L'interprteur considre qu'une instruction est compos d'un nom de
commande ou de fichier, ventuellement suivi de paramtres, le tout
pouvant tre mis entre parenthses .
  Les paramtres sont en nombre fini dfinis avec le nom de la commande .
On peut remplacer les paramtres par les lments successifs de la pile
allant avec la tche lanant l'instruction, par le symbole $ pour remplacer
un paramtre, $n o n est un nombre pour remplacer n paramtres, $$ pour
remplacer tous les paramtres .
@
* Liaisons
  Chaque tche doit communiquer d'une manire indirecte ses rsultats 
l'utilisateur du systme (sinon, elle n'aurait aucun intrt), et donc les
communiquer de manire directe  une autre tche ou  un priphrique de
sortie (cran, imprimante, etc) . De mme, elle doit prendre ses donnes de
base quelque part, sinon, elle ferait toujours la mme chose et n'aurait
besoin d'tre lance qu'une fois pour toute (ce qui est possible) ; aussi,
devra-t-elle le plus souvent recevoir indirectement des donnes communiques
par l'utilisateur, c'est  dire directement d'une autre tche ou d'un
priphrique d'entre (clavier, souris, etc) .
  L'interprteur devra donc tre capable de lier diverses tches entre elles
d'aprs les instructions fournies .
  C'est pourquoi on dfinira trois symboles :
- le symbole "<<" plac entre deux instructions sert  indiquer que la
premire entre disponible de l'une sera nourrie par la premire sortie de
l'autre . On pourra suivre le symbole d'un ou deux chiffres ou noms dsignant
l'entre ou la sortie qui ne serait pas la premire disponible de la commande,
la virgule prcdant l'identificateur de la sortie ; plusieurs couples lis
d'entres et sorties peuvent tre prciss, spars par le symbole ";" .
  Le tout formera une nouvelle instruction dont les autres liaisons prcises
correspondront  la premire instructions, sauf si elle est sature, auquel
cas la seconde instruction sera concerne, ou si dans la liaison est prcise
que l'entre ou sortie concerne la seconde instruction .
- Le symbole ">>" agira de mme, mais dans l'autre sens, c'est  dire que le
membre de gauche envoie sa sortie de donnes dans l'entre du membre de
droite, et que quand on prcise entres et sorties, l'ordre est inverse,
la sortie tant indique  gauche .
- Enfin le symbole "<<>>" agit  la fois comme un symbole "<<" et un symbole
">>", les prcisions apportes au premier tant spares de celles apportes
au second par un symbole ":" si des prcisions sont apportes au second .
  Ces oprateurs sont associatifs  droite, ce qui veut dire que l'expression
" A << B << C " signifiera " A << ( B << C ) " ou encore que l'on valuera
le signe de droite avant celui de gauche .
  Pour couronner le tout, si besoin est de faire des communications
circulaires entre plusieurs tches, on peut utiliser le symbole "@" suivi
d'un nombre n pour dsigner la n-ime commande spcifie dans la ligne
d'instruction, ou le symbole "@@" suivi de l'identificateur d'une tche
en cours pour indiquer celle ci .
@
* Juxtaposition
  Une commande pourra comporter plusieurs instructions mises cte  cte,
spares par un symbole ";;"

* Identificateurs
  Une tche ou un programme peut tre identifi de plusieurs manires :
par un numro absolu d'xcution pour une tche, dlivr  sa cration ;
par le nom du programme, suivi ou non d'un numro, indiquant de quel tche
l'on parle si plusieurs ont le mme nom, la premire disponible tant prise
sinon ; par sa slection  la souris ou avec un accessoire quelconque, dans
une autre fentre .
  Le nom d'une tche peut tre prcd, pour plus de prcision, de celui de
la tche qui l'a appele, les deux tant spars par un point "." , et ainsi
de suite, et suivi par les noms de tches filles, le premier spar par deux
points "..", et les autres par un point  chaque fois, ou par une virgule pour
de tches soeurs, les parenthses tant acceptes pour dtourner la priorit
du symbole "." sur le symbole "," . Il en est de mme pour les rpertoires,
o rpertoires pres, fils, et frres remplacent tches mres, filles et
soeurs .
@
* Liaisons standard
  Les liaisons standard sont pour entre le clavier (disponible quand la
fentre de la tche est active), et pour sortie la fentre tltype d'o a
t lance la commande . En fait, chaque tche choisit ses liaisons standard,
qui peuvent aussi bien tre par dfaut un objet quelconque dfini par la
tche (typiquement une sortie srie, une fentre graphique, ..., le rsultat
renvoy par une fentre menu propose  l'utilisateur,...). La liaison WAIT
interrompt la tche qui l'appelle, selon les paramtres spcifis ( voir le
paragraphe Commandes de l'interprteur ), et permet  l'utilisateur de
contrler les flux de donnes dans une liaison (dangereuse).

* Paramtres
  Les paramtres des commandes sont laisss  la discrtion de celles-ci,
qui utiliseront sans doute les routines Forth pour isoler les options
tout d'abord, puis saisir les paramtres directement en tant qu'objets, en
appelant d'autres commandes spcifies, ou s'il n'y en a pas  travers les
routines textuelles de saisie de tels objets, donnes avec la dfinition de
ces objets. Le systme fournit toute l'aide souhaite  la gestion
automatique d'options et paramtres.

@
** COMMANDES DE L'INTERPRETEUR
  Voici la liste des commandes intgres  l'interprteur :
 CATALOG	; FILES		;
 DELETE		; UNDELETE	;
 COPY		; RENAME	; MOVE
 FORTH		; INTERPRETE
 LOAD		; STOP		; CONTINUE	; KILL
 SAY		; LINK
 WAIT		;
 SCREEN		;
 SELECT		; PROTECT	; UNPROTECT	;
  Certaines commandes ont des abrviations, spcifies alors entre
parenthses .

* FILES (FI)
  Cette commande prend en paramtre une chane de caractres, et l'interprte
en cherchant dans les units de disques spcifis les fichiers correspondant,
qu'elle envoie successivement dans sa sortie standard.
  Les fichiers slectionns sont ceux dont le nom (voir identificateur) est
reprsent par la chane, o le symbole "?" remplace un caractre quelconque,
"*" un nombre indtermin de caractres dans un mme mot, "**" tout groupe de
mots.
  Pour choisir des fichiers selon plusieurs chanes de caractres, l'on peut
concatner les listes obtenues par FILES, par la commande Forth CONCAT
(ex: CONCAT( FI"chane1", FI"chane2" ) ) , ou crire les deux chanes
spares par un symbole "|", ce qui est quivalent .
  Eventuellement, une option permet l'utilisation d'expressions rgulires
plus gnrales.

* CATALOG (CAT)
  Affiche vers sa sortie standard les identificateurs de fichiers slectionns
assortis d'informations diverses, selon les options . Les fichiers
slectionns sont ceux correspondant  l'identificateur donn,  la liste
d'identificateurs donne, ou  la chane donne en paramtre, par appel de
FILES dans le dernier cas . Les options sont les suivantes :
 -O : les options prcises seront les nouvelles options par dfaut
 -W : attend l'appui d'une touche au clavier  chaque fois que l'cran a t
   rempli, avant d'crire de nouvelles lignes d'information .
 -N : n'affiche que les noms .
 -C : affiche la date de cration
 -M : affiche la date de dernire modification
...
 exemple:  CAT -W "osl*n.asm"  renverra osl0010n.asm, etc.

* DELETE (DEL)
  Dtruit un ou plusieurs fichiers . Si le paramtre est un identificateur de
fichier, le fichier correspondant est dtruit . Si le paramtre est une liste
d'identificateurs de fichiers, les fichiers correspondant sont dtruit par
appels successifs de la commande DEL pour chacun des fichiers . Enfin, si le
paramtre est une chane de caractres, tous les fichiers correspondants sont
dtruits, par appel de DEL FI suivit de la chane .
  Si l'option -E est prcise, les fichiers sont effacs de faon  ne plus
pouvoir tre rcuprs .


* UNDELETE (UNDEL)
  Rcupre un ou plusieurs fichiers . Cette commande prend ses paramtres
comme DEL, mais au lieu de dtruire des fichiers existant, elle rcupre si
c'est possible un fichier dtruit .

...

* WAIT
  lance une tche disposant d'une entre standard quelconque, et d'une sortie
de mme nature. WAIT fait attendre l'une et l'autre, ne laissant passer aucun
message. Mais si on l'on lui dit "LINK", il se dtruit en reliant son entre
 sa sortie. Si un paramtre est donn correspondant  un vnement du
systme, WAIT attendra cet vnement avant de dclencher ce processus. WAIT
peut aussi servir de tampon avant de bloquer ou non les transferts.
( voir Evnements du systme dans "Projet.c" )

*


@
** INTERFACE GRAPHIQUE
voir "Projet.c"

...
* Icne tche
  Le petit icne apparat actif (il bouge), inactif (immobile), ou assoupi
 (zzZZ), et de lui sortent des appendices reprsentant ses liaisons externes,
 par dfaut l'attente. On peut relier ces appendices entre eux avec un fer
  souder et du fil.
...

@------------------------------------ II -------------------------------------
-------------------- LE CONTENU DE L'ORDINATEUR DU PROF ----------------------

** ARBRE DES REPERTOIRES

- Base		   ; contient le noyau du systme
 - Systme	   ; contient le systme et le langage tendu de programmation
 - Papa
  - Mathmatiques
   - Analyse
   - Algbre
  - Courrier
 - Enfants
  - Gilles
  - Annette
  - Apprendre l'anglais
  - Apprendre la programmation
 - Jeux
  - MangeOuSoitMang
  - TireLeurDessus
  - LodeWalker
  - Hroca (jeu d'aventures co-crit par le professeur)
   - listing source d'Hroca
( - Puissance 4 )
( - Echecs, Echecs chinois, ou autre jeu de rflexion )
 - Musique
 - Dessin
 - Applications
  - Base de donnes
   - catalogue de la collection de purnufles
  - Comptabilit
  - Traitement de texte et Micro-dition
 - Utilitaires
  - Gestion du disque
  - Programmation avance
  - Tlcommunication
 - Temporaire
@
** LES ENFANTS
  Au dbut l'ordinateur ne donne accs qu'au systme de base ; tous les
rpertoires sont bloqus, aucun utilitaire de bas niveau n'est disponible qui
pemettrait de contourner ces protections; et d'ailleurs, l'utilitaire seul
sans les droits d'accs aux donnes serait insuffisant. Des bulles
apparaissent, tmoignant de l'agacement croissant du PJ qui se dira
finalement que la partie rserve aux enfants sera srement la plus facile 
dplomber, celle d'Annette particulirement.

* Annette
  Annette a programm elle-mme la protection de son rpertoire, et elle en
est assez fire: quand on en demande l'accs, un joli dessin d'Annette
apparat reprsentant Maman mcontente, tandis que la ligne de commande
s'agrandit pour afficher un message sommant l'utilisateur de se prsenter.
Tout autre nom que celui d'Annette fche Maman, qui disparait quand on enfonce
une touche ou bouge la souris, avec un message spcial pour Papa, et un autre
moins gentil pour Gilles. Si l'utilisateur rpond Annette, Maman demande par
le biais d'un message similaire de le prouver, et l'utilisateur doit entrer un
code de 6 chiffres. Si l'utilisateur se trompe, Maman s'crie Menteur ! en
fronant les sourcils et en ouvrant la bouche, et c'est tout. S'il trouve le
bon code, le rpertoire d'Annette lui est ouvert.
  Si le joueur essaie plus de trois fois de deviner le code, une bulle externe
apparat, lui prsentant le calcul suivant :  Sachant qu'il y a un million de
combinaisons diffrentes, mme en imaginant que j'arrive  entrer les codes un
 un au clavier  la vitesse phnomnale de un code par seconde et sans me
tromper, il me faudra toujours un million de secondes pour les essayer tous,
soit 11 jours, 13 heures, 46 minutes et 40 secondes !!! . Si le PJI est bien
fait, on pourra mme s'arranger pour que le joueur ne puisse jamais trouver
avant 10000 essais (ou tout nombre assez grand).
  Le joueur pourra alors abandonner: tant pis pour lui ! Il lui sera
conseill de consulter le manuel de l'ordinateur. Ainsi pourra-t-il dtourner
l'entre au clavier en lanant le programme, pour entrer automatiquement les
codes; il devra donc inclure  son programme un test qui l'arrte quand
l'accs est accord, le plus simple tant une tentative de changer le
rpertoire courant en celui d'Annette, et de vrifier que le chemin du
rpertoire a bien t modifi. Mais le problme restera alors entier,
puisque l o il lui fallait cinq secondes, il faut maintenant une seconde
effectivement,  cause de l'affichage des images successives de Maman  une
vitesse prdtermine. La seule solution  ce problme est de dbrancher
logiciellement le module d'cran graphique. Pour cela, il faut mettre
l'ordinateur en mode texte compatible avec les anciens modles (il faut bien
que la compatibilit serve  quelque chose !) et lancer ainsi le programme.
Or, par une mauvaise conception du systme, il est impossible de revenir de ce
mode au mode graphique sans relancer le systme au moins partiellement; le
joueur devra donc dcouvrir le code en mode texte, avant de l'utiliser en
mode graphique (sauf s'il compte rester en mode texte). Un dernier obstacle
restera: si l'opration est dj cent fois plus rapide, il faudra encore
plusieurs heures (2 ou 3) pour passer outre cette protection, qui est pourtant
cense tre la plus facile  forcer. Le dernier truc  appliquer sera donc de
dtourner la sortie textuelle tltype vers un fichier nul. La rsolution
sera alors une affaire de minutes. PJI devra avoir t conu de manire 
respecter un chronomtrage similaire, en tout cas.

  Le rpertoire d'Annette contient les fichiers suivants, tous crits par
Annette :
Maman - Le programme de protection dcrit ci-haut.
Journal - Le journal de WabBaba, le singe en peluche d'Annette.
Papier,Ciseaux,Caillou - comme son nom l'indique.
Devine  - Le jeu o il faut deviner un entier entre 1 et 100.
JeDevine - Idem, mais cette fois, c'est l'ordinateur qui devine.
Anglais - Ceci permet de lancer le programme pour apprendre l'anglais.
...

  Le fichier Journal est curieusement annot par Gilles, ce qui montre que
lui aussi a forc la protection, et pourra s'avrer un informaticien dur 
battre (une bulle apparat pour en faire part au joueur). D'ailleurs, dans une
note  la fin du journal, Annette menace Gilles de le dnoncer  Papa s'il
continue de modifier son fichier et de se moquer d'elle. Annette se demande
bien comment Gilles devine son code qu'elle change pourtant souvent maintenant
(au dbut, c'tait une date de naissance ou de fte, mais maintenant c'est
un nombre pris au hasard selon sa fantaisie). En fait, Gilles avait eu ide
de ce code avant Annette, et Annette l'avait copi (en augmentant le nombre
de chiffres), mais Gilles avait dj rflchi au problme et crit un
programme pour dplomber ce genre de codes.
  Les programmes Papier,Ciseaux,Caillou, Devine et JeDevine sont des
devoirs de programmation du livre que papa a donn  Gilles et Annette.
Annette s'en tient aux strictes recommandation du livre, Gilles, non (voir
plus loin). Le premier programme est tel que l'ordinateur peut jouer contre
lui mme, tandis que les deux autres programmes jouent l'un contre l'autre
(C'est Papa qui a expliqu  Annette le truc de la dichotomie pour le
dernier programme, Annette ayant d'abord fait un programme qui essaie tous les
entiers entre 1 et 100; Annette n'a pas encore saisi toute la profondeur de
la mthode, mais c'est un bon dbut).
  Anglais lance le programme d'initiation  l'anglais, avec les paramtres
correspondant  la leon d'Annette
...
@
* Gilles
  Le rpertoire Gilles lui, est protg de manire plus subtile : un premier
code semblable est demand (d'ailleurs, c'est Annette qui s'est inspir de la
protection de Gilles et non le contraire). Le programme accepte n'importe
quelle combinaison au troisime essai (une bulle de satisfaction apparat
alors). Malheureusement, ceci n'est qu'une ruse, car si on a alors le droit
de voir la liste des programmes du rpertoire, on s'aperoit, quand on tente
de les utiliser ou de les lire en gnral, qu'ils ne contiennent qu'un message
railleur (l'accs au listing du programme de protection seul est alors
interdit ),  la suite de quoi l'accs est refus. On peut alors ressayer
d'entrer un code, et aprs que trois nouveaux essais aient t effectus, on
a de nouveau accs aux programmes, mais seulement pour l'xcution de l'un,
et encore, pendant quinze secondes  la fin desquelles apparat un That's
all, folks !. Le processus reprend alors  zro.
  Avec cette protection amusante, le programme utilis pour entrer dans le
rpertoire d'Annette ne rapportera aucun rsultat, et le PJ devra s'en douter,
d'autant qu'il devrait rviser le test de russite du code, ce qui est moins
vident, puisque la protection laisse entrer l'intrus dans le rpertoire, pour
mieux le tromper . En effet, le code n'est qu'une ruse, et quoique l'on tape,
c'est du pareil au mme, sauf si on tape l'un des anciens codes d'Annette,
auquel cas le programme dit a, c'est TON code, Annette ! . Pour avoir
accs aux donnes, Gilles lance au moment o il a 15 secondes le programme
WabaBb, mpris par les autres, et entre comme mot cl, aprs avoir
commenc la discussion, le nom du pre de WabaBb, WabiBubo, qu'il est seul
 utiliser, Annette ne s'interessant qu' la mre.
  Le joueur ne risque pas de trouver ceci tout seul. Il est donc
vraisemblable qu'il n'y arrivera qu'aprs avoir trouv le nom de WabiBubo
dans Apprendre l'Anglais. Un indice ventuel sera de parler au singe.

  Voici les fichiers du rpertoire Gilles
Hh - la procdure de protection.
PAPA - Programme Anti Protection Annettoise.
WabaBb - dialogue avec WabaBb, le singe en peluche de Gilles.
Papier,Ciseaux,Caillou - comme pour Annette, mais avec des animations.
Devine  - voir plus haut, et plus bas.
JeDevine - idem.
Rdaction - une rdaction pour l'cole.
Facteurs Premiers - un programme de dcomposition en facteurs premiers.
Marcheur - voir plus bas.
Anglais - comme pour Annette.
...
  Le programme PAPA, que tout le monde croit tre un programme pour Papa qui
tmoigne d'une grande affection par son nom en majuscules, est en fait un
acronyme pour Programme Anti Protection Annettoise. En effet, son rle est de
trouver le code d'Annette, d'une faon similaire  la faon prcdemment
utilise par le PJ. Mais ce programme ne marche pas en mode graphique
couramment utilis, et c'est pourquoi Papa et Annette ne peuvent dterminer
son usage et croient qu'il s'agit d'un grand programme en gestation. En fait,
une fois en mode de compatibilit texte, le programme fonctionne et affiche
finalement le code d'Annette.
  Papier,Ciseaux,Caillou est un programme du mme principe que celui
d'Annette,  part qu'il triche effrontment, et qu'il possde une jolie
animation. L'animation montre le papier coup par les ciseaux, etc, selon
plusieurs manires diffrentes, en tenant compte des matchs nuls. La triche
consiste  avoir tout le temps plus de points que l'adversaire, sauf contre
Gilles, ou au dbut dans un tournoi contre un adversaire quelconque, c'est 
dire quand un nombre de parties a t choisi  l'avance, et que le programme
pourra prtendre que son adversaire triche s'il refuse de continuer le tournoi
quand il mne aux points. Sinon, lorsqu'il est sr de son avance, le
programme choisit honntement au hasard parmi papier, ciseaux, et caillou.
  Devine est un programme comme celui d'Annette,  la diffrence qu'il
triche quand ce n'est pas Gilles qui joue : Il s'arrange pour qu'on trouve
en le plus de coups possibles, et s'il voit  la deuxime partie qu'on a
compris le truc de dichotomie, il se met  tricher ! Il choisit des nombres
non rglementaires, ou prtend que le nombre  deviner est  la fois plus
grand qu'un nombre donn et plus petit qu'un nombre plus petit que celui-l,
quitte  modifier  l'cran ses dires passs. Si on lui dit qu'il triche,
il nie avec toute la mauvaise foi possible.
  JeDevine marche btement par le principe de dichotomie, avec cela de
plus qu'il injurie un partenaire qui se tromperait ou tricherait, avec une
profusion d'expressions qui arrivent  suggrer sans dire de gros mots (que
Papa n'apprcierait pas), et qui se renouvellent sans cesse. Il est d'ailleurs
assez drle de lancer Devine avec JeDevine. Enfin, si on lui dit "PAPA",
ce programme "Devine" le code d'Annette et l'affiche, grce au programme PAPA.
  Marcheur est apparamment une animation d'un bonhomme qui marche ; en fait,
c'est un programme qui lance LodeWalker quand on crit le mot play pendant
l'animation. Il fallait cela pour que Papa ne voie pas que Gilles avait
trouv une parade  sa protection pourtant ingnieuse: seule la prsence de
la disquette de Papa (celle-l mme que le Chef a prise) dans le lecteur
permet l'accs au rpertoire; mais comme ce test ne concerne que la prsence,
la taille,et la date, d'un fichier de la disquette, Gilles dtourne le lecteur
de disquettes et simule la prsence de ce fichier en premire position du
rpertoire, aprs s'tre procur la taille et la date en jetant quelques fois
un oeil par dessus l'paule de son pre quand il listait le rpertoire
principal de la disquette.
@
* Apprendre l'Anglais
  Ce rpertoire contient un logiciel d'E.A.O. destin  initier les dbutants
 l'anglais,  travers diverses leons. Il peut aussi servir  rviser son
anglais au personnes plus exprimentes, grce  des questionnaires  choix
multiples de difficult variable, o les questions sont tires au hasard parmi
plusieurs modles, et o la correction est commente, ou avec des questions de
vocabulaire, de conjugaison, ou d'accord.
  Le programme est peu protg, si bien que Papa l'a modifi pour qu'Annette
ait le droit de jouer  son jeu prfr  chaque fois qu'elle a fini une
leon, avec autant de parties qu'elle a eu de points au-dessus de la moyenne,
la note tant sur 20. Ce jeu est MangeOuSoitMang.
  Quand le PJ lance le programme, celui-ci a besoin d'informations sur le
niveau de l'utilisateur, les leons dj suivies par lui, ses points faibles
et forts, et ainsi de suite. Or le PJ ne pourra dans un premier temps lancer
ce programme qu' partir du rpertoire Annette; c'est pourquoi le programme le
prendra pour Annette. Mais si le PJ en a marre de ces leons primaires, il
pourra essayer de planter le programme, pour le recommencer  zro, ou avec
les paramtres de Gilles.
 Pour ce faire, il devra d'abord remarquer que le programme est entirement
crit en Forth entier (utilisant des nombres entiers uniquement), langage qui
est dtaill dans le manuel de l'ordinateur. Il pourra le faire en remarquant
la forte similarit de sa prsentation avec d'autres programmes prsents dans
la mmoire de l'ordinateur et crits dans ce langage, ou avec les programmes
d'exemples du livre: ces similarits sont les polices de caractres
utilises, la manire de demander une rponse au clavier ou  la souris, la
couleur de fond, les messages d'erreur apparaissant quand un mauvais type de
donnes est donn lors d'une demande d'information au clavier, etc. De plus,
un prompt apparat au chargement du programme, et disparat pour laisser
place  l'cran de prsentation, mais on peut se rendre compte de ce que
c'est le Forth entier qui est charg, car ce langage est disponible depuis la
ligne de commande habituelle, quoique sans aucun droit d'accs ni privilge;
de plus ce langage est longuement dcrit dans la doc. du systme. Un autre
programme pourra plus tard avoir pour seul indice un prompt du genre, ou un
message d'erreur,  moins que ce ne soit la lenteur des accs au disque.
 Alors, en feuilletant le manuel, il verra que dans certaines conditions, les
programmes en ce langage peuvent s'interrompre: quand la pile de retour de
sous-routine est sature alors que la mmoire sature en gnral l'empche de
s'aggrandir, tandis qu'au mme moment, elle est sollicite pour une exception
comme un appui simultan sur les touches Ctrl et Break. Alors, le langage
produit une erreur fatale, et le programme s'arrte. S'il a t appel depuis
la ligne de commande, il se terminera alors; mais s'il l'a t depuis le
langage Forth entier, disponible dans les fins fonds de l'hritage que systme
tient de ses prdecesseurs, le langage aura la possibilit de le modifier,
quand la mmoire sera  nouveau disponible, moyennant un petit himem/lomem.
L est toute la ruse.
  Ainsi, le PJ pourra modifier les paramtres du programme, et crer un
nouveau fichier utilisateur, o il verra qu'on demande nom, prnom, situation
familiale, etc, ou charger celui de Gilles, ou celui de WabaBb, qui se
trouve dans le rpertoire Apprendre l'Anglais auquel il aura accs si il le
dprotge  partir du programme. Mais il ne pourra pas charger l'initialiseur
du programme, ou dmarrer automatiquement celui-ci avec les paramtres qu'il
souhaite, le Forth entier tant monotche (mais pouvant avoir des liens
extrieurs via des instructions rajoutes).
  Dans le fichier de paramtres de WabaBb, il trouvera la situation
familiale de celui-ci, un questionnaire rempli sur son chanteur favori, Bdo
du groupe Les Poubellards, etc.

** LES JEUX
* MangeOuSoitMang
  Ce jeu sera un remake de Serpentine sur Apple II (si l'auteur de ce jeu le
permet); mais ses High-Scores contiendront des lments interessants, s'ils
ne sont pas effacs: des pseudonymes de Gilles et Annette.
* TueLesTous
  Ce jeu est un shoot-them-up efficace.

** HEROICA
  C'est un jeu d'arcade-aventure qui est sorti rcemment, avec un succs
retentissant, mais le PJ n'y a jamais jou. Il pourra nanmoins en savoir
plus sur ce jeu grce aux magazines trouvs dans la chambre.

* Principe du jeu
- Dans ce jeu, on incarne un petit homme difforme, Rnplb qui cherche la pierre
philosophale, dans un monde hostile o il n'a que sa ruse pour se dfendre,
dans l'espoir qu'elle le rendra beau, mais aussi peut-tre riche et puissant.
Au long de sa qute, il aura divers moyens d'augmenter ses pouvoirs, mais ceci
sera trait plus loin; il deviendra aussi de plus en plus laid. A un certain
moment, sa propre laideur lui sera insoutenable, si bien qu'il ne pourra plus
se voir dans une glace.
* Dbut du jeu
- L'cran de prsentation s'ouvre sur le village natal de Rnplb, qui subit
des vexations habituelles de la part des siens, que lui valent  la fois sa
difformit (il est entre autre nain), et de son esprit rus (intelligent ?),
qu'il a dvelopp pour chapper aux mauvais coups des villageois (et mme de
sa famille) et parfois pour s'en venger et/ou en jouer lui mme (ce qui lui a
valu plus d'un ennemi). Rnplb pourra visiter le village, etc.
- Si Rnplb vient  bout de ses premiers embtement (et peut-tre mme s'il
n'en vient pas  bout), il pourra voir arriver un sergent recruteur de l'arme
royale, qui recrute en effet  coup d'or et de vin qui veut bien quitter son
foyer pour partir  l'aventure. C'est l'occasion rve pour partir de ce
village abominable ! Malheureusement, il y a de fortes chances pour que Rnplb
devienne la tte de turc des soldats, qui imiteraient les villageois, et en
effet, quand il propose ses services, les soldats lui rient au nez, suivis en
cela par tous les villageois prsents, qui en rajoutent pour le vxer. Aussi,
s'il veut convaincre les soldats, ou bien il devra arriver  vaincre (par la
ruse) un villageois costaud qui se moque de lui et qu'il provoquera, ou bien
il devra russir  faire rire le sergent par son humour et non par son
ridicule, en retournant habilement  son avantage les sobriquets dont on
l'affuble et les moqueries des villageois et des soldats. Il sera alors engag
comme soldat-guetteur ou comme bouffon du gnral selon le cas, et emmen au
camp.
- Au camp, il devra, s'il est soldat, se procurer des armes  sa taille avant
la bataille,  laquelle il devra participer. Il aura une occasion de devenir
bouffon du gnral, s'il arrive  faire rire celui-ci; mais la tche ne sera
pas facile, car la tente du gnral est garde et il n'en sort pas; aussi,
non content de crer une situation propre  faire rire, notre nain devra en
plus faire sortir le gnral.
- S'il est bouffon du gnral, aprs quelques petites pripties, le nain
devra jouer avec le gnral  un "wargame" simulant la bataille  venir; le
nain devra "aider" le gnral  prendre les bonnes dcisions, tandis que le
gnral suggrera les dplacements des troupes adverses, qui seront
rsistantes, mais dont un joueur mme peu expriment pourra avoir raison,
s'il est offensif. (Une version simplifie du mme wargame tait disponible
au village, et le nain aura pu s'entraner contre un vieillard spcialiste
local). Pour ajouter  la confusion du jeu, le joueur devra croire que le
nain mne vraiment la bataille;  la fin seulement, quand l'issue de la
"bataille" sera connue, l'on retrouvera le cadre (familier) de l'intrieur de
la tente du gnral, aprs que l'image ait t trouble, ait ondul, avec une
musique fluide pour rapparatre clairement (comme dans un film de cinma).
  Si le bouffon a perdu la bataille (avec les couleurs du gnral), le
gnral, furieux, le renverra avec moult injures et en prime, un bon coup de
pied dans l'arrire-train; Rnplb devra alors affronter la bataille sans avoir
le temps de runir tout un quipement de guerre.
  Si par contre les troupes du gnral gagnent grce au bouffon, le gnral
sera fou de joie et le flicitera (avec entre autre une bonne tape dans le
dos); mais une estafette viendra interrompre ces rveries picrocolines pour
annoncer que le camp est attaqu, et s'crouler aussitt terrass par une
flche dans le dos. Le nain aura tout juste le temps de se cacher dans une
malle avant qu'un gant ne surgisse et ne massacre le gnral. S'il combat
le gant, le nain sera cras d'un seul coup; s'il reste neutre dans la
bataille, ou trahit sans grand succs, il sera pris par les soldats ennemis
et leur servira de jouet; s'il trahit le gnral et le tue, il sera port
aprs la bataille au gnral adverse, qui lui donnera la rcompense de tous
les tratres, la mort; s'il arrive  aider le gnral  survivre et  tuer
le gant, le gnral le remerciera en lui confiant un talisman familial
(NB: si le gnral meurt et que le nain le fouille avant de se recacher, il
pourra s'en saisir, mais le talisman ne lui aura pas t donn), et lui
conseillera de se cacher, avant de sortir de la tente pour prter main forte
 ses troupes. Le nain entendra les ordres du gnral  ses hommes, puis ses
cris, et enfin son rle; s'il sort ou regarde dehors, il pourra assister  la
scne: le gnral sera tu, transperc par les lances des soldats ennemis qui
l'encerclaient. Peu aprs, les hommes (une dizaine) se rueront vers la
(riche) tente, pour s'emparer de ses richesses; si le nain se trouve sur leur
passage, il sera cras. La seule cachette qui ne sera pas dvaste sera la
lourde malle du fond de la tente; d'autres coffres contiennent de l'or et
seront vids (aprs quelques tueries entre les soldats ayant trouv les
coffres, quant au partage -- ou non-partage -- du trsor), et un nain trouv
dedans serait importun. Mme la malle sera ouverte, et le nain ne sera pas vu
que s'il s'est roul dans les vtements une fois dans la malle, pour passer
en dessous; s'il bouge tandis que quelqu'un inspecte les vtements, il sera
galement dcouvert.
- La bataille devra tre le lieu o la mort se rencontre le plus facilement,
souvent d'on ne sait o, sous les formes les plus varies. Si notre petit
bonhomme y participe, malgr toute la ruse qu'il pourra dployer, sa seule
chance de survie  long terme face  tous les guerriers expriments qui
vont dferler sera de se cacher, par exemple sous le cadavre de deux gants,
ou d'un homme et son cheval, etc. S'il combat, il pourra repousser l'instant
de sa mort, mais ne fera pas de vieux os (s'arranger pour que ce soit en
effet la fatigue du joueur qui le fasse finalement faire la fausse manoeuvre
fatale).
- Si le nain parvient sur le champ de bataille une fois la fureur des combats
passe, il pourra se livrer au pillage des cadavres, tenant compagnie aux
charognards. L, il rencontrera Gnkp, un gant issu de l'arme vaincue, ou
d'un corps auxiliaire de l'arme du gnral vainqueur, mais n'ayant pas t
sold; le gant tentera d'assommer Rnplb pour lui subtiliser ce que celui-ci
aura pu ramasser. Mais si Rnplb a russi  viter plus de dix coups du gant,
Gnkp, au lieu d'abattre au dernier moment le nain, se ravisera et
sympathisera (pour peu que le nain accepte).
- Si le nain a t emmen dans la malle, il pourra s'endormir (l'image se
brouille en ondulant), et se rveillera dans la mme malle, qui aura t
transporte dans la tente du gnral adverse. Rnplb pourra de nuit s'enfuir
du camp (aprs quelques pripties) en emportant ventuellement quelques
objets utiles.
* Le gnie
Sur le champ de bataille, Rnplb pourra dpouiller le cadavre d'un grand
capitaine de l'arme vaincue; il aura pu voir le capitaine en arrivant au
campement. Il manque la tte au cadavre, main celui-ci est reconnaissable 
son armure (maintenant en pitre tat). Rnplb pourra mme avoir assist  la
mort du capitaine, qui pourfendait vaillamment ses adversaires, mais fut
finalement submerg par ces ennemis l'encerclant de toute part, non sans
entamer un chant de guerre: Un soldat lui trancha la tte une fois au sol,
mais mme coupe, la tte cracha sur le capitaine adverse auquel elle fut
prsente. Le vaillant capitaine possdait entre autre (autour de son cou,
sous son armure) un anneau contrlant un gnie.
  Il apprendra par la suite, aprs de multiple prgrination, le pouvoir de
l'Anneau, en entendant un sorcier qui cherche l'Anneau en parler: l'Anneau
est activ par l'eau de diamant. Plus cette eau est concentre, plus fort
devient le gnie; l'eau la plus concentre tant celle coulant de la source
de la pierre philosophale. Ce gnie (ou dmon ?) incorporel pourra alors
entrer en symbiose avec l'homme pour lui faire partager momentanment sa
force et sa beaut. Au dbut, le gnie ne pourra que conseiller l'homme, puis
lui apprendre quelques coups, et enfin rentrer en lui avec la force qu'il a
avec l'eau.
  Ceci, il ne pourra le faire qu'en traversant le dsert pour fuir l'arme du
sorcier. Il devra alors doser l'eau qu'il utilisera pour lui, et celle qu'il
donnera au gnie. Il arrivera alors  la capitale, en pleins chambardements
politiques, puisque les conseillers du rois se trahissent et s'entretuent, et
que nul ne veut ou ne peut prendre la direction de l'arme pour faire face au
sorcier. Le petit homme devra alors entrer dans les intrigues du palais, pour
tenter de parler au sage 'Blndrc emprisonn par le roi pour dissidence. Il
approchera alors la fille du roi dont il tombera amoureux, et  laquelle il
pourra envoyer des lettres qui la sduiront. Mais elle ne voudra pas d'un
nabot difforme pour mari et lui en voudra mortellement d'avoir pu l'aimer,
s'il ose se montrer. Il pourra aussi tenter de la sduire quand il est en
symbiose avec le gnie, mais il n'aura pas assez d'nergie pour faire durer
la supercherie assez longtemps. Il devra aussi apporter au roi un message
d'un envoy secret, qui lui apprend qu'un de ses capitaines va trahir, en se
frayant un chemin  travers le palais par mille ruses. Il pourra tout au plus
mettre le message dans la chambre du roi, mais n'arrivera pas  lui parler
pour faire librer 'Blndrc; et il sera mis en prison avant qu'il ait pu
sortir du chteau ou que le roi ait pu lire le message. L, pour se librer,
il devra cracher l'anneau qu'il aura d avaler pralablement sur une flaque
d'eau de diamant qu'il aura d provoquer en renversant une fiole dans un
conduit prcdemment; il ne pourra recracher l'anneau que s'il a pris un
repas copieux auparavant, que les coups des gardes l'auront empch de
digrer; ce repas pourra l'avoir empch de se rendre dans certaines parties
du chteau  travers des conduits trop troit; Aprs avoir dgluti (ou s'il
n'a pas fait le repas), Rnplb pourra se rendre dans ces parties du chteau.
Une fois l'anneau recrach, il faudra passer son doigt de pied dans l'anneau
pour que le gnie rentre dans la jambe.
  Mais celui-ci convoite l'Anneau
  Ensuite, l'homme devra vaincre le sorcier et son arme d'hommes et de
monstres qui protge son chteau, en cherchant sans cesse de l'eau pour
donner de l'nergie au gnie . Mais il devra pargner le sorcier pour qu'il
lui montre la source d'o coule l'eau .
- le sorcier  un anneau moins puissant, mais mieux fourni en nergie que
celui du bonhomme .
- Les gnies sont rivaux et celui du sorcier pourra tenter de former un pacte
avec le bonhomme pour gagner, mais se rvlera plus tratre encore que
l'autre.
- Le bonhomme pourra cder son anneau  quelqu'un, mais il perdra, sauf s'il
s'agit du sage de la ville, dans les prisons du roi .
- le coeur du chteau du Magicien est proprement un labyrinthe  trois
dimensions o la gravit change de direction en fonction de l'endroit o l'on
se trouve, et du temps parfois. Le mme couloir pourra avoir t parcouru
avec des gravits diffrentes. On peut changer le sens de vue, mais sans
savoir quel sont les haut, bas, gauche, droite, avant et arrire originaux.
- le pierre  la fin lui demande ce qu'il veut. Il peut rpondre la beaut,
et il pourra pouser sa princesse, mais aura une vie malheureuse et une fin
tragique; il pourra choisir la puissance, mais finira accabl par ses
horreurs; il pourra demander le don de gurison, mais ses efforts seront
toujours  recommencer, et ses rsultats phmres aprs sa mort. Il pourra
choisir le pouvoir de transmettre de gnration en gnration; et alors, tout
ce qu'il accomplira, aussi peu ft-ce, sera repris dans le futur, et de mme
pour ses successeurs; mme si le monde rgresse, son hritage se perptuera,
et s'aggrandira.
...
  Le gnie s'avre trop assoiff de puissance. Si l'homme le laisse faire,
une fois la pierre philosophale atteinte, le dmon s'en servira pour devenir
matre du monde aprs avoir dtruit l'me de l'homme. Il s'emparera de corps
plus fort que celui du bonhomme pour poursuivre sa route

- il ne faut pas finir en symbiose avec le gnie, ou il se libre et se
dchane.
- on n'est au courant de la trahison du gnie qu' la fin
-  un moment, il faut sacrifier une partie de son corps  l'anneau, pour lui
donner une partie de l'eau de diamant que l'on a bue.

*
- il

** A CASER
...
- lettres au lieu de chiffres (Annette) pour Papa ...
- L'accs au rpertoire Musique (sauf son catalogue) devra tre impossible
avant d'avoir fini le jeu : en effet, une des cls de l'ordinateur sera que
le programme demande  ce qu'on lui joue un certain air . Il faudra donc que
le joueur copie le CD de l'air en question sur une cassette, puis copie la
cassette sur l'ordinateur par l'entre micro, avant de reproduire l'air en lui
ayant donn le bon nom, en mme temps que l'on demande l'accs au fichier ...
- Pour avoir accs au rpertoire ...
- changer la date et l'heure de la dernire fois que l'ordinateur a t allum
pour faire croire au programme que le code a dj t mis . (Mais le faire au
centime de seconde prs, donc en utilisant les Utilitaires) ...
- Un virus est dans l'ordinateur qui va dtruire des donnes, import par le
rseau tlmatique, ou bien il va tre import par le PJ; en tout cas, comme
il est actionn par l'utilisateur, il est inactif tant que celui-ci ne l'a pas
lanc avec un niveau de privilge assez fort ...
- cf remarques gnrales du fichier "PJI.C"
...


@------------------------------------ III ------------------------------------
--------------------------- LA CHAMBRE DU HUIS-CLOS --------------------------


** LISTE DES OBJETS DE LA PIECE
- L'ordinateur Pactariga:
- Un tableau au mur : sans grande valeur, et sans coffre-fort derrire.
Nanmoins, au dos du tableau est colle une enveloppe avec les papiers
d'acquisition du tableau au milieu desquels se trouve une disquette.
Les papiers sont attachs par un trombone.
- La disquette, contenant
- Une fentre donnant sur une impasse, et d'o les voisins peuvent voir le PJ
s'il ne tire pas les rideaux. Dans ce cas, ils appelleront la police, et le
temps du PJ se comptera en minutes.
- Une chane hi-fi, avec enceintes et ampli, poste radio rcepteur,lecteur CD
et lecteur de cassette. A ct,
(- Un tlphone )
 - des magazines informatiques

** LES MAGAZINES INFORMATIQUES
  Ce sont les numros 16,17,19 et 20 de Pactariga Magazine .
  Ce magazine est organis selon les rubriques suivantes :
- Nouvelles du monde informatique
- Brve prsentation des nouveauts matrielles et logicielles
- Dossier
- Banc d'essai de machines et programmes
- Prsentation des nouveaux jeux
- Aide pour les jeux
- Trucs et Astuces
- Programmes tout faits et comments
- Slection des meilleurs logiciels et machines disponibles, avec
 version, date et prix .

  Bien sr, le tout est entrecoup de publicits (dont certaines peuvent
tre vraies !) .

  Dans ce qui suit, sont indiqus un "(!!!)" les dtails importants pour le
jeu. Il devront tre noys sous une foule de dtails inutiles, ou
insignifiants, ou en tout cas sans importance sur le bon droulement de la
suite du jeu. Mais certains articles pourront tre d'authentiques articles
d'intrt informatique rel, ou des fictions informatiques considres comme
relles dans le jeu.
  Dans les magazines, il sera fait allusion  des informations contenues dans
le numro 18, et qui auraient pu aider grandement le joueur. Mais ces
informations manquent (sauf peut-tre sur la couverture du numro 18, qui
se trouve prs du bulletin d'abonnement des numros 19 et 20). Cependant, le
peu que l'on peut en apprendre (ne fut-ce par exemple que l'existence de
certains trucs, que l'on pourra alors rechercher) pourra s'avrer critique.

* Nouvelles du monde informatique
(16)
(17)
(19)
(20)
  - Les ventes du Previous ont explose, tandis que le Pactariga P7 a fait
  un flop.
* Brve prsentation des nouveauts matrielles et logicielles
(16)
(17)
(19)
(20)
* Dossier
(16)
(17) Hroca
(19)
(20)
* Banc d'essai de machines et programmes
(16) Le nouveau Pactariga P7
(17) Le logiciel de C.A.O.
(19) Le Previous face au Pactariga
(20)
* Prsentation des nouveaux jeux
(16) Hroca
(17) TueLesTous
(19)
(20)
* Aide pour les jeux
(16)
(17) Hroca,...
(19)
(20)
* Truc et Astuces
(16)
(17)
(19)
- Le truc de la saturation de mmoire en Forth entier (!!!), appliqu dans
 le logiciel Apprendre l'Anglais .
(20)
* Programmes tout faits et comments
(16)
(17)
(19)
(20)
* Slection des meilleurs logiciels et machines disponibles, avec
 version, date et prix .
(16)
(17)
(19)
(20)










   Ŀ
   Pactariga                                    
   

*/
