/*
  fichier "PROJET.C"

  ides collectes  partir de la classe de 1re, (anne scolaire 1988-1989)
  rdiges  partir du 27 juillet 1991 (vacances scolaires entre HX et XM' )

  voir les fichier suivants :
   "ProjetAp.c" (Appendices  ce projet)
   "Prj386.c"   (tentative d'implmentation)
   "PJI.c"	(projet de jeu informatique)
   "PJI1.c"	(sous-ensemble de PJI.c, plus directement li  ce projet)

   "SYNTAXE.OSL"  (fichiers dcrivant le prlangage OSL)
   "INTRFACE.OSL"
   "VOCABULR.OSL"

   "OBJETS.OSL"	(fichiers source en prlangage OSL)
   "LISTES.OSL"
   "ARITHM.OSL"

   "EVENEMNT.OSL" (source en OSL des fonctions de haut niveau du noyau)

   "ALGEBRA.C"  (premire tentative de compilateur du prlangage)
   "ALGx.CPP"
*/

/*
@-----------------------------------------------------------------------------
--------- Projet  court ou moyen terme d'environnement informatique ---------
------------------------------------------------------------------------------

Objet: Ce projet reprend les ides dveloppes sur le petit carnet gris et
-----  les feuilles d'exemples, pour en proposer une implmentation effective,
 sur des appareils quips de processeurs compatibles intel 80386 dans un
 premier temps, puis sur des appareils RISC FORTH 32 bits .

Grandes lignes: Le systme informatique propos comporte principalement :
--------------
 * un matriel PC386 standart, ou un nouvel ordinateur ( voir appendice A )
 * un noyau OSL, espce de FORTH orient objet multitche  gestion dynamique
 de la mmoire, avec mmoire virtuelle et protge, selon plusieurs niveaux de
 programmation et de protection ;
 * un compilateur universel orient objet produisant un code interprtable ou
 compilable par le noyau ;
 * un environnement graphique multitche multiutilisateurs o tout est
 reconfigurable ( en tenant compte des protection des programmes et des
 donnes ) .



-------------------------------- SOMMAIRE ------------------------------------

AVANT-PROPOS

CHAPITRE I : LE NOYAU OSLM DU SYSTEME
 * Le concept d'objet
 * La gestion de la mmoire
 * La gestion des bibliothques d'objets
 * L'xcution simultane de plusieurs tches
CHAPITRE II : LE COMPILATEUR UNIVERSEL :
 *
 *
 *
 *
CHAPITRE III : L'ENVIRONNEMENT GRAPHIQUE :
 * brve description
 * rpartition des ressources de l'environnement
 *
 *
CHAPITRE IV : ACCESSOIRES LOGICIELS DU SYSTEME :
 * liste succinte
CHAPITRE V : APPLICATIONS ET PROGRAMMES PREVUS :
 * liste succinte
APPENDICE A : CAHIER DES CHARGES  court terme POUR UN ORDINATEUR conu exprs
  pour le systme propos .
 * Aspect extrieur du matriel
 * esquisse du microprocesseur souhait
 * Architecture lectronique du matriel
APPENDICE B : LISTE DES CLASSES D'OBJETS DU SYSTEME
** Classes de donnes de base
** Classes du noyau
** Classes du compilateur
** Classes de l'environnement
** Classes des accessoires
** Classes des applications



Note: les appendices se trouvent dans le fichier PROJETAP.C


@------------------------------ AVANT-PROPOS ---------------------------------

  Cette proposition de systme ne prtend absolument pas tre d'une
originalit totale d'ailleurs, la plupart des ides exprimes ont t
inspires plus ou moins directement de systmes, matriels, logiciels dj
existant, et mme les ides trouves n'ont t en fait que re-trouves,
parfois  partir de systmes s'en tant eux-mmes inspirs . Ce systme n'est
qu'une esquisse de synthse de ces ides dont une partie sont souvent
dlaisses,  cause d'une tendance assez nette des entreprises informatiques
 prfrer crire des programmes qui rapportent vite, souvent bcls, copiant
la mode et les systmes existant tels quels plutt que d'en retirer la
substantifique moelle, ce qui donne souvent des programmes mals faits, o il
manque toujours la moiti de ce qu'on voudrait, et o il faut vite apprendre
un nouveau vocabulaire technique  chaque fois qu'on veut utiliser un nouveau
logiciel, ou programmer dans un nouveau systme .
  De nombreuses amlioration sont possibles pour le systme propos, et toute
ide nouvelle ou ancienne nglige y sera la bienvenue, mme si elle doit
remettre en cause une partie ou la totalit des efforts antrieurs ; car la
philosophie du systme n'est pas de balayer un systme obsolte et nuisible
de compatibilit historique par un autre, mais de faire profiter pleinement
le grand public et les informaticiens des progrs technologiques jusqu'alors
enchans et freins sous le prtexte oiseux qu'il faut garder un systme
totalement compatible avec le prcdent, donc plus lent, plus cher, moins
facile d'utilisation et de programmation, pour pouvoir utiliser des vieilles
donnes que de toute faon l'on peut rcuprer et enrichir, avec des anciens
programmes qui ne servent  rien tels qu'ils sont puisqu'il en sort toujours
de nouveaux, meilleurs qui les remplacent, et peuvent trs bien tre crits
sur un nouveau systme meilleur que l'ancien en reprenant tout le code
prxistant souhaitable . Ce prtexte ne sert d'ailleurs qu' affermir la
position des entreprises qui dominent actuellement le march et leur faire
gagner de l'argent au dtriment de tous, les consommateurs finaux en premier,
mais eux aussi, tant eux-mme consommateurs .
  Ainsi, la prtention de ce langage est que les vieux standards soient
sans cesse remplacs, que ce soit les antiques systmes d'exploitation, ou
tout matriel obligatoire, ou langage hgmonique, trop facile et trop peu
puissant, ou trop ardu et difficile  transcrire et reprendre . Ce
remplacement peut trs bien ne pas tre fait par le systme propos, mais par
un systme meilleur : tant mieux ! D'ailleurs, ce texte mme est obsolte,
et en passe d'tre ratrapp par les logiciels informatiques, mais il comporte
des ides, qui, si elles ont quasiment toutes t mises en pratique
auparavant, ne l'ont jamais t ensemble .


@@------------------------------- CHAPITRE I ---------------------------------
--------------------------- LE NOYAU OSLM DU SYSTEME -------------------------

  Ce noyau comporte trois lments essentiels : la gestion dynamique et
relationnelle de la mmoire, y compris la mmoire virtuelle et la mmoire de
masse, le traitement dynamique et relationnel (aussi) de la bibliothque
d'objets, et la gestion de l'xcution de plusieurs programmes  la fois .
Le premier est celui dont le code est le premier crit et le plus au centre
du systme , mais il est tellement imprgn du concept d'objet, qu'il est
impossible d'en parler avant d'avoir clairci un tant soit peu ce concept .

**   LE CONCEPT D'OBJET

  Au stade lectronique, un ordinateur traite des signaux numriques binaires
forms de zros et de uns . Mais pour l'utilisateur, ces signaux reprsentent
quelque chose, ont une signification profonde, il peut s'agir d'un texte,
d'un extrait de comptabilit, d'une image ou d'un son numris, d'une
expression mathmatique, et s'il ne peut les communiquer en tant que tels au
systme, il devra perdre son temps  les transformer, ce qui peut tre une
opration complexe qu'il devra encore perdre du temps  matriser ; son
ordinateur sera donc un mauvais outil . Aussi de nombreux logiciels sortent,
spcialement conus pour traiter chaque donnes . Mais dans un systme
classique, un logiciel est spcialis non seulement pour utiliser certains
types de donnes, mais aussi pour les utiliser avec certains algorithmes
seulement alors que l'utilisateur aimerait leur faire subir d'autres
transformations, ou rciproquement pour utiliser certains algorithme, mais
avec certains types de donnes seulement alors que l'utilisateur aimerait
transformer de mme d'autre types de donnes . Le systme se trouve alors
lacunaire, et n'est qu'un amalgame de logiciels mis les uns  ct des
autres ; c'est d'ailleurs ainsi que chacun le sent, et on vend bien ces
logiciels  part, et un logiciel diffrent pour chaque application ; ainsi,
on se retrouve avec un traitement de texte diffrent pour taper des textes
en franais ou en anglais, en vitnamien, en arabe, en chinois, en japonais,
en grec, en hiroglyphes gyptiens, avec des symboles musicaux ou des
symboles mathmatiques , avec des programmes diffrents pour saisir des
donnes, pour les traiter, et pour les imprimer, avec des gestionnaires
d'impression qui gchent lamentablement le papier, avec des programmes qui
marchent avec certains matriels mais avec aucun autre . Certains de ces
programmes sont performants, mais impossibles  tendre pour utiliser leurs
potentialit en traitant les donnes dont on a besoin ; les autres permettent
d'utiliser ces donnes, mais sont peu performants, car chaque type de donnes
spcialis n'est utilis que par une partie restreinte et minoritaire du
public, et donc ne vaut pas la peine d'un investissement important de la
part des compagnies de logiciels . Pourtant chaque utilisateur a ses
spcialits et est donc oblig de se servir de logiciels spcialiss qui se
rvelent peu performants . Ceci reprsente une perte de temps continuelle, 
la fois pour l'utilisateur final qui n'a accs qu' une partie trs
restreinte de la puissance de son ordinateur, alors qu'il doit investir
beaucoup d'argent pour l'achat de son matriel et de ses logiciels,et son
temps pour apprendre  les utiliser , et pour les programmeurs, qui doivent
rcrire sans cesse les mmes algorithmes pour les adapter au systme utilis
et aux donnes traites, sans pouvoir profiter des efforts des autres
programmeurs, ni en partie, ni en totalit,  cause des copyrights xagrs
sur les codes finaux interdits de modification et de la non diffusion des
codes sources .
@
  La solution  tout ceci est le concept d'objets : tous les types
d'algorithmes ou de donnes sont isols en des modules, que le systme relie
automatiquement entre eux au moment de l'utilisation, de faon  ce qu'un
algorithme quelconque puisse tre utilis avec n'importe quel type de donne
qui s'y prte, et que rciproquement, un type de donne puisse tre trait
par n'importe quel algorithme qui s'y prte ; un algorithme ou une donne, ou
un groupe d'algorithmes et/ou de donnes sera un objet, des objets similaires
sujets aux mmes types de transformation formant une classe d'objet ; il
suffira alors de dfinir pour chaque objet des conditions ncessaires pour
pouvoir le lier  un autre objet, requises de par sa classe ou son
individualit, et l'utilisateur pourra alors indiffremment utiliser les
algorithmes de son choix avec les donnes de son choix, sans avoir  tout
reprogrammer soi-mme (s'il en est capable) ou  payer les yeux de la tte un
logiciel inadapt voire nul pour dnicher lequel il aura mis un temps fou et
prodiguer des efforts inimaginables s'il y arrive .
  Un objet est donc quelque chose caractrise par les liaisons qu'il peut
ou non avoir avec d'autres objets, par son comportement selon les impulsions
qu'il reoit .
  Le concept n'est pas nouveau, puisqu'il a t esquiss ds les annes 70,
mais jamais il n'a t mis totalement en oeuvre pour le grand public  cette
chelle : des logiciels permettent d'utiliser des objets, mais pas d'en crer
(cf les ordinateurs Apple Macintosh, ou les calculatrices HP 28 et 48) ;
d'autres permettent d'en crer dans certaines limites, mais pas de les
utiliser en mme temps, et ne livrent pas d'objets volus permettant la
constitution d'un environnement rellement orient objet (cf les langages
de programmation C++, ADA, TurboPascal ). Smalltalk (esquiss ds 1973,
prsent en 1977), le langage pionnier en matire d'objet, n'a jamais t
distribu  grande chelle, et aucune application importante n'a t crite
pour ce vritable environnement, le langage, conceptuellement intressant,
tant peu performant pour les calculs et limit dans la syntaxe ; nanmoins,
Smalltalk a inspir tous les langages  objets subsquents, mme s'ils n'en
reprenaient que peu de caractristiques . D'ailleurs, l'ide de base d'un
environnement orient objet est issue de Smalltalk , c'est que tout est
objet, mme les classes d'objets qui constituent une ou plusieurs classes,
ci fait que le systme n'a ni dbut ni fin, mais est une collection d'objets
qui interagissent les uns avec les autres .
@
  Il reste  prsenter le concept d'hritage pour les objets, introduit
par Smalltalk ou un langage antrieur ; pour l'introduire voici un exemple
pratique pour les mathmaticiens (pour les non matheux, se rapporter tout de
suite  l'exemple suivant) : soit  dfinir l'algorithme d'euclide (qui
donne le PGCD de deux nombres et ventuellement un relation de Bzout entre
ces deux nombres), qui est valable dans n'importe quel anneau euclidien (o
est dfini la division euclidienne) ; si la structure d'anneau a dj t
dfinie, il sera contre la philosophie de l'environnement de la redfinir
entirement pour ne lui rajouter que l'existence d'une division euclidienne,
d'autant que l'on pourrait en profiter pour introduire les concepts d'anneaux
principaux et factoriels, les anneaux euclidiens tant principaux,les anneaux
principaux factoriels, tous tant des anneaux ; on dfinira donc la structure
d'anneau euclidien comme hritant les proprits de la structure d'anneau
principal, elle mme hritant celles de la structure d'anneau principal, et
ainsi de suite . Voici un autre exemple, pour tous : soit un collectionneur
voulant dresser un catalogue de ses nombreuses pices, qu'il voudra trier
selon une mthode particulire au type de pices collectionnes, et parcourir
selon une mthode personnelle non squentielle, ( par thmes voisins, par
exemple ), tout en affichant les pices sous leur aspect rel, car la
dsignation exacte d'une pice est difficile  retenir ; il n'aura pas 
rcrire tout un systme de base de donn pour avoir un tel catalogue,
comme il le devrait dans un systme rigide classique, mais il devra juste
dfinir un objet catalogue, qui hritera les proprits d'une base de
donne, mais en redfinissant de nouvelles manires de trier, de visualiser
et de parcourir la base, et une nouvelle mthode pour en afficher un lment,
grce aux outils de programmation fournis par le systme ; alors tout
logiciel de base de donnes bien conu dans le systme pourra prendre en
charge la gestion de son catalogue ; son catalogue sera un objet d'une
classe qui aura hrit de la classe base de donnes, qui hrite de la classe
des fichiers diviss en lments diviss en champs, qui hrite de la classe
plus gnrale des fichiers . Ainsi, tout objet pourra hriter les proprits
d'autres objets, qu'il n'aura pas  redfinir, et pourra tre utilis avec
tous les algorithmes prvus pour fonctionner avec ces objets, tout en en
redfinissant certains, incomplets ou mal appropris .
@
  Un objet pourra hriter des proprits de plusieures diffrentes sortes
d'autres objets . Pour revenir  notre exemple mathmatique, un anneau
unitaire hritera sparment de la structure de groupe ablien pour sa loi de
composition interne additive, et de la structure de monode pour sa loi de
composition interne multiplicative, outre qu'il sera aussi un anneau pris
dans la dfinition gnrale, non forcment unitaire ; un corps d'extension
quadratique de Q aura  la fois les proprits d'espace vectoriel de
dimension 2 sur Q, et de corps archimdien ; ou encore, un espace vectoriel
norm aura celles d'un espace vectoriel et d'un espace mtrique  la fois ;
ces deux structures auront en plus des particularits non hrites des
structures nommes . Et pour les non matheux, on peut dire qu'un spectacle
son et lumire aura  la fois les qualits d'un spectacle sonore et celles
d'un spectacle visuel, en rajoutant celle de la synchronisation entre les
deux parties ; dans un autre contexte, on peut voir qu'une chaise en bois
hrite la proprit de toute chaise, qu'elle est faite pour s'assoir dessus,
et celles de tout objet en bois, qui pourrit s'il n'est pas trait, et que
l'on peut brler  au cas chant, aprs l'avoir dbit en morceaux .


 **   LA GESTION DE LA MEMOIRE
@
* Introduction
  Tout est objet . Un objet change et se transforme, vit et meurt . Or, tout
objet occupe de la place dans la mmoire de l'ordinateur . Et celle-ci est
trs limite .
  En partant de ces constatations, on dduit que le systme doit disposer
d'un dispositif pour grer la mmoire, la confier  certains objets pour
s'agrandir ou pour en crer d'autres, la rcuprer sur les objets devenus
inutiles .
  Certaines zones de la mmoire vive de l'ordinateur (un objet !), seront
occupes par des objets dont la taille variera, et dont l'adresse
(l'emplacement) variera, si bien que le mme emplacement mmoire pourra
changer de propritaire lors du droulement d'un programme . Une telle zone
sera appele un tas (heap en anglais), ou une zone d'objets temporaires
( ce que l'on abrge en ZOT ) . La mmoire de l'ordinateur pourra en contenir
plusieurs, sparment ( surtout si la mmoire physique de l'ordinateur est
pagine ), ou les unes dans les autres, une ZOT tant un objet comme un autre
qui peut tre contenu dans d'autres objets, dont des ZOT . D'autres zones,
plus stables, contiendront des objets de taille et adresse fixes . Mais
ces zones, tant des objets, pourront contenir, ou tre contenus dans des
ZOT .
  Le gestionnaire de mmoire devra donc s'y retrouver dans un imbroglio
d'objets bougeant les uns  l'intrieur des autres, tout en devant savoir 
tout instant l'adresse de chaque objet . Ainsi, une donne contenant
l'adresse d'un objet, appel pointeur parce qu'on dit qu'il pointe vers cet
objet, pourra indiquer  un programme l'emplacement de l'objet . Mais si
cet emplacement change, il faudra corriger le pointeur, et donc en connatre
l'emplacement . C'est pourquoi les pointeurs formeront un arbre, o tout
pointeur sera point par un autre pointeur ; et pour que toute la mmoire ne
soit pas envahie par de tels pointeurs, et que le processus s'arrte, les
pointeurs seront regroups tant que possible .
  Ceci nous amne  dcrire comment le systme organise ses pointeurs .
@
* Les pointeurs
  Il peut exister de multiples sortes de pointeurs,  tout niveau, cods
de manires particulires, stoqus dans des coins reculs de la mmoire .
Aussi, le systme contiendra une liste chane de listes chanes virtuelles
de d'objets pointant de mme type , les dfinitions de tels types tant des
objets d'une mme classe . Une liste chane est une liste dont le premier
lment est  une place fixe, et dont chaque lment pointe d'une manire ou
d'une autre sur l'lment prcdent et sur l'lment suivant, ( et pouvant
bien sr, et c'est tout l'intrt, contenir d'autres informations ) .
  La premire liste aura pour premier lment un type prfourni du systme,
par exemple le type tableau de pointeurs, et chaque type recevra  son tour
un ordre de mettre  jour ses pointeurs . Voici la description d'un objet du
type en question : chaque tableau de pointeurs rels contiendra, dans cet
ordre,
 - le nombre total de pointeurs du tableau
 - un pointeur sur le tableau suivant (pour la procdure de raffraichissement
  des pointeurs)
 - un pointeur sur le tableau prcdent (pour la procdure de destruction du
  tableau)
 - les autres pointeurs du tableau, au nombre indiqu prcdemment, moins
  deux, car les pointeurs sus-cits sont compts .

* Les collections d'objets et les zones d'objets



* Complications envisages en systme multiprocesseur



**   LA GESTION DES BIBLIOTHEQUES D'OBJETS
@
  Le principe de la gestion dynamique des bibliothques d'objets est qu'un
algorithme doit tre crit une fois pour toute, indpendamment des types de
donnes utiliss, tant qu'ils vrifient une certaine structure chacun, mais
que pourtant son xcution effective soit aussi rapide que s'il tait
effectivement rcrit, car sinon l'opration serait de peu d'intrt, et il
faudrait toujours perdre son temps pour avoir un programme de calcul
efficace. L'environnement doit donc compiler automatiquement les algorithmes
avec les donnes correspondantes quand il en est besoin, en tenant compte des
particularits de chaque objet, et en temps rel; mais il doit aussi ne pas
compiler systmatiquement chaque algorithme pour chaque donne possible et se
restreindre au ncessaire pour ne pas gcher les ressources du systme et
dborder avant inutilement de mmoire limite de l'ordinateur, tout en
pouvant retrouver aisment les codes compils pour ne pas avoir  les
recompiler, et nanmoins liminer les codes compils et utiliss mais
maintenant inutiles . Tout cela est la tche qui incombe au gestionnaire
des bibliothques d'objets .

[[[ parler
  liaison entre objets -> contrle, hritage, utilisation, simultanit,
liaison code-source/objet, ...
- gestion relationnelle et dynamique
- types virtuels de base :
 - pointeurs
  - pointeur mmoire
 - nombres
 - collections
  - zones d'objets
   - zones fixes
   - zones mobiles
  - listes
   - tableaux
   - piles
   - listes chanes
 - programme
   - code machine xcutable
   - Forth semi-compil
   - code source
    - texte
    - bote d'information
 - tche

- requtes
 - demande
@
**  L'EXECUTION SIMULTANEE DE PLUSIEURS TACHES
* Objet tche  accomplir
 Le ou les microprocesseurs du systme disposent de
 -adresse du programme principal
 -niveau de privilge .
 -sauvegarde des registres
 -pile de retour
* indpendance des blocs de code xcutable, et des blocs de donnes
* protection des donnes
* niveaux d'accs d'objets sur d'autres, avec hritage dcroissant des
 priorit par appel simple
* communication entre tches : ordre  un infrieur, requte  un autre,
 change de codes et donnes
* complications envisages en systme multiprocesseur .



@@------------------------------- CHAPITRE II --------------------------------
--------------------------- LE COMPILATEUR UNIVERSEL -------------------------

- dfinition des types d'objet de base accessible au programmeur (types
 globaux largement paramtrable)
- dfinition de plusieurs sortes de donnes compilables ou compiles
 (texte,graphe,forth,code machine)
- dfinition de plusieurs degrs de compilation
- dfinition des objets utiliss par le compilateur au niveau de la
 compilation (mais accessibles au programmeur)
- procdure gnrale de la compilation


- Stabilit des donnes
  A chaque variable correspond des zones (du point de vue du temps et/ou de
la portion de programme en marche considre ) d'existence, de constance, et
d'tat protg en criture et/ou en lecture, chaque zone cite incluant bien
sr les suivantes . Voici 
quelles priodes ces donnes peuvent tre lies, par ordre dcroissant
d'inclusion aussi :
 . L'existence mme du systme ;
 . La prsence de l'une de ses parties ;
 . La session du systme, depuis la mise en marche de l'ordinateur jusqu'
  son arrt ;
 . La prsence d'une tche en mmoire (accessoire, application, tche
  sous-traitante ou de communication, ...) ;
 . L'xcution d'une procdure .


- conditions de liaison des objets => programmation par contrainte dont
 le compilateur est un interprteur

-  Mais quelque soit le nouveau systme, il faudra qu'il intgre un moyen de
comprendre un tant soit peu les donnes, les
liens entre ces donnes et notamment les algorithmes, qu'il devra pouvoir
reprendre avec le moins d'aide humaine possible quelque soit le langage o
ils auront t originellement crit, ce qui mettra fin dfinitivement 
l'autre prtexte oiseux qu'il faut garder de vieux langages de programmation
dbiles et en apprendre un nouveau pour chaque type d'application parce que
ces langages ont tous des avantages que d'autres n'ont pas ; le langage de
programmation du systme aura donc plusieurs formes et plusieurs syntaxes,
tout en limitant les mots ou symboles difficiles  retenir ainsi que l'ordre
de leur paramtres, et en grant facilement tous les cas particuliers, les
erreurs possibles, et en vitant les rptitions inutiles grce  un systme
simple d'utilisation, mais toff de macrocommandes et macrodfinitions, o
il y a peu  retenir du moment qu'on a compris .

@@------------------------------ CHAPITRE III --------------------------------
--------------------------- L'ENVIRONNEMENT GRAPHIQUE ------------------------
  Ce chaptre tente de dfinir les objets de base de l'interface du systme
avec le ou les utilisateurs, ainsi que les principales mthodes d'utilisation
de ces objets .
- bref aperu des ressources communicatives du systme (cran(s) ou portion,
 clavier(s), souris, etc)
- structure dynamique d'allocation de ressources en communication entre les
 tches
- structure hirarchise des fentres et crans ;
- application du principe de multiapparition d'un objet ;

- communication des vnements .

@@------------------------------- CHAPITRE IV --------------------------------
----------------------- ACCESSOIRES LOGICIELS DU SYSTEME ---------------------
(  part le compilateur en temps rel et l'environnement graphique virtuel
proprement dit )
- toute une panoplie d'outils de communication multiutilisateurs :
 chaque circuit priphrique peut tre contrl par un utilisateur diffrent
 ou partag entre plusieurs utilisateurs, ce qui ncessite des gestionnaires
 spcialiss, et des accessoires adapts  chaque circuit d'acquisition et/ou
 de visualisation des donnes : l'utilisateur entre des nombres  partir
 d'une fentre calculette forth, entrant les nombres au clavier s'il en a un,
 ou s'il a priphrique de pointage, avec une rglette,  la suite de quoi il
 les ajustera chiffre par chiffre ( autre rglette ) ou en xcutant des
 oprations (prise de la partie entire ou fractionnaire notamment), aussi
 accessible au clavier avec un systme de menu et de valeur dynamique des
 touches .
- compression/dcompression des donnes par divers algorithmes et sous
 divers formats, avec routines  lier  des programmes de l'utilisateur qui
 voudrait dcomprimer des donnes en temps rel, et/ou dcomprimer par
 tranches ses donnes, les vrifier, les coder, etc .
- codage/dcodage des donnes par divers algorithmes avec ou sans cl,
 routines  lier pour codages multiples, conjugus  une compression des
 donnes, etc .
- en utilisant les deux accessoires prcdents, communication en gnral
 entre deux plusieurs systmes formels, chacun pouvant tre en ralit
 intrieur ou extrieur  l'ordinateur .
- un utilisant les mmes accessoires, un module de programmation permettant
 de raccourcir ou protger le code et les donnes d'un programme .
- interface personnalise selon l'utilisateur, avec connaissance des liens
 entre les utilisateurs, entre les programmes, et entre utilisateurs et
 programmes, comprenant un agenda relationnel et un gestionnaire de projets
- Programme d'intelligence artificielle reconnaissant l'utilisateur d'aprs
 l'usage qu'il fait des ressources de l'ordinateur : ceci vaut mieux que
 tous les mots de passe .
- rcupration de donnes en provenance d'autre systmes ( accessoire
 primordial  remettre  jour rgulirement ).


@@------------------------------- CHAPITRE V ---------------------------------
---------------------- APPLICATIONS ET PROGRAMMES PREVUS ---------------------
- Programme de calcul mathmatique formel et symbolique
- Programme d'acquisition de connaissance
- Gestion de bases de donnes relationnelles partages
- Feuilles de calcul non quadrilles ( mais dans lesquelles on peut crer
 des tableaux tout de mme )
- Publication assiste par ordinateur
- Prsentations et dmonstrations assistes par ordinateur
- conception d'objets tridimensionnels
- synthse d'images : dessin 2D ou 3D, mlange, dformation d'images, avec
 synchronisation de l'affichage avec son et autres programmes .
- acquisition d'images
- analyse d'images : reconnaissance de formes, de caractres, analyse des
 couleurs
- Programme musical total : de l'criture de la partition  son audition,
 avec saisie et envoi des donnes sur l'interface MIDI, chantillonnage de
 son, traitement divers de ces sons, analyse et synthse musicale et vocale,
 etc ...
*/
/*
 Pour voluer dans le texte, chercher :
 @@   pour aller au chaptre suivant,
 **  pour aller  la partie suivante du chaptre .
 @  pour aller au paragraphe suivant .
*/
