/*

 Le dbut du texte est dans le fichier PROJET.C
*/
/*
@@------------------------------ APPENDICE A --------------------------------
--------------------- CAHIER DES CHARGES POUR UN ORDINATEUR -----------------
------------- conu exprs pour le systme propos (  court terme ) --------

Sommaire :
I) Aspect extrieur du matriel
II) Esquisse du microprocesseur souhait
 1) Introduction
 2) Principes de base
 3) Les registres
  a) registres de donnes
  b) registres de pointeurs
  c) registres d'tat
  d) registres d'entre/sortie
 4) Les types instructions
 5) arithmtique sur les entiers
 6) calcul boolen
 7) calcul  virgule flottante
 8) dplacement individuel de donnes
 9) dplacement de blocs de donnes
 10) utilisation des pointeurs
 11) contrle du flux d'instruction
 12) utilisation d'objets et protection de la mmoire
 13) interprteur matriel paramtrable
 14) gestion des mmoires cache et virtuelle

III) Architecture matrielle du systme


I) ASPECT EXTERIEUR DU MATERIEL
   Voici divers types de configurations possible :
 - petite calculatrice ouvrable, avec un cran monochrome matriciel d'un
  ct, un clavier de l'autre, que l'on peut placer derrire la machine, avec
  des touches telles que l'on peut utiliser la plupart des fonctions du
  systme sans regarder la ou les mains qui tapent sur le clavier par
  derrire tout en tenant la calculette ; le systme se prsentera sous la
  forme d'une configuration portative personnelle que l'on branche
  ventuellement sur un ordinateur de bureau, par une extension du bus, ou un
  simple cble srie .
 - une tablette au format A4 avec un cran haute rsolution en recouvrant la
  quasi-totalit de la surface, et un stylo optique comme priphrique de
  pointage et d'criture, ou quelque chose qui se met au bout du doigt ;
   le clavier est alors rduit au minimum, avec quelques touches sur le ct :
  des flches comme autre priphrique de pointage, une touche pour mettre le
  systme en veil, quelques touches d'action, et une range d'un ct de
  l'cran, dont la fonction est affiche juste  ct sur l'cran , ainsi que
  des rglettes et des interrupteurs pour rgler le contraste, la luminosit
  d'un ventuel clairage par derrire que l'on pourra alors teindre, le
  contraste des couleurs d'il y en a, la vitesse du systme si elle peut
  varier, et un test de l'alimentation nergtique par une diode lumineuse
  s'allumant  la pression d'un bouton s'il y a assez d'nergie .
 - une carte s'enfichant dans un ordinateur de bureau prxistant : mc, pac,
  atiga, amari, station de travail nun, sext, iec ou dbm, console de jeu
  ninta segendo ou nee goo, ou autre . Alors l'ordinateur en question prendra
  en charge les oprations d'entres sorties, de graphisme et de son (sauf
  peut-tre pour les pc qui ont un son pourri)
 - un simple logiciel pour les ordinateurs dj existant ; alors il faudra
  faire avec les moyens du bord, et la fameuse &@$"#!* compatibilit
  historique .


II) ESQUISSE DU MICROPROCESSEUR SOUHAITE

1) Introduction
  Ces paragraphes tentent de donner une ide des possibilits logicielles
d'un microprocesseur conu pour un systme semblable au systme propos .
  En effet, on ne peut pas concevoir sparment le logiciel du matriel, et
il est plus stupide encore de fabriquer des processeurs trop lents

2) Principes de base
   Le microprocesseur devra disposer d'au moins 32 ( 16  l'extrme rigueur )
 registres gnraux sur 32 bits, spars en registres de donnes et registres
 d'adresses (peut-tre logiciellement,  l'aide d'un registre rserv 
 indiquer si chaque autre est de donnes ou d'adresses), mais autrement
 indiffrencis si possible . Ceci permettrait de grer simultanment de
 nombreuses zones de donnes : deux piles d'adresses, une pile de nombres
 entiers, une pile de nombres  virgule flottante, plusieurs segments de codes
 et de donnes auxiliaires, avec pointeurs sur chaque et protection des
 donnes par accs limits  certaines zones dfinies par borne infrieure et
 longueur, et vrifies automatiquement par le processeur, avec procdures
 d'exceptions paramtrables en cas de dbordement des limites (renvoie la
 donne 0 ou lance un programme spcial  adresse stoque  une place fixe) .
   Le processeur sera sinon  technologie RISC, tout en conservant une
 facilit d'accs  des piles de donnes LIFO (last in, first out) dont les
 pointeurs seraient les registres, et auquelles un accs direct (random) est
 possible en une instruction . Tout ceci permettra une compilation aise et
 pourtant de bonne qualit des programmes du noyau, d'o un gain en vitesse,
 tandis que les processeurs standards issus d'une ligne de compatibilit
 totale se retrouvent avec relativement peu de registres, un jeu
 d'instructions complexe dont il est difficile de tirer parti mme s'ils ne
 sont plus limits par un vieux systme d'exploitation, et des modes
 d'adressages trs divers qui alourdissent l'assemblage et sont mal adapts
 car hrits d'une ligne de processeurs conus selon des principes
 obsoltes.
   Le mouvement, l'inspection, l'initialisation de larges blocs de mmoire au
 bit prs sera gr par une par une partie du processeur de faon optimale.
 Le calcul sur des nombres  virgule flottante et leur transcription de (ou
 vers) la base dix sera gre directement par le processeur, que les
 oprations soient menes matriellement ou logiciellement.
   Enfin et optionnellement, des facilits seront ventuellement conues
 ( ventuellement sur un circuit auxiliaire ) pour aider l'implmentation
 d'un interprteur paramtrable au niveau matriel, un code opration de
 l'interprteur tant directement traduit au niveau des circuits en
 instructions simultanes ou successives pour le processeur . Ces facilits
 permettront ainsi de concevoir plus aisment des interprteurs ou
 semi-compilateurs de langages de tout niveau aux performances accrues, et de
 rcuprer tout logiciel hrit d'une compatibilit historique sans laquelle
 le matriel aurait moins de succs ( On pourra envisager d'implmenter une
 compatibilit MS-DOS, Macintosh, Atari, Amiga, ou avec tout vieux systme
 8,16,ou 16/32 bits ) . Ces facilits, permettant de grer des instructions
 simultanes, pourront aussi tre utilises pour acclrer un traitement
 rptitif des donnes  grande chelle . Dans l'optique d'un systme
 multitche, la reprogrammation de l'interprteur matriel devra tre
 relativement rapide, et l'interprteur lui-mme devra tre assez souple
 pour permettre la simulation de systmes les plus divers .
@
   Voici une tentative d'application de ces principes pour la dcision d'un
 jeu d'instruction .
   Celui-ci se divise en plusieurs grands types d'instruction :
 - arithmtique sur les entiers
 - calcul boolen
 - calcul  virgule flottante
 - dplacement individuel de donnes
 - dplacement de blocs de donnes
 - utilisation des pointeurs
 - contrle du flux d'instruction
 - utilisation d'objets et protection de la mmoire
 - interprteur matriel paramtrable
 - gestion des mmoires cache et virtuelle
@
 * Registres
 - 32 registres de donnes 32 bits numrots de D0  D31
 - 32 registres d'adresses 32 bits numrots de A0  A31 ;
  chaque registre d'adresse est accompagn d'un descripteur
 - 2 registres indiquant quels registres sont effectivement t utiliss,
  parmis les registres prcdents.
 - 1 registre d'tat sur 32 bits pour les calculs not CF
 - 1 registre d'tat sur 32 bits pour le contrle du processeur not PF
 - 1 registre de pointeur d'instruction (adresse sur 32 bits) not PC
 - 2 registres d'adresse de sauvegarde des registres en cas d'interruption :
  l'un pour les interruptions logicielles internes, l'autre pour les
  interruptions matrielles externes.
 - un registre de masque des interuptions matrielles externes.

    Par convention, on utilisera de prfrence les registres D0  D3 pour les
  calculs sur les entiers et les boolens, les registres D4  D7 pour les
  nombres  virgule flottante, les registres D8  D11 (Db) pour les
  compteurs, les registres D12 (Dc)  D15 (Df) pour les variables locales .
    De mme, les registres de A0  A3 serviront de prfrence pour les calculs
  d'adresses, les registres A4  A7 de pointeurs sur des piles de nombres 
  virgule flottante, les registres A8  A11 (Ab) de pointeurs sur des piles de
  donnes quelconques, et les registres A12 (Ac)  A15 (Af) de pointeurs sur
  des piles d'adresses ( notamment la, ou les, piles de d'adresses retour de
  sous-programme )

    Le registre d'tat pour les calculs est organis comme suit :
   F  E  D  C  B  A  9  8  7  6  5  4  3  2  1  0
   -  -  -  -  -  -  -  - SF OF AF UF XF PF ZF CF
   CF: carry flag, drapeau de retenue,  1 s'il y a une retenue
   ZF: zero  flag, drapeau d'galit ,  1 si le dernier rsultat est nul
   PF: parity flag, drapeau de parit,  1 pour un rsultat impair
   XF: extended flag,
   UF: user flag, drapeau  usage laiss  la discrtion de l'utilisateur
   AF: auxiliary flag,
   OF: overflow flag,
   SF: sign  flag,  drapeau
    Le registre de contrle du processeur est organis comme suit :
   F  E  D  C  B  A  9  8  7  6  5  4  3  2  1  0
   Priority -  -  -  -  -  -  -  -  -  -  -  - IF
   IF: interrupt disable flag,  1 pour interdire les interruptions externes
   Priority : c'est le niveau de priorit accord au programme
    (voir protection mmoire).
@
 * Note prliminaire
  On prsentera ainsi les instructions ainsi :
  . <nom>	<mod>
   O <nom> reprsente le nom de l'instruction
 et <mod> les modes d'adressages disponibles pour l'instruction,
 spars si plusieurs sont disponibles par le symbole /
   Voici la liste des symboles utiliss, avec leur signification :
   #  : donne immdiate sur 32 bits
   #n : donne immdiate sur n bits
   Dx : registre de donne de D0  D15
   Ax : registre d'adresse de A0  A15

@
 * Contrle du flux d'instruction
  - Remarque gnrale : dans chacune de ces instructions, on a le choix
  - Sauts inconditionnels
  . BRA		#/Dx
  . JMP		#/Ax
  . RET		Ax
   Explication :
   BRA ajoute au pointeur d'instruction la valeur de l'oprande .
   JMP charge le pointeur d'instruction avec la valeur de l'oprande .
   RET charge le registre PC avec le contenu de l'adresse pointe le registre
  d'adresse Ax spcifi, qui est incrment .
   Note : l'instruction RET peut tre utilise pour xcuter des instructions
  Forth dont les adresses sont crites les unes  la suite des autres, et
  dont le code se termine par un mme RET Ax qui aura pour effet de continuer
  l'xcution du programme  l'instruction pointe suivante ; le registre Ax
  en question servira alors de pointeur d'instruction auxiliaire, ou plutt
  de pointeur sur des pointeurs d'instruction successifs. Cette technique est
  pratique pour produire un code semi-compil efficace.

  - Transfer de la valeur du pointeur d'instruction
  . MOV		Ax,PC
  . PUSH PC,	Ax
   MOV Ax,PC transfre le contenu du registre PC vers le registre Ax .
   PUSH PC,Ax dcrmente le registre Ax et place  l'adresse indique le
  contenu du pointeur d'instruction.
   Ces instructions sont les contraires respectifs des instructions JMP Ax et
  RET Ax .
  - branchements conditionnels
  . DO cc
  . BR cc	#/Dx
  . JMP cc	#/Ax
  - Contrle des interruptions
  . INT #8
  . RETI
  . CRITICAL #4
  . BIT PF,#/Dx
   INT appelle l'interruption dont le numro n est donn en oprande, dont
  l'adresse est stoque au n-ime mot de 32 bits de la mmoire . Avant cela,
  les registres PC et PF sont empils dans cet ordre dans la pile pointe par
  le registre A15 (Af)
   RETI termine une interruption en dpilant les registres PF et PC dans cet
  ordre de la pile pointe par le registre A15 (Af) . Ne peut tre xcut
  que si le drapeau IF est lev ( 1) .
   CRITICAL traite les interruptions ventuellement en suspens, puis les
  bloque totalement pendant l'xcution du nombre d'instructions donn en
  paramtre . Ceci permet de rgler des problmes de conversions de donnes
  en pointeur et vice versa sans risquer d'tre interrompu et d'avoir alors
  un pointeur ne pointant plus o il faut .
   BIT PF, effectue un ET logique du registre PF avec les 16 bits hauts de
  l'oprande
  -
@
 * arithmtique sur les entiers (et les pointeurs)
 . ADD	Ax/Dx , Dy/#/#5
 . ADC  Ax/Dx , Dy/#/#5
 . SUB  Ax/Dx , Dy/#5
 . SBC  Ax/Dx , Dy/#5
 . CMP	Dx , Dy/#/#5
 . CMPP Ax , Ay/#/#5
 . SUBP Dx , Ay , Az
 . MUL  Dx , Dy/#
 . MULS Dx , Dy/#
 . DIV  Dx , Dy/#
 . DIVS Dx , Dy/#
 . NEG	Dx
   De plus les instructions de calcul sur pile suivantes sont disponibles
  I+ I- I* IS* I IS INEG
@
 * calcul boolen
 . AND	Dx , Dy/#/#5    (symbole d'intersection  (#239) )
 . OR	Dx , Dy/#/#5	(symbole d'union U )
 . XOR  Dx , Dy/#/#5
 . ROL	Dx , Dy/#5
 . ROR	Dx , Dy/#5
 . RXL	Dx , Dy/#5
 . RXR	Dx , Dy/#5
 . SHR	Dx , Dy/#5
 . SHL	Dx , Dy/#5
 . SAL	Dx , Dy/#5
 . GET	Dx,Dy,#
 . PUT	Dx,Dy,#
@
 * dplacement individuel de donnes
 . MOV	Dx , Dy/#/(Ay++)/(Ay+#5)
 . MOV  Ax , Ay/#/(Ay++)/(Ay+#5)
 . MOV  (--Ax)/(Ax+#5) , Dy/Ay/#/(Ay++)
 . XCHG Dx , Dy
 . XCHG Ax , Ay
 . XCHG (Ax+#5),(Ay)
 . MOV  (--Ax),
@
 * calcul  virgule flottante
 .
@
 * dplacement de blocs de donnes
@
 * Protection de la mmoire

  Niveaux de privilges
 - 0 : Seule la ROM a ce privilge . Elle contrle tout, a accs  tous les
  registres, toute la mmoire, tous les ports d'entre/sortie .
 - 1 : Le systme a ce privilge . Il peut alors tout faire, dans la limite
  du contrle exerc par la ROM, qui surveille ses allocations de bornes
  pour les pointeurs .
 - 2 : on ne peut plus modifier les bornes des pointeurs, accder aux
  registres protgs ...
 - 3 :
 - 4 :
 - 5 : seules les oprations de calcul sont permises, et les appels au
  systme ; on ne peut pas accder aux objets points autrement que
  par les routines dfinies dans le descripteur .
 - 6 : les instructions de contrle du flux sont interdites ; seul un appel
  systme peut permettre une chose similaire .
 - 7 : c'est le mode d'xcution pas--pas, o toutes les instructions sont
  interdites et engendrent une interruption .

  Zones amies :
  Un objet peut tre plus ou moins amie d'un autre.
@
(* interprteur matriel paramtrable )
@
(* gestion des mmoires cache et virtuelle )



  Systme bi-tche : deux tches peuvent tourner simultanment, ce qui permet
d'avoir une pipeline alterne, donc de rduire ses bulles, d'utiliser les
possibilits de calcul au mieux, une tche servant traditionnellement  
vrifier que l'autre ne fait rien d'interdit ; ce genre de vrifications ne
ncessite en gnral qu'affectations, additions, comparaisons ; aussi, le
processeur peut  la fois faire ses calculs et effectuer ces oprations 
simples dans le mme cycle. A fin que cet avantage soit efficace, le 
doublement du bus d'instruction (il y a plusieurs mmoires caches internes
d'instructions) permettra d'viter en gnral les accs simultanes  la
mmoire.





III) ARCHITECTURE ELECTRONIQUE DU SYSTEME
  Le systme doit tenir sur une carte lectronique la plus petite possible,
dans l'intention de faire tenir des versions du systme dans des boitiers de
la taille d'une calculatrice . Si dans de tels boitiers ne peuvent tenir
tous les composants lectroniques du systme complet, il doit tre possible
de remplacer les composants manquants en les simulant logiciellement, ou en
tout cas pouvoir utiliser des programmes y faisant appel en interceptant ces
appels et les liminant ou les traitant d'une manire ou d'une autre.
  Toujours est-il que la technologie des puces est telle qu'il restera de la
place sur la puce du microprocesseur et qu'on y pourra placer plusieurs tels
processeurs avec un systme de communication, ou bien une partie de la
gestion des fonctions d'entres-sortie ou de mmoire prsente indpendamment
du systme utilis ( horloge interne, horloge permanente, gestion de la
mmoire virtuelle, gestion des interruptions logicielles, rafraichissement de
la mmoire dynamique, contrle de bus partag, communication en srie ...) ,
ou bien directement une partie de la mmoire centrale, alors trs rapide
d'accs, et tant configurable par parties en mmoire cache pour les donnes
extrieures  la puce, ou un savant mlange .
  D'autres puces feront le reste du travail, ainsi que la gestion du ou
des supports de mmoire de masse et de communication avec d'autres systme
lectroniques (interfaces sries et parallle, avec possibilit de connection
 un rseau local et  un rseau MIDI), avec un clavier, des priphriques de
pointages divers (souris, manches  balai, crayons optiques, tables traantes
et autres boules), un cran plat et/ou un moniteur, sans compter des
processeurs spcialiss pour traiter les graphismes et le son .




@@------------------------------ APPENDICE B ---------------------------------
-------------------- LISTE DES CLASSES D'OBJETS DU SYSTEME -------------------
( voir feuille de graphe d'hritage )
@
** CLASSES DE DONNEES DE BASE
Objet
 Macro-dfinition
 Dfinition
  Classe
   Classe de classes
   Classe de pointeurs
   Magma
    Monode (semi-groupe)
     Groupe
      Anneau	-> Entier illimit
       Corps
 Squence virtuelle
  Liste chane virtuelle





 * Pointeur virtuel

 * Squence virtuelle
 Nom:
 squence virtuelle 	(articles: dfini=une,des indfini=la,les,
			 pluriel: s aux deux mots)
 Nature:
 Procdures virtuelles:
 objet suivant : renvoie un pointeur virtuel sur un objet
 objet prcdent :

 * Liste chane virtuelle
 * Tas d'objets

** CLASSES DU NOYAU
** CLASSES DU COMPILATEUR
** CLASSES DE L'ENVIRONNEMENT
** CLASSES DES ACCESSOIRES
** CLASSES DES APPLICATIONS



*/
/*
 Pour voluer dans le texte, chercher :
 @@   pour aller au chaptre suivant,
 **  pour aller  la partie suivante du chaptre .
 @  pour aller au paragraphe suivant .
*/

