(***************************************************************************
                 Ebauche pratique de gestionnaire d'vnements
***************************************************************************)


(************************ Description du fichier **************************)
(*
 Liste des classes,constantes,procedures,etc

 Constantes:
  _NmMaxPeriph		nombre maximum de priphriques utilisables par un
			seul gestionnaire

 Classes:
 I) Algorithmique gnrale
  VListe -> Liste
    PointeurDeListe
  (( LListe ))

 II) Gestion de priphriques
  Tache
  GestionnaireDEvenements
    Evenement
    Peripherique
      Guetteur

 Procedures et fonctions: (ordonnes par classes)
  *GestionnaireDEvenements

*)

(********************* Dclarations prliminaires *************************)

{Uses Listes ;}
Type PointeurDeListe = Word ;	{ OSL classe en paramtre de la mtaclasse Liste }
Type VListe =
       Object
	AccesDirectQ : boolean ;
	Taille,P : PointeurDeListe ;
	Function FinDeListe  ( index : PointeurDeListe ) : boolean ;virtual ;
	Function ElementAddr ( index : PointeurDeListe ) : pointer ;virtual ;
       end ;

(********************* Dclaration des constantes *************************)

Const
 _NmMaxPeriph = 32 ;
 MultiTache   = False ;


(************************* Dclaration des types **************************)

Type
 Tache = Object
         Main : procedure ;
         Data : pointer ;
        End ;

 Peripherique =
  Object
   {***** champs de donnes ****}
    Teste : Tache ;
    Tampon : Liste ;			{ OSL : Liste d'vnements }
    Guetteurs : Liste ;			{ OSL : La Liste de Guetteurs }
     DejaGuette : PointeurDeListe ;
   {********** mthodes ********}
    Constructor Init ( _Teste : Tache ) ;
    Procedure GuetteTout ;
    Procedure Guette ( var E : Evenement ) ;
  end ;

 Guetteur =
  Object
   {***** champs de donnes ****}
    Guette : Tache ;
   {********** mthodes ********}
  end ;

 GestionnaireDEvenements =
  Object
   {***** champs de donnes ****}
    periph		: Liste ;		{ OSL : Liste of Periph' }
   {********** mthodes ********}
    Procedure	BoucleMonoTache (Condition:boolean) ;
    Procedure	Empile ( ListeDeGuetteurs : Liste ) ;
    Procedure   Depile ( ListeDeGuetteurs : Liste ) ;
  end ;

(********************** Mthodes de Peripherique **************************)

constructor Peripherique.Init ( _Teste : Tache ) ;
 Begin
  Teste := _Teste ;
 End ;

Procedure Peripherique.GuetteTout ;
 Var
  p : PointeurDeListe ;
 Begin
  With Guetteurs do begin
    While not FinDeListe ( DejaGuette ) do begin
      Guette ( ElementAddr(DejaGuette)^ ) ;
      inc (DejaGuette) ;
     end ;
   end ;
 End ;

Procedure Peripherique.Guette ( ;
 Var
  p : PointeurDeListe ;
 Begin
  With Guetteurs do begin
    While not FinDeListe ( DejaGuette ) do begin
      repeat
       Guette ( Element(DejaGuette) ) ;
     end ;
   end ;
 End ;

(************************ Mthodes de Guetteur ****************************)




(**************** Mthodes de Gestionnaire d'vnements *******************)

Var
  GestionnaireActuel : ^GestionnaireDEvenements ;

Procedure	GestionnaireDEvenements.BoucleMonoTache ;
 Var
  i : word ;
  G : ^Guetteur :
 Begin
   repeat
   For i := 1 to _NmMaxPeriph do with periph[i] do begin
     Teste ;
     GuetteTout ;
    end ;
  until false ;
 End ;

Procedure	GestionnaireDEvenements.Empile ( ListeDeGuetteurs : Liste ) ;
 Var
 Begin
 End ;

Procedure	GestionnaireDEvenements.Depile ( ListeDeGuetteurs : Liste ) ;
 Var
 Begin
 End ;


(***************** dfinition d'un priphrique clavier *******************)

{$IFDEF exemples}

Var
 Clavier0 : peripherique ;


Procedure Clavier0Test ;
 Begin
  if keypressed then
    Clavier0.Declare ( _Entree_, readkey ) ;
 End ;

Begin
 Clavier0.Init ( Clavier0Test ) ;
End ;


{$ENDIF}



